[Sep 17 2009]

 * FIXED: XPCE: possible crash rendering wide-character strings.

[Aug 18 2009]

 * CLEANUP: Bug#413: Complete 'make distclean'.  Feliks Kluzniak

[Aug 17 2009]

 * FIXED: Deal with XPCE in saved states.  Jeffrey Rosenwald.

[Aug 17 2009]

 * FIXED: PceEmacs %% --> % % when filling comments.

 * FIXED: PceEmacs syntax highlighting inside XPCE methods while typing.

[Aug 16 2009]

 * ENHANCED: PceEmacs: show syntax errors using a small orange block.

 * ENHANCED: PceEmacs: base Prolog comment-colouring on actual parsing
   rather then the emacs-buffer syntax-rules.

[Aug 10 2009]

 * FIXED: Force reloading the autoload index in pl.rc (linking XPCE).

[Aug 2 2009]

 * FIXED: Buffer overflow in XPCE's int_item on 64-bit machines.

[Jul 21 2009]

 * MODIFIED: Make initialization/1 ISO compliant
   This patch is a modest cleanup to the implementation of '$load_file'/3
   from init.pl and provides an ISO compatible implementation of
   initialization/1. This executes the argument goal *after* loading the
   file rather than when encountering the directive. Often this makes no
   difference, but notably load_foreign_library/1 is an exception.
   Therefore we added use_foreign_library/1,2 that act as a directive and
   provides proper integration with saved-states automatically.  Loading
   code using initialization(load_foreign_library(...)) will load the
   library immediately and issue a warning.

   See initialization/1,2 for details and further hints for dealing with
   possible compatibility problems.

[Jul 18 2009]

 * CLEANUP: Extended .gitignore files

[Jul 7 2009]

 * BUILD: Refuse to build XPCE without the freetype libraries.  Give informative message if libXft cannot be found.

[Jul 6 2009]

 * ADDED: Application->leader to support ICCCM window groups
[Jun 29 2009]

 * BUILD: Enhance message if -lXpm is not found.  Dennis van Dok.

[Jun 15 2009]

 * SECURITY: Loading XPCE can cause an insecure library search path.  ELF-systems only.  Keri Harris.

[Mar 19 2009]

 * CLEANUP: Removed all trailing whitespace from all source-files.  This avoids many GIT (merge) warnings.

 * ADDED: PceEmacs automatically removes trailing whitespace from lines. The feature is controlled by the resource
   	emacs_buffer.ensure_no_whitespace_errors: true
[Mar 12 2009]

 * MODIFIED: Renamed concat_atom/2,3 into atomic_list_concat/2,3 for compatibility.  Moved the old predicates into library(backcomp).  It is adviced to update your code, but 99% of the code will remain working because the old definitions are autoloaded.

[Jan 30 2009]

 * FIXED: PceEmacs colouring of module:head --> body clauses.

[Jan 26 2009]

 * PORT: Build properly working XPCE if xinerama is missing
[Jan 22 2009]

 * FIXED: Tracer handling of redo port.

 * EHANCED: Avoid that the gui-tracer ever reverts to the normal tracer by
   adding a catch-all rule.  Especially avoids deadlocks when tracing threads
   that cannot interact with the toplevel.

 * CLEANUP: Avoid pce_global failure messages to use the general goal_failed/1
   term.

[Jan 20 2009]

 * ENHANCED: Avoid crash if XPCE cannot even find its default font
[Jan 7 2009]

 * MODIFIED: Removed current_module/2 and export_list/2 and introduced
   module_property/2. The removed predicates have been moved to the
   backcomp.pl library and are thus autoloaded, providing compatibility.

[Jan 2 2009]

 * CLEANUP: Make XPCE work with new meta_predicate declarations

 * MODIFIED: Removed high-arity meta declarations for XPCE's get/N, send/N and
   get_object/N.  Note that this only limits these predicates for meta-calling
   because normally compiled versions are expanded by means of goal_expansion/2.

[Dec 28 2008]

 * ADDED: PceEmacs: realise a backup encoding for saving files as Unicode if the normal encoding cannot represent the content of the buffer.

 * FIXED: XPCE: text_buffer->save failed to report representation errors.

[Dec 5 2008]

 * FIXED: Bug#384: Memory leak in XPCE conversion of Prolog objects to text.  Keri Harris

[Nov 17 2008]

 * BUILD: Make distclean removes h-link in xpce
[Sep 29 2008]

 * BUILD: Bug#381: more parallel build issues.  Keri Harris.

[Sep 27 2008]

 * BUILD: Parallel build patches by Keri Harris.

[Sep 11 2008]

 * PORT: Add AC_PREREQ to configure.h for systems that auto-select autoconf
   versions.  After tip by Ulrich Neumerkel.

[Aug 11 2008]

 * BUILD: XPCE: deleted generated h/names.[ic] files and replace the scripts
   by a plain C program to build these files.

 * INSTALL: Remove all configure files from the git repository

[Aug 5 2008]

 * MODIFIED: Now uses PceEmacs as default editor if XPCE can be enabled
[Jul 16 2008]

 * PORT: Properly include curses.h and term.h in pl-term.c.  Does this need to
   be conditional?

[Jul 7 2008]

 * ADDED: Prolog navigator listens to prolog_file_type/2.  Jean-Marc Vanel.

 * FIXED: Navigator failed to open on files with only directives.

[Jun 19 2008]

 * ADDED: Provide support for printing attributes in the GUI tracer

[Jun 17 2008]

 * ADDED: access to thread profiler from thread monitor

 * ADDED: Thread monitor: status icon now indicates CPU usage.

 * FIXED: Bug#363: Text->margin: @nil leaving object base inconsistent.  Tom Conlon.

[Jun 16 2008]

 * FIXED: Several issues around tprofile, making it much more robust

[May 21 2008]

 * PORT: Bug#357: Updated config.{guess,sub}, needed for development version of FC.
   Mary Ellen Foster.

[May 14 2008]

 * FIXED: Bug#355: XPCE: warnings on undefined method frame->post_event.   Andreas Steiner.

[May 13 2008]

 * FIXED: Make index of MANUAL line-based, so we no longer depend on Windows CR/LF
   mapping.  Jorge Cabrera.
[May 5 2008]

 * FIXED: Make PceEmacs mode selection sensitive to prolog_file_type/2.

[Apr 28 2008]

 * PORT: Make some scripts for building the manuals not depend on the perl path.
   Jacco van Ossenbruggen.

[Apr 25 2008]

 * ENHANCED: PceEmacs: show location of import

[Apr 23 2008]

 * ENHANCED: GUI tracer: expose variable details window

[Apr 21 2008]

 * ENHANCED: PceEmacs: show location of autoload (as well as documentation)

[Apr 14 2008]

 * CLEANUP: Remove calls to sformat from system libraries (backward compatibility)

[Mar 31 2008]

 * FIXED: Undefined predicate in PceEmacs

[Mar 28 2008]

 * FIXED: PceEmacs colouring of module qualified meta-arguments

 * FIXED: xpce named colour demo search for name database in /usr/share/X11

[Mar 27 2008]

 * MODIFIED: XPCE class editor logic for forward/backward paragraphs

[Feb 26 2008]

 * ENHANCED: Raise PceEmacs bookmark window on `Show bookmarks'

[Feb 22 2008]

 * FIXED: Avoid unknown class: yes messages if graphical tracer is active.

 * FIXED: Bug#351: Loading XPCE objects containing 24bpp images.  Tom Conlon.

[Jan 26 2008]

 * ADDED: Import-except, import under a new name and reexport

[Jan 23 2008]

 * FIXED: `editor->paste' to check whether the editor is `editable'.  Matt Lilley.

[Jan 14 2008]

 * PORT: Bug#339: name conflict in AIX

 * FIXED: Bug#336: parbox->cdata to handle Unicode data.  Dmitry.

[Dec 12 2007]

 * FIXED: area->overlap now fails on adjacent areas.  Maurizio Ferreira

[Dec 11 2007]

 * ADDED: Make PceEmacs use PlDoc for the Documentation link if the old manual
   has no information.  Integration must be improved!

[Nov 15 2007]

 * ADDED: library(apply) with include/3, exclude/3, partition/5.
   Moved sublist/3 from built-in to library(backcomp).  Added library apply
   to the manual.

[Nov 12 2007]

 * ADDED: PceEmacs: ->insert_file_header expands %E to E-mail address

 * INSTALL: Bug#319: Allow for parallel make install.  Keri Harris


VERSION 6.6.44, distributed with SWI-Prolog 5.6.44
==================================================

* ADDED: Support posix/dos newline detection in PceEmacs.  Preserves
  file mode over load/save.

* FIXED: Pass Prolog exceptions on send(@prolog, ...).  Alexandre Vautier.

VERSION 6.6.43, distributed with SWI-Prolog 5.6.43
==================================================

* MODIFIED: Use new portability flags.

* UPDATED: About dialog.

VERSION 6.6.40, distributed with SWI-Prolog 5.6.40
==================================================

* FIXED: Possible crash in graphical->layout.  Anjo Anjewierden.

VERSION 6.6.39, distributed with SWI-Prolog 5.6.39
==================================================

* ADDED: @pce<->application_data to reflect the directory for storing
  user application settings.

VERSION 6.6.37, distributed with SWI-Prolog 5.6.37
==================================================

* FIXED: Bug#294: PceEmacs colouring of pce_image_directory arg.

* FIXED: Bug#290: text<-postscript ignores <-wrap: wrap_fixed_width.
  Tom Conlon.

VERSION 6.6.36, distributed with SWI-Prolog 5.6.36
==================================================

* FIXED: Possible 1 point to small boundingbox when writing (scaled)
  postscript.  Bert Bredeweg.

VERSION 6.6.35, distributed with SWI-Prolog 5.6.35
==================================================

* FIXED: Bug#285: image<-postscript.  Dmitry.

* FIXED: editor->newline if the text-buffer is in wide-character mode
  on big-endian machines (Mac PPC).

* FIXED: Bug#281: Error in class tabular.   Bruno Martinez,

* FIXED: Failing double-click detection due to too short datatype.

VERSION 6.6.34, distributed with SWI-Prolog 5.6.34
==================================================

* PORT: Work-around for version problems in Xft libraries.

VERSION 6.6.32, distributed with SWI-Prolog 5.6.32
==================================================

* ADDED: Edit breakpoints and define how they are handled in the debugger.

* ENHANCED: some issues in table-layout.

VERSION 6.6.30, distributed with SWI-Prolog 5.6.30
==================================================

* FIXED: Bug#265: socket(tuple(host, 0).  Sebastian Steenbuck.

* PORT: Prefer pkg-config over xft-config for finding XFT.  Needed on
  Redhat Linux FC6.  With help from Jacco van Ossenbruggen.

VERSION 6.6.29, distributed with SWI-Prolog 5.6.29
==================================================

* FIXED: PceEmacs: variable-marking inside brace-terms.

VERSION 6.6.27, distributed with SWI-Prolog 5.6.27
==================================================

* PORT: More patches for the Win64 port.

VERSION 6.6.26, distributed with SWI-Prolog 5.6.26
==================================================

* PORT: Many changes for Win64 port (running experimentally).

* FIXED: Store/load real objects to/from file for 64-bit platforms.  Various
  other issues with real objects on 64-bit systems.

VERSION 6.6.25, distributed with SWI-Prolog 5.6.25
==================================================

* MODIFIED: Moved library(broadcast) to general SWI-Prolog library.  Should
  not affect code that load this library on demand or using the recommended
  :- use_module(liberary(broadcast)).

VERSION 6.6.24, distributed with SWI-Prolog 5.6.24
==================================================

* FIXED: Bug in srcsink<-contents, showing up after 64-bit fix below.

* FIXED: 64-bit issue in XPCE stream class (also affecting socket and
  process).

VERSION 6.6.23, distributed with SWI-Prolog 5.6.23
==================================================

* PORT: Include LDFLAGS making xpce-client.

* FIXED: Class textbuffer: crash in Windows on <-scan.  Jacco van Ossenbruggen.

* FIXED: PceEmacs: Avoid loading DDE interface on Unix.

VERSION 6.6.21, distributed with SWI-Prolog 5.6.21
==================================================

* PORT: Bug#214: Compatibility to new FreeType #include standards.
  Darren Bane.

* PORT: Bug#212: parallel make.  Keri Harris.

VERSION 6.6.19, distributed with SWI-Prolog 5.6.19
==================================================

* FIXED: Class editor: possible division-by-zero filling a line.

VERSION 6.6.18, distributed with SWI-Prolog 5.6.18
==================================================

* ADDED: Allow for spaces in #include file of defaults.  Tom Conlon.

* FIXED: Crash in window placement if a new window is created from an
  event that first destroys the window from which it originated.
  Jochem Liem.

VERSION 6.6.17, distributed with SWI-Prolog 5.6.17
==================================================

* FIXED: Colours of arrow-heads in PostScript generation.  Anders Bouwer.

VERSION 6.6.16, distributed with SWI-Prolog 5.6.16
==================================================

* FIXED: Crash when accessing files with illegal multi-byte sequences in the
  name (Unix version only).

VERSION 6.6.15, distributed with SWI-Prolog 5.6.15
==================================================

* FIXED: PceEmacs: Backspace in incremental search.

VERSION 6.6.14, distributed with SWI-Prolog 5.6.14
==================================================

* FIXED: compatibility problem in saved text_buffer objects between version
  5.4.7 and 5.6.13.  Tom Conlon.  There is still an issue.  While providing
  Unicode support the save format was changed, but the version was not
  incremented.  Unfortunately there is no other way to distinguish the old
  format from the new.  Therefore, 6.6.14 can read files produced by itself
  and pre-unicode versions, but not produced by unicode versions < 6.6.14.
  Files containing only ASCII characters (<128) are compatible.


VERSION 6.6.12, distributed with SWI-Prolog 5.6.12
==================================================

* ENHANCED: `text_buffer->for_all_fragments' to avoid use of alloca() for
  large number of arguments.  Patchwork for problems in Windows with limited
  stack-sizes.  Pierpaolo Bernardi.


VERSION 6.6.11, distributed with SWI-Prolog 5.6.11
==================================================

* FIXED: Bug#82: various issues in gemetry management.

* MODIFIED: PceEmacs/editor: ->delete_blank_lines (^X^O) is now GNU-Emacs
  compatible.  Pierpaolo Bernardi.

* FIXED: PceEmacs: C-hk (describe-key) using \C-c or \C-x prefix keys.
  Pierpaolo Bernardi.

* FIXED: library(tabular): avoid sending ->margin to objects with a
  different interpretation.

* FIXED: PceEmacs: Preserve kill-location over marking variables.
  Also fixed repeating undo using ^Xu.  Pierpaolo Bernardi.

VERSION 6.6.10, distributed with SWI-Prolog 5.6.10
==================================================

* FIXED: Use current monitor for placement rather than display as a whole.

* ADDED: `display<-pointer_location'.

* FIXED: X11 version: frame->gemetry offset for open windows.

* ADDED: @monitor to frame->geometry specification.  Also added an extra
  monitor argument to most of the frame dimension methods.  Work in progress
  supporting multiple monitors.

* ADDED: Query available physical monitors.  See class monitor.  Added
  monitor argument to frame->center, frame->open_centered, etc. This
  fixes Bug#82.  Holger Kanwischer.

* FIXED: regex->match on backward matches (executed as search).

* FIXED: PceEmacs: failing bracket highlighting on syntax errors.  Enhanced
  ->beginning_of_clause to be more careful with in-clause comments.  Fixed
  ->backward_clause on directives.


VERSION 6.6.9, distributed with SWI-Prolog 5.6.9
================================================

* FIXED: device->event to be safe against events changing the displayed
  graphicals.

* ADDED: PceEmacs colour support for the http/html_write library.

* ADDED: pce_xref/0: graphical frontend to the cross-referencer.  Many
  enhancements to the cross-referencer itself and its interaction with the
  other libraries.

* FIXED: PceEmacs: colouring lists as a goal (consult).

* ENHANCED: library(pce_toc).  Allow hooking collapse of a node.  See
  ->collapse_node.

VERSION 6.6.8, distributed with SWI-Prolog 5.6.8
================================================

* FIXED: PceEmacs: caret positioning issues on syntax errors in Prolog
  mode.

* ADDED: display->x11_threads.  Provides a work-around for MacOS X11
  problems.

VERSION 6.6.7, distributed with SWI-Prolog 5.6.7
================================================

* FIXED: Do not initialize XLib threads on MacOS to avoid a deadlock entering
  certain keys.  Reported several times.

* ADDED: Allow binding different X11 modifiers to the Meta Key.
  See display->meta_modifier.  By default bind Meta to the Mac command-key.


VERSION 6.6.6, distributed with SWI-Prolog 5.6.6
================================================

* FIXED: Bug#146: Unicode handling of window->drop_files.  Dmitry.


VERSION 6.6.4, distributed with SWI-Prolog 5.6.4
================================================

* FIXED: offset issue in win_printer.  Tom Conlon.

* FIXED: DCG for manual operations.

* ENHANCED: Operator handling in PceEmacs Prolog mode.


VERSION 6.6.3, distributed with SWI-Prolog 5.6.3
================================================

* ENHANCED: PceEmacs colouring: more aggressive colouring of the current
  clause.

* ADDED: Bug#136: actually use directory argument in display<-win_directory.
  Holger Kanwischer.


VERSION 6.6.1, distributed with SWI-Prolog 5.6.1
================================================

* COMPAT: changed library(find_file) to confirm on overwrite on both the
  private file prompter and the Windows one.  Jelmer Jellema.

VERSION 6.6.0, distributed with SWI-Prolog 5.6.0
================================================

VERSION 6.5.39, distributed with SWI-Prolog 5.5.39
==================================================

* ADDED: pce_prolog_xref.pl: process terms in :- include directives.

* MODIFIED: `graphical->request_compute: Val' invokes ->compute if the
  already registered compute request has a different value.  This generally
  should fix applications using this feature, but it may cause loops in
  computation.

VERSION 6.5.38, distributed with SWI-Prolog 5.5.38
==================================================

* PORT: Windows: Work around MSVC6 bug in `string->insert_character'.
  Jelmer Jellema.

* ADDED: Emacs buffer menu: kill selected buffer on DEL and backspace keys.

* ENHANCED: cleanup ENC_WCHAR issues.  Use new encoding API to protect
  from unsolicitated changes in the encoding of text-strings.

* FIXED: Encoding issue with pce_open/3 on stream objects (crashes
  XPCE httpd).  Anjo Anjewierden.

VERSION 6.5.37, distributed with SWI-Prolog 5.5.37
==================================================

* FIXED: Bug#117: new(X, 9).  Dmitry.

* FIXED: Bug#108: Unicode support in the classes type, class and method
  to allow for unicode names in programming.  New code also fixes
  potential buffer overruns caused by invalid programs.  Dmitry.

* FIXED: Bug in class name that can cause identity problems with names
  that have used wide-character representations as intermediate.

* FIXED: Bug#111: @pce->write and friends to deal with Unicode arguments.
  Dmitry.

VERSION 6.5.36, distributed with SWI-Prolog 5.5.36
==================================================

* FIXED: Various 64-bit compiler warnings.  One of them caused
  `graphical->layout' to do the layout in the area (0,0,0,0).
  Another causes a crash in class spatial.  Anders Bouwer.

VERSION 6.5.35, distributed with SWI-Prolog 5.5.35
==================================================

* ADDED: display_manager<-window_of_last_event

VERSION 6.5.34, distributed with SWI-Prolog 5.5.34
==================================================

* PORT: Cleanup for GCC 4.0

* ADDED: Start of interface to add classes from C at runtime.

VERSION 6.5.33, distributed with SWI-Prolog 5.5.33
==================================================

* FIXED: Win32: display<-win_file_name: honour default directory.
  Jelmer Jellema.

* ADDED: head/body argument do `_draw_post_script'.  Jelmer Jellema.

* ADDED: library(swi/pce_debug_monitor).

* FIXED: avoid warning on M-q in Prolog mode (->indent_clause).

VERSION 6.5.31, distributed with SWI-Prolog 5.5.31
==================================================

VERSION 6.5.30, distributed with SWI-Prolog 5.5.30
==================================================

* ADDED: library(print_graphics), method ->save_postscript

VERSION 6.5.29, distributed with SWI-Prolog 5.5.29
==================================================

* FIXED: `unclip window' recursive event processing (leaving empty `unclip'
  windows behind.

* FIXED: Windows: draw bitmap objects on printer and metafile.

* FIXED: Bug#87: conversion of wide-string to source_location object.
  Dmitry.

* ADDED: Partial support for creating proper PostScript from masked
  colour images (often used as icons).

* FIXED: crash in `graphical<-postscript' for graphicals with zero width
  and/or height (sometimes used to fill space).


VERSION 6.5.28, distributed with SWI-Prolog 5.5.28
==================================================

* FIXED: Bug#85: conversion of unicode SWI-Prolog string objects to
  XPCE strings.  Dmitry.

* FIXED: Bug#81: dynamically deal with dropshadow setting for popup frames
  to avoid crash on windows versions older than XP. Holger Kanwischer.

* ADDED: Bug#79: `frame->icon' also sets the Windows `big' icon.
  Holger Kanwischer.


VERSION 6.5.27, distributed with SWI-Prolog 5.5.27
==================================================

* FIXED: `menu->selection' for single-selection menus sometimes wasn't
  honoured.

* FIXED: PceEmacs: colourising of use_module directives pointing to
  non-existing files.

* FIXED: `file->kind'.   Petter Egesund.

VERSION 6.5.26, distributed with SWI-Prolog 5.5.26
==================================================

* Consistent numbering (SuSE 10.0 beta2)

VERSION 6.5.24, distributed with SWI-Prolog 5.5.24
==================================================

* FIXED: Text clipping in X11 systems using the Xft text rendering library.

* FIXED: Remove code calling XSetInputFocus() if a window gets the focus
  while it has a modal trainsient window.  This could cause BadMatch
  errors, killing XPCE.  In theory the window manager should do this
  properly anyway.


VERSION 6.5.23, distributed with SWI-Prolog 5.5.23
==================================================

* ADDED: display<-win_directory to exploit the standard Windows Shell
  directory dialog.

* ENHANCED: Win32: update GetSysColor() defined colours (name win_*).
  Steve Moyle.

* FIXED: pcePP() to return UTF-8 encoded strings if there is Unicode data
  in it.

* FIXED: prolog_term<-print_name (encoding issue).


VERSION 6.5.21, distributed with SWI-Prolog 5.5.21
==================================================

* FIXED: Bug#66: filename handling for names holding extended ISO Latin 1
  (128..256) characters.  Jiri Spitz.

* ADDED: Allow (re-)definition of ->_draw_postscript from Prolog.  See
  documentation in `graphical->_draw_postscript'.

* FIXED: handling arrows on class arc.  MPWH.

* FIXED: Bug#62: define class whose name is already used as a type causes
  a crash.  Holger Kanwischer.


VERSION 6.5.20, distributed with SWI-Prolog 5.5.20
==================================================

* FIXED: Flickering pullright when dragging over pullright arrow.
  Jochem Liem.

* FIXED: Open pullright if there is no message on an item and the button
  is released.  Jochem Liem.

* FIXED: Unicode support in Windows metafile filename and comment handling.

* FIXED: Bug#48: Error handling in date->advance.  Dmitry.

* FIXED: Bug#57: menu<-modified.  Holger Kanwischer.

* FIXED: Bug#52: file->backup when using national characters.  Jiri Spitz.


VERSION 6.5.19, distributed with SWI-Prolog 5.5.19
==================================================

* ADDED: Working on XIM support.  Current primitive version deals with
  dead-keys and with wide characters in a portable manner.


VERSION 6.5.18, distributed with SWI-Prolog 5.5.18
==================================================

* FIXED:  (At  least  partly):  use   UTF-8  in  decoding  output  from
  XLookupString() to deal with international keyboard input.  See
  src/x11/xcommon.c for details.

* FIXED: Bug#46: Support unicode in display->{inform,confirm}.  Dmitry.


VERSION 6.5.17, distributed with SWI-Prolog 5.5.17
==================================================

* FIXED: Bug#41: memory allocation error using Prolog terms in XPCE.
  Dmitry.

* FIXED: Bug#40: Wrong calculation of character dimensions on non-fixed
  width Unicode characters.  Dmitry.

* FIXED: Bug#39: cannot paint selected text with UNICODE characters.
  Dmitry.

* FIXED: tracing dynamic clauses holding strings.  Steve Moyle.

* FIXED: PceEmacs colouring: removed load_files/1 spec (error).  Cross
  referencer: deal properly with meta predicates with unknown goal.


VERSION 6.5.16, distributed with SWI-Prolog 5.5.16
==================================================

* FIXED: Bug#36: text->insert_self for characters > 255.  Dmitry.

* FIXED: Bug#33: editor->typed.  By default bind unicode characters to
  ->insert_self.  Dmitry.

* FIXED: char_array<-append: support wide characters.


VERSION 6.5.15, distributed with SWI-Prolog 5.5.15
==================================================

* PORT: Fixed visibility attribute issues on IA64.  These problems may
  have affected more GCC/ELF platforms.  With help from Stefan Dirsch.

* FIXED: XPCE httpd regex for breaking the header.

* FIXED: regex definitions is ispell demo (also used by PceEmacs
  M-x ispell).

* PORT: Some of the GCC 4.0 issues: handling names, visibility attribute,
  illegal lvalues in DND interface. Work with Stefan Dirsch from SuSE
  preparing for the next SuSE release.


VERSION 6.5.14, distributed with SWI-Prolog 5.5.14
==================================================

* ADDED: allow for rules for the multifile predicate
  emacs_prolog_colours:style/2 to define personal colour preference.
  Steve Moyle.


VERSION 6.5.13, distributed with SWI-Prolog 5.5.13
==================================================

* PORT: remove regex debugging code, as it fails to compile on some
  systems.

* MODIFIED: changed operators after discussion with Paulo Moura about
  a conflict with @.  I think these values are more in line with the
  ISO table.

	op(100, fx, @)	--> op(200, fy, @).
	op(150, yfx, ?) --> op(250, yfx, ?).

* ADDED: PceEmacs: report encoding in ->properties and allow changing
  using M-x encoding.

* ADDED: Support for BOM.  See class file and SWI-Prolog manual.

* MODIFIED: Replaced the underlying regular expression library from
  GNU-regex to Henry Spencers regex implementation with the Tcl added
  support for UNICODE.  Support for regular expressions is now a lot
  more powerful, but unfortunately SERIOUSLY INCOMPATIBLE.  There is
  a program in library(pce_regex_compat) that can convert regular
  expressions embedded in sourcefiles.  This is not perfect, sometimes
  regular expressions are created on the fly and sometimes the script
  may modify an atom that is not a regular expression.  It did at least
  95% of the job for PceEmacs and the rest of the XPCE libraries though.

* ADDED: UNICODE support for ->save_in_file on names and strings.

* ADDED: UNICODE support for class text_buffer in ->save_in_file and
  file<-object.


VERSION 6.5.12, distributed with SWI-Prolog 5.5.12
==================================================

* ADDED: library(pce_progress): provide progress bars.

* FIXED: Bug#28: avoid strtod() locale-specific interpretation of resource
  strings.   Jiri Spitz.

* FIXED: Bug#28: error messages of class tokenizer.  Jiri Spitz.

* FIXED: Bug#26: make accelerators in menus work.  Holger Kanwischer.


VERSION 6.5.11, distributed with SWI-Prolog 5.5.11
==================================================

* ADDED: Support UNICODE in window titles.

* ADDED: Win32: Support for UNICODE in cut/paste.

* PORT: adopt new SWI-Prolog `xos' layer around MS-Windows, providing access
  to files using UNICODE names.


VERSION 6.5.9, distributed with SWI-Prolog 5.5.9
================================================

* FIXED: Bug#21: wrong computation of window<-visible.  Holger Kanwischer.

* FIXED: Bug#23.  Menu selection handling (integers).  Holger Kanwischer.


VERSION 6.5.8, distributed with SWI-Prolog 5.5.8
================================================

* ENHANCED: xpce-stub.exe to show a messagebox if initialisation or execution
  fails.  Simplifies debugging.

* ENHANCED: improved error message if selector is not an atom.

* FIXED: seek issues on streams created from XPCE objects.

* FIXED: integer return values of prolog defined methods incorrectly mapped
  to XPCE floats.

* ADDED: `text_buffer->iso_latin_1' to see whether text can be expressed in
  ISO Latin-1.

* FIXED: Avoid BadAtom errors on X_GetAtomName when getting the X11 selection.


VERSION 6.5.7, distributed with SWI-Prolog 5.5.7
================================================

* ADDED: PceEmacs: ->insert_character_by_code to interactively insert a
  character by entering its numeric UNICODE value.

* FIXED: wide character support for `editor->insert_self' and `editor->
  transpose' and editor undo management.

* ADDED: (very simple) make check

* FIXED: frame->geomtry for transient frames (MS-Windows).  Holger Kanwischer.

* FIXED: PceEmacs crash on `revert-buffer'.  Pierpaolo Bernardi.


VERSION 6.5.6, distributed with SWI-Prolog 5.5.6
================================================

* FIXED: Bug#14: image->pixel for <-kind = bitmap. Holger Kanwischer.

* FIXED: omitted close in text_buffer->insert, introduced in 5.5.3.

* FIXED: Bug#11: crash on text objects with more than 200 lines.
  Holger Kanwischer.


VERSION 6.5.5, distributed with SWI-Prolog 5.5.5
================================================

* FIXED: Using text-buffer for binary I/O.  Fixes
  send(Image, save, TextBuffer, jpeg), etc. (bug introduced with wide
  characters).

* FIXED: Bug#7: Get rid of maximum rows/columns in a dialog window (used
  to be 100/100).  Holger Kanwischer.


VERSION 6.5.4, distributed with SWI-Prolog 5.5.4
================================================

* FIXED: X11 error in text-metric computation, notably showing up when
  positioning the caret in text-items.

* ENHANCED: some cleanup and more robustness in library(Xserver) to create
  a head-less server for XPCE.

* FIXED: Crash in wrapped text objects.  Caused by incompatible change in
  low level string functions.  As compatibility is restored, more problems
  may be fixed by this.

* FIXED: Bug#6: TAB in password item.

* FIXED: `file->append' for text-files did not terminate (bug introduced
  in 6.5.3).

* PORT: Fix various MacOS (and other) portability problems introduced
  in wide character version.

* PORT: enhanced detection of visibility attribute


VERSION 6.5.3, distributed with SWI-Prolog 5.5.3
================================================

* ADDED: Changed X11 frame class to resemble the XPCE class name.  For
  grouping in KDE.

* ADDED: XFT-based font support for the Unix/X11 version.

* FIXED: Environment handling for class process (Unix).

* ADDED: Ongoing work on wide-character support.  Currently dealing with
  the XPCE <-> Prolog interface, elementary string handling, displaying
  wide strings.


VERSION 6.5.1, distributed with SWI-Prolog 5.5.2
================================================

* FIXED: Inconsistend results when initialising directory with terminating
  /.  Steve Moyle.

* FIXED: Bug#209 PceEmacs CHR colouring on bad input.


VERSION 6.4.3, distributed with SWI-Prolog 5.4.3
================================================

* FIXED: Converting instances of class number to a string.  Petter Egesund.

* FIXED: Win32: Drawing arcs as pie-slice with size-angle close to 0, so
  start and end are at the same location.

* FIXED: forcing loading of swi_compatibility.pl to ensure registration of
  messages.


VERSION 6.4.0, distributed with SWI-Prolog 5.4.0
================================================

* Updated version number for consistency.


VERSION 6.2.26, distributed with SWI-Prolog 5.3.20
==================================================

* FIXED: Bug#176.  Caused by allowing redefinition of `window<-popup'.

* ADDED: `window->update_scroll_bar_values' as a hook to intercept update
  requests to the scrollbars.

* ADDED: `tabbed_window->append': optional `expose' argument to make the
  new tab the topmost one.

* ENHANCED: Allow redefinition of `window<-popup' for associating popups
  rather than using hardwired slot.

* FIXED: Busy cursor handling for MS-Windows (Cursor was not properly
  updated).  Holger Kanwischer.

* FIXED: Class connect gesture to reset <-device in ->terminate.
  Petter Egesund.

VERSION 6.2.25, distributed with SWI-Prolog 5.3.18/5.3.19
=========================================================

* FIXED: Buffer overrun-by-one in menu->selection.  Caused crashes on Windows
  version.  Christophe Costa Florencio.

VERSION 6.2.24, distributed with SWI-Prolog 5.3.17
==================================================

* FIXED: Drawing arrow heads on bezier curves.  Christophe Costa Florencio.

* FIXED: editor->transpose_characters to fail if the caret is at the
  end of the buffer instead of importing a random character.

* FIXED: Bug#154 Application modal frame handling.  Holger Kanwischer.

VERSION 6.2.23, distributed with SWI-Prolog 5.3.16
==================================================

* FIXED: cross-referencer: handle directives with conjunctions properly.

VERSION 6.2.22, distributed with SWI-Prolog 5.3.15
==================================================

* FIXED: class tabbed_window destroying the window.  Steve Moyle.

VERSION 6.2.21, distributed with SWI-Prolog 5.3.14
==================================================

* ADDED/FIXED: untab/retab of tabs in the class tabbed_window.

* FIXED: Scrollbar update for windows used as graphicals (i.e. displayed
  on other windows).


VERSION 6.2.20, distributed with SWI-Prolog 5.3.13
==================================================

* FIXED: avoid trying to build GUI reporting for errors from user input.
  Dmitry.

* FIXED: Pass $(LDFLAGS) in generating Prolog interface.  Paulo Moura.


VERSION 6.2.19, distributed with SWI-Prolog 5.3.12
==================================================

* ADDED: Create CLASSINDEX.pl in XPCE library insex file.

* FIXED: PceEmacs: restore of syntax after processing a file.  Dmitry.

* ENHANCED: Improve checking of arguments in pce_begin_class.  After
  message from Joao Mariz.

* FIXED: PceEmacs: handle exported operators in colouring.


VERSION 6.2.18, distributed with SWI-Prolog 5.3.10
==================================================

* ENHANCED: Exploit GCC visibility("hidden") attribute.  Improves symbol
  handling for embedded applications on ELF-based systems.


VERSION 6.2.17, distributed with SWI-Prolog 5.3.9
=================================================

* ADDED: PceEmacs to determine mode from arbitrary patterns on the content.
  See emacs_content_mode/3 in library('emacs/emacs.pl').

* ADDED: CHR support in the cross-referencer and colours to the
  PceEmacs chr mode.

* FIXED: Bug#142: Buffer overflow on menus with > 1000 items.  Limit
  has been removed.  Holger Kanwischer.

* MODIFIED: class compiler operator issues to exploit the new
  library(operators).


VERSION 6.2.16, distributed with SWI-Prolog 5.3.7
=================================================

* FIXED: PceEmacs: make matching bracket highlighting work after
  text-modifying commands.

* FIXED: cross-referencer to handle #! script file.


VERSION 6.2.15, distributed with SWI-Prolog 5.3.6
=================================================

* ADDED: PceEmacs: Highlight of matching bracket in language mode.
  Suggested by Maurizio Colucci.

* ENHANCED: make view->colour and editor->colour all set the foreground
  colour of the text.


VERSION 6.2.14, distributed with SWI-Prolog 5.3.3
=================================================

* INSTALL: Avoid accessing the X11 display when building the online
  manual index to facilitate building in environments that do not
  support X11.


VERSION 6.2.13, distributed with SWI-Prolog 5.2.13/5.3.2
========================================================

* FIXED: Avoid excessive amount amount of ->report: status, '' from
  keybinding (Laurens van der Meij).

* FIXED: Bug#113: ERROR: - ->initialise: Argument 1 (left): `expression'
  expected, found `Unexpected ` in PceEmacs on some errors in Prolog mode
  (Hugo Ferreira).

* FIXED: Bug#117: PceEmacs to confirm overwrite when writing to	a `save_file'.
  Extended `file_item->exists' for this purpose (Hugo Ferreira).

* FIXED: Bug#111: date(0,0,0,1,1,1970).  Fabien Todescato.  See documentation
  of date->set for details.


VERSION 6.2.11, distributed with SWI-Prolog 5.2.11
==================================================

* ENHANCED: pullright menu handling.

* MODIFIED/FIXED: `node<-contained_in' now fails if the node is not
  contained in a tree (rather than returning the incorrect @nil).

* ADDED: library(url_image) providing class url_image.

* ADDED: library(scaledbitmap) providing class scaled_bitmap.

* FIXED: Bug#104: PceEmacs find-file `Browse' to use Open rather than Save
  (actually not good, but MS-Windows cannot browse for Open or Save file at
  the same time).  Holger Kanwischer.


VERSION 6.2.10, distributed with SWI-Prolog 5.2.10
==================================================

* FIXED: Bug#102: focus handling problems in combo box.  Holger Kanwischer.

* ADDED: library(pce_grapher) to support creating and managing simple Prolog
  graphs.  Especially useful for educational purposes.

* ADDED: extra argument to `graphical->layout' to extend existing graphs.
  (incremental layout).

* ADDED: library(pce_tagged_connection): allow ->tag: @nil to remove the
  associated tag.

* ADDED: `graphical <-connected' and use message passing in
  `graphical <-layout' to find out about connected graphicals.

* FIXED: Bug#103: Error loading XPCE on MS-Windows when compiled for single
  threading.  Holger Kanwischer.

* FIXED: Bug#101: @finder<-file using a specified default file (MS-Windows
  version).  Laurens van der Meij.


VERSION 6.2.9, distributed with SWI-Prolog 5.2.9
================================================

* ADDED: PceDraw: Alignment sub-menu for text objects

* FIXED: Frame area computation in MS-Windows to use AdjustWindowRectEx().
  Fixes layout problems in Windows XP.

* ADDED: in_pce_thread/1 to support the model of XPCE running in the foreground
  and make background threads interact synchronously with it.

* FIXED/MODIFIED: `node->image' now use ->destroy to destroy the old image.
  The new image is immediately connected to the tree so <-contained works.

* FIXED: `event->inside' for windows that are not the receiver of the event.

* PORT: manual installation according to the GNU make/autoconf guidelines.
  Andreas Voegele.

* MODIFIED: library(pce_unclip) to detach if the pointer leaves the original
  window.  Avoids event processing problems.

* PORT: Socket library tests for IRIX 6.5.  Rob Myers.

* FIXED: Demo ispell file-open (Kip Rugger).

* FIXED: Crash in button->redraw if the button was nost displayed in a
  window (i.e. `image->draw_in').  Lourens van der Meij.

* FIXED/ADDED/MODIFIED: Fixed loc_still generation if loc_move handling
  created other events.  Added class-variable loc_still_time to class
  event to specify the time and modified the default to 400ms (was 700ms).

* ADDED: `table_cell->image' to replace the image in a cell while keeping
  the same cell.

* FIXED: Class text_item modified propagation for ->paste.  Also provide
  real modified status for normal edit.

* FIXED: `node->collapsed' for indented-list trees on the <-display_root
  (screen update problem).

* FIXED: handling of `tree->heighbour_gap' in `list' mode.

* FIXED: `node->move_after' to succeed silently if the node is already the
  last.

* FIXED: redraw problems in class tree (using ->direction: list) when moving
  nodes between branches.

* FIXED: keyboard focus handling in class frame to use ->post_event.  Also
  the source-view of the GUI tracer requires redefining ->post_event rather
  then event (doesn't forward trace-commands).

* MODIFIED: Various aspects of class text_edit_gesture: only activate on
  `click', ignore double-click and ->copy on ->terminate if there is a
  selection.

* ADDED: library(pce_editable_text) to use text_edit_gesture, adding
  selection handling.

* ADDED: Selection management for class text if the text is wrapped.


VERSION 6.2.8, distributed with SWI-Prolog 5.2.8
================================================

* FIXED: MS-Windows: displaying of large cursor for drag-and-drop while the
  underlying window updates.

* ADDED: `frame->sensitive'.  Use this to avoid tooltip (balloon) and the
  `unclip' windows of library(pce_unclip) to grab the focus from the
  application window.

* MODIFIED: The windowing kernel now invokes `window->post_event' rather than
  `window->event'.  For most applications this just removes bugs, but
  applications that really aim at redefining the window focus and
  event-handling may break.  Such applications should redefine
  ->post_event instead of ->event.

* PORT/MODIFIED: `window->grab_pointer' maintains @grabbed_windows on all
  platform (used to be called @_grabbed_windows and only on X11).

* MODIFIED: `node->delete_tree' now calls ->destroy on the deleted nodes,
  providing guaranteed destruction of the node's <-image.  Application that
  which to preserve the images should detach them from the tree before
  deleting the node.  We believe it is unlikely that any application is
  affected.  Please contact bugs@swi-prolog.org if this change poses
  problems to you.

* ENHANCED/FIXED: X11 image routines now diagnose the image type using
  analysis of the header similar to Unix file(1) before calling the loading
  function.  This is faster and avoids trouble of unsafe loading filters
  on images of the wrong format.  Also fixes trouble running the SuSE
  RPMs on Mandrake.  Diagnosed with help of Chris Fox.

* ADDED: Support for new event-types.  See event_node->initialise.

* ADDED: Class tabular (library(tabular)): ->append now accepts
  table_cell objects.

* ADDED: drag_and_drop_gesture<-select_command to deal with command selection
  in right-dragging.

* ADDED: popup_gesture->max_drag_distance to get a popup that opens at
  the `Up' event.

* MODIFIED: Allow drag_and_drop_gesture->cursor: @default to create the
  cursor from the dragged graphical.

* ADDED: `node->move_before' to move a node just before another.

* FIXED: `node->move_after' to handle @default as advertised (move to end).

* ENHANCED: object->delete_hyper to destroy the object's <-hypers chain
  after deleting the last hyper.


VERSION 6.2.7, distributed with SWI-Prolog 5.2.7
================================================

* FIXED: temporary filename generation (new(X, file)).  Dave Hankinson.

* ADDED: Documentation for pce_autoload_all/0.  Lourens van der Meij and
  Piet Mertens.

* FIXED: Change label of objects in dialog editor.  Denis Medvedev.

* FIXED: Class node (part of tree) placement of constrained graphicals using
  ->geometry instead of ->set, so windows can be displayed in hierarchy nodes.
  Also ensure `window<-contained_in' returns the node in this case.

* FIXED: pce_identifier_item.pl: declare the used error (not filled).

* FIXED: Avoid text_image (used by editor and list_browser) to draw selection
  over scrollbar.

* ADDED: pce_begin_class/[2,3]: test for redefinition of built-in and user
  defined classes.

* FIXED: Produce clean error message when running a class whose super-class
  is missing.

* FIXED: PceEmacs SGML mode: avoid long delay on long lists of elements
  in very large files.

* FIXED: Popup handling with library(pce_unclip).


VERSION 6.2.6, distributed with SWI-Prolog 5.2.6
================================================

* ADDED: Paint <-mark of class path when generating PostScript.

* ENHANCED: barchart package: show cursor indicating a bar can be dragged.


VERSION 6.2.5, distributed with SWI-Prolog 5.2.5
================================================

* FIXED: `process->close' to avoid messages
  Warning: Select failed; error code 9.

* FIXED: Manual tools object browser doesn't open class browser on request.
  Fabien Todescato.

* ADDED: `object <-create_context' to query the goal stack for the object
  that creates me.

VERSION 6.2.4, distributed with SWI-Prolog 5.2.4
================================================

* ENHANCED: pce_global messages and handling of changed definitions.

* ADDED: Support for new SWI-Prolog profiler hooks.

* FIXED: Issues resulting from the :: priority change.  Anders Bouwer.


VERSION 6.2.3, distributed with SWI-Prolog 5.2.3
================================================

* ADDED: library(pce_unclip) to show graphicals partly clipped by their own
  window in a small tooltip-like window.  Used by library(pce_toc).

* MODIFIED: Changed priority of :: using in "comment"::<Body> from 1150 xfx
  to 910 xfy.  Must be above \+ (900) to avoid a conflict.

* FIXED: Visual hierarchy tool to find windows displayed in windows.

* ENHANCED: reset the display after an abort.

* FIXED/ENHANCED: Various issues and expensions with PceEmacs bookmark
  window.

* FIXED: MS-Windows: painting (redraw) in windows displayed inside a
  `tabbed_window'.

* ADDED: `menu_item->background'.

* PORT: Define _THREAD_SAFE for FreeBSD if threaded code is requested.

* FIXED: type := value declaration handling of instance variables.  Also
  updated documentation and added some value := new(Term) to the preprocessor.
  Anders Bouwer.


VERSION 6.2.2, distributed with SWI-Prolog 5.2.2
================================================

* FIXED: `frame->keyboard_focus' to use window rather than decorator.
  Could make dialog windows with a scrollbar insensitive to typing.

* MODIFIED: `chain<-current_no' now fails if there is no current.

* FIXED: Auto-update of library class index.

* FIXED: Class persistent_frame to be more careful about changed window
  layout when restoring the layout.

* ADDED: `bar_chart->sort' to sort the bars by <-value.

* ADDED: window_tab->untab to transform a tabbed window into a toplevel
  window.

* FIXED: right-click on tab of tabbed_window (exception).

* FIXED: tracepce/1 on Prolog-defined get-methods that fail (crashed).

* FIXED: Properly deal with := in variable initialisations if the value is
  shareable, but converted to a non-shareable value due to the variable
  type.  Anjo Anjewierden.

* ADDED: `date<-xml_string' and extended `date<-convert' to deal with XML
  Schema dateTime representation.

* ENHANCED: PceDraw: somewhat more tolerance in the setting-menu handling.

* FIXED: PceDraw to properly cancel pending operations (notably creating a
  path).

* ADDED: library(password_item) to allow entering passwords through the GUI.


VERSION 6.2.0, distributed with SWI-Prolog 5.2.0
================================================

* ADDED: `view->background' and `editor->background' to set the background
  of the text_image

* FIXED: Bug #53: Restarting the Prolog Navigator (Holger Kanwischer).


VERSION 6.1.13, distributed with SWI-Prolog 5.1.13
==================================================

* PORT: Fixed many GCC 3.3 signed/unsigned warnings.


VERSION 6.1.12, distributed with SWI-Prolog 5.1.12
==================================================

* ADDED: library(splash_screen) to provide nice startup screens.

* ADDED/FIXED: Allow a frame to delete its only window (frame->delete).
  Added code to library(tabbed) window to disconnect a window from its
  frame before adding to the tab.  Steve Moyle.

* FIXED: Poor hash-performance hashing a sequence of integers.  Anjo
  Anjewierden

* FIXED: Various minor problems in barchart/plotter.

* FIXED: Generating PostScript from bitmaps filled with ->draw_in
  (X11 version).

* FIXED: Generating PostScript from boxes with negative dimension.

* FIXED: bar->compute can fail.

* FIXED: Prolog navigator loading wrong Prolog module.  Fabien Todescato.


VERSION 6.1.11, distributed with SWI-Prolog 5.1.11
==================================================

* ADDED: Redirect events to the label of a tab to ->label_event to allow
  adding user-defined event-handling to tab-labels.

* FIXED: Proper handling of `tab->destroy': update layout of the tab labels
  and ensure one of the tabs is `on-top'.

* ADDED: library(tabbed_window) for putting windows in tabs.

* FIXED: handle keyboard focus to windows displayed on windows.

* FIXED: Term-description of class view.

* FIXED: Cursor up/down in list-browser.  Anjo Anjewierden.

* FIXED: default-button and modified-item handling in nested dialog-groups.
  Juergen Repp.

* FIXED: Make `window->background' work with images on Windows.  Used to be
  supported on the X11 version only.


VERSION 6.1.10, distributed with SWI-Prolog 5.1.10
==================================================

* ENHANCED: many small changes to PceEmacs, cross-referencer and other parts
  of the XPCE libraries dealing with Prolog itself.

* MODIFIED: moved library(emacs/prolog_xref) to library(pce_prolog_xref) for
  better library structure.

* ADDED: library(pce_class_index).  Ongoing work to simplify class management.

* ADDED: Support for cross-referencing class definitions and usage from
  library('emacs/prolog_xref').

* ADDED: Class keybinding reports pending keystrokes of multi-key commands.


VERSION 6.1.9, distributed with SWI-Prolog 5.1.9
================================================

* ADDED: Enhanced HTML/XGML/XML structure viewer from library(doc/xml_browse)
  with search and some more goodies.  Added this tool to to demo programs.

* MODIFIED: Use win_btnface for default background colour of dialog
  windows.  Seems to make more sense to get a reasonable default
  colour on Windows XP.

* ADDED: PceEmacs: cross-referencer check for :- arithmetic_function/1.

* ADDED: optional `before' argument to `node->son' for efficient insertion
  of nodes at arbitrary locations.

* FIXED: Bug#27 icon directory prolog/lib/doc/icons was not installed.
  Lourens van der Meij.

* FIXED: PceEmacs: do not signal ->idle when a gesture is in progress
  (avoids re-colouring while waiting for the user to select a popup-entry).

* FIXED: library(pce_style_item). Ferreira Maurizio.

* ADDED: <->gap to graphical_browser (library(pce_graphical_browser)).

* FIXED: Placing of window objects in tables (class table).

* FIXED: PceEmacs OWL-mode: open_document namespace declarations.

* ADDED: PceEmacs colourise "Comment":: in method-body.

VERSION 6.1.8, distributed with SWI-Prolog 5.1.8
================================================

* ADDED: library(pce_identifier_item) providing the class identifier_item.

* FIXED: tool_bar->activate if there are `gaps' in the toolbar

* ADDED: PceEmacs cross-references now deals with the :- meta_predicate
  declaration.


VERSION 6.1.7, distributed with SWI-Prolog 5.1.7
================================================

* ENHANCED: indirection in class editable_text to make it easier to modify
  edit-mode feedback in subclasses.

* FIXED: Bug #14: printer handling for PceDraw (Lourens van der Meij).

* FIXED: Object-reference counting problem that may cause colour objects
  to be garbage collected early.  (Lourens van der Meij).

* ADDED: PceEmacs: provisional RDF, RDFS and OWL modes to insert the lengthy
  header and draw a triple diagram from small files.

* PceEmacs: added .owl to map to xml-mode

VERSION 6.1.6, distributed with SWI-Prolog 5.1.6
================================================

* FIXED: `toc_node->font' from the library(pce_toc).  Filip Prochazka

* FIXED: Balloon help in modal windows.  After demo program from Juergen Repp.

* FIXED: Guitracer: goal-expansion loop.

* ENHANCED: image->draw_in to avoid redrawing the whole graphical if only
  part overlaps the image.

* ADDED: Support for writing PostScript colour images.

* ADDED: Windows version: load .ICO data from streams and therefore from
  SWI-Prolog resources.  With help from	Fabien Todescato.  Thanks.

* FIXED: Handling `default' argument in @finder<-get_file.
  (Lourens van der Meij).


VERSION 6.1.5, distributed with SWI-Prolog 5.1.5
================================================

* FIXED: `@pce->show-console' to deal with new SWI-Prolog console code.

* PORT: Upgraded XPCE configure suite to use autoconf 2.5.3 (distributed
  with SuSE 8.1).  Configure gives some warnings on cd to non-existent
  directories, but appears to work fine.

* FIXED: `date->set' (also `date->initialise' if arguments are provided)
  on Windows platforms. Fabien Todescato.

* FIXED: Added type-checking if an instance-variable is initialised to
  a constant (Lourens van der Meij).


VERSION 6.1.4, distributed with SWI-Prolog 5.1.4
================================================


VERSION 6.1.3, distributed with SWI-Prolog 5.1.3
================================================

* FIXED: `file<-read_line' to fail on end-of-file as advertised (but
  no longer working after a recent patch to this code to deal with
  unlimited-length lines).

* FIXED: A few problems in the configuration-editor.

* ADDED: @prolog_ide->thread_monitor to monitor active threads.

* ADDED: `timer->service' to execute timers in `service mode'.

* FIXED: MT: not releasing XPCE mutex in event_window() if the window
  was destroyed while processing the event (leads to lockup after using
  a popup).

* ADDED: `path->relative_move' for better performance and flexibility.

* ADDED: optional argument to `device->clear' to force destruction of the
  erased objects.


VERSION 6.1.2, distributed with SWI-Prolog 5.1.2
================================================

* PORT: MS-Windows Moved from winsock-1 to winsock-2

* FIXED: memory leak due to error in recent change in incremental GC.

* MODIFIED: termToObject() translates Prolog floats that happen to be
  integer into an XPCE real object.  Petter Egesund.


VERSION 6.1.1, distributed with SWI-Prolog 5.1.1
================================================

* INSTALL: Remove .qlf files when installing new libraries to avoid version
  conflicts.

* ADDED: Optional `ignore-case' argument to `char_array->equal'.  Used in
  text_item completion.

* MODIFIED: renamed module of library(http_client) to pce_http_client

* FIXED: Windows: text repaint to use int rather than short for very large
  scrolled objects.  Petter Egesund.

* FIXED: `file<-read_line' no longer has a limit on the line-length and
  reads lines holding 0-bytes.  Anjo Anjewierden.

* PORT: Make the windows version thread-safe.

* CLEANUP: Deleted death code accessing plterm.dll functions.

* ENHANCED: Various issues around the diagramming class plot_axis.  Fully
  compatible.

VERSION 6.0.10, distributed with SWI-Prolog 5.0.10
==================================================

* FIXED: below mentioned memory-management fixes, causing new problems in
  especially the source-level debugger.  Wouter Jansweijer and a few
  related messages.

* ADDED/FIXED: named attributes to class float_item and checking low/high
  in the stepper functions of this class.


VERSION 6.0.10a, distributed with SWI-Prolog 5.0.10a
====================================================

* FIXED: memory-management problem in `code-referenced' objects.  This
  can be the cause of some hard-to-reproduce crashes.

* FIXED/ENHANCED: Max size of a string is increased from 16MB to 128MB
  and the system handles attempts to create larger strings gracefully.

* FIXED: Improved handling when out of memory.

* FIXED: Some dubious C constructs reported by gcc 3.1 (Paulo Mauro).

* FIXED: Editor text-selection better checking of context (Jakub Jiricek).

* FIXED: When using with multi-threaded SWI-Prolog, avoid deadlock if
  background threads wants to send output.


VERSION 6.0.9, distributed with SWI-Prolog 5.0.9
================================================

* ADDED: Skeleton file for ~/.xpce/Defaults.

* ADDED: First version of system-dependent and hot-switchable key-bindings
  (accelerators).  Provides the important CUA (Common User Access, used
  in Windows) key-bindings by default on Windows and Emacs bindings on
  Unix systems.

* ADDED: Print and Print Selection to PceEmacs, both working on Windows and
  Unix platforms.

* ADDED: `text_image<-character_position'.

* ADDED: Make `text_image <->elevation' an instance-variable instead of a
  class-variable.

* ADDED: `screenline' argument to `editor->scroll_to'.

* ADDED: Hooks in class key_binding, preparing for better programmable
  binding tables.

* ADDED: PceEmacs: allow for deleting menu-items in sub-modes.  Used to cleanup
  the menus in the Prolog Mode.

* MODIFIED: Editor selection management, unifying the `region' and `selection',
  which is now defined by <-mark and <-caret.  This is a first step towards
  better compatibility to GNU-Emacs as well as MS-Windows editing commands.

* ADDED: Published `editor<->internal_mark', a mark for program use.

* FIXED: Throw exception of Prolog defined get-method returns a
  freed XPCE object. Used to succeed without binding the result.
  Thanks to Lourens van der Meij.

* FIXED: Windows: reading transparent GIF with > 128 colours.

* FIXED: `Image->mask' in windows now sets the masked parts to black for
  proper display.

* FIXED: writing GIF in windows version if 3*width mod 4 =\= 0 it swapped
  the blue and red colors.

* FIXED: writing XPM in Windows version.  This includes a patch to the Windows
  port of XPM which inverted transparency.  If you use the source, get the
  updated XPM library from ftp://www.swi.psy.uva.nl/xpce/Windows/lib/

VERSION 6.0.8, distributed with SWI-Prolog 5.0.8
================================================

* ADDED: writing transparent GIF files.

* FIXED: Removed some traces of pre-iso SWI-Prolog concat/3 (replaced
  with atom_concat/3).  Martin Sondergaard.

* FIXED: filter-name in Unix file-dialog when using tuple(Name, Ext)

* ENHANCED: PceEmacs help-page on Prolog Mode.  Martin Sondergaard.

* FIXED: X11 version: make filling monochrome context with colour-images
  work (Anjo Anjewierden).

* FIXED: `finder->label' compatibility.

* FIXED: Missing ws_unlink_colour_map() in X11 version.  Paulo Moura.

VERSION 6.0.7, distributed with SWI-Prolog 5.0.7
================================================

* COMPAT: X11 file-finder: allow again for specifying extensions as .xyz

* FIXED: Improved compatibility of X11 selection-handling.  Works again
  with recent Qt versions which demanded the obligatory `targets' target.

* FIXED: Win32: Loading X11 .BM files (broken due with new DIB-based jpeg
  loading).

* ADDED: `segment' argument to `line<-distance' to compute the distance
  from a point to the line-segment.

* FIXED: `path<-distance' (yielding wrong result).

* ENHANCED: Subwindow layout adjustment if actual resizing the windows is
  slow.

* ENHANCED: Windows: JPEG bitmap loading to use a more direct
  approach through DIB.  A similar approach was already in the X11 version
  for some time.

* MODIFIED: Windows: by default we now use the Netscape 216 colour
  colour-cupe as read-only colour-map on 8-bit displays.  This provides
  better reproducable and generally better results.

* ADDED: `image<-rotate' now accepts a float rather then an integer (conversion
  ensures compatibility, though fractional arguments are no longer rounded to
  the nearest integer.

* COMPAT: re-added `finder->directory' (Bob Wielinga).

* FIXED: Completion (TAB) in file_item (library(pce_file_item)).

* FIXED: `graphical->draw_image': correctly handle non-square images.

* MODIFIED: PceEmacs command "M-x insert_date" to insert just the date, not
  the time.


VERSION 6.0.6, distributed with SWI-Prolog 5.0.6
================================================

* FIXED: PceEmacs prolog mode trapping an error when pausing during
  singleton-replace mode (error became severe after fixing timer :-).

* FIXED: real_range type handling of unbound (e.g. "1.0..").

* FIXED: X11 version: timers sometimes stopped spontaneously.

* ENHANCED: library(find_file).  New and more flexible file-browser.

* FIXED: interface to generate error(instantiation_error,_) exception on
  uninstantiated data rather than a type-error.

* ENHANCED: XPCE Inspector to show textual value of a string rather then
  the address of the text and numerical indication of flags.

* ADDED: `dialog<-border' to always return a size object.

* ADDED: `file_item <->exists', fixing browse mode in PceEmacs save_as and
  friends.

* FIXED: Explicit window placement in Windows version.

* FIXED: avoid loosing a file-descriptor in prolog_xref.pl if a loaded
  file contains a syntax-error in the first term.  Affects PceEmacs in
  Prolog mode and the GUI-Tracer.

* FIXED: Added -fno-strict-aliasing to make XPCE compile correctly using
  GCC-3 (Lourens van der Meij).

* FIXED: `image_browser<-selected' from library(pce_image_browser).

* ADDED: Allow unbound value as default in default/3.

* ADDED: `path<-distance' to compute distance to a point or event.

* ADDED: `menu->insert_before' for easily adding menu items in the middle
  of existing menus.

* FIXED: `object <-get_hyper' got into a loop when accessing the hyper
  backwards.

* ADDED/MODIFIED: Instance variables that allow for @default, but not for
  @nil have initial value @default without explicit specification.
  Instance-variables that have an associated class-variable are now always
  initialised to @class_default, which is replaced by the value from the
  class-variable on first access.

* MODIFIED: class tab/tab_stack: nicer visualisation of top/hidden tab.

* ADDED: `colour<-hilite' and `colour<-reduce': argument to say how much.

* FIXED: `frame->set' on Windows to handle X and Y properly.  Reported by
  Ron Seljee.

* MODIFIED: `tab_stack->layout_dialog' to succeed if the stack is empty.

* ADDED: Allow non-editing interaction (select, scroll) on text_items that
  handle editable: @off.  By Amir ?

* FIXED: Various overflow issues concerning path and distance calculations
  when using graphicals extending the range of 16-bit (short) integers.

* FIXED: `text_item ->value_font' fails to update font in some rare
  situations.

* MODIFIED: object-term of window and it subclasses now provide one
  argument: the <-name of the window.  Used to be inconsistent and
  often refering to failing methods, making object/2 fail on window
  instances.  Shouldn't break any code.

* ADDED: `class<-no_created' and `class<-no_freed': extra boolean
  argument to add the counts of their subclasses.  Used by PceEmacs
  Prolog colouring to display the correct number of fragments again.

* MODIFIED: moved image greying from library(toolbar) to new
  library(imageops), which is included from library(toolbar).

* ADDED: `tree->event' to call new method `node->event' to allow for
  refinement of node event-processing.

* ADDED: `dialog<->border' to allow setting the border independent from the
  <->gap.

* FIXED: `term-names' of text_item to use <-value rather then <-selection
  to avoid resetting <-modified (and other side-effects).

* FIXED: Lock up on `point<-distance' if points are very far apart.  Now
  use floating point arithmetic.

* ADDED: Dedicated support for JPEG loading on static-color visuals in
  the X11 version, more than triples the speed on non colour-mapped
  displays.


VERSION 6.0.5, distributed with SWI-Prolog 5.0.5
================================================

* ADDED: `editor->show_caret'.  If the caret it invisible, the up/down
  arrow-keys scroll the editor.

* ADDED: Provide support for exchanging atoms and strings holding 0-bytes
  between Prolog and XPCE, facilitating better handling of binary objects.

* ADDED: `window<->buffered_update': switch on/off double buffering on
  window-basis.

* ENHANCED: wheel-mouse events on a window are routed to the vertical
  scrollbar if one is attached.

* ADDED: `graphical<->solid' for more advanced definition of own repaint.

* FIXED: `graphical->draw_image: argument-order and made transparent
  argument accept default.

* ADDED: ->background to class list_browser and class browser.

* ADDED: Windows: support for UNC-filenames (//host/share/...)

* FIXED: scrollbar thumb handling if the scrolled object size > 2M (notably
  large editors).  Fabien Todescato.


VERSION 6.0.4, distributed with SWI-Prolog 5.0.4
================================================

* FIXED: Win32: ->geometry to use SystemParametersInfo(SPI_GETWORKAREA, ..)
  to determine boundaries.

* FIXED: More robust and better re-entrant implementation of pceDispatch(),
  fixing problems with errors in select() (error code 9: EBADF).  Required
  for SWI-Prolog's improved library(socket).

* ADDED: full_screen to `@pce->show_console'.

* ADDED: Start for `frame->status: full_screen' (work in progress).

* FIXED: `frame->status: window' for the X11 version, opening the frame
  if it was iconic.

* FIXED: `persistent_frame' to save deeply nested subwindow layout.

* ADDED: Win32: `@pce<-user' to obtain the name of the currently logged
  on user.

* ADDED: PceEmacs: report key-bindings in replace mode.

* FIXED: `frame->set' force negative and 0-width/height frames to be
  at least one pixel to avoid errors from the Window system.

* FIXED: Avoid loop in textimage redraw if it is 0-pixels wide.

* FIXED: Access of freed memory in `display->inspect', used by the
  balloon system (probably harmless, but spotted in allocation debug-mode).

* FIXED: Disable dabbrev_expand in read-only editor.

* FIXED: PceEmacs Prolog mode: avoid an XPCE crash when replacing
  singletons.

* FIXED/MODIFIED: PceEmacs ^X^B (switch_to_buffer): properly handle
  complete but not unique buffernames and open the buffer in a
  new window if the current window is sticky.


VERSION 6.0.3, distributed with SWI-Prolog 5.0.3
================================================

* FIXED: WSAEWOULDBLOCK problems in windows socket layer.

* INSTALL: Properly install swipl.rc in the MacOS version to bind XPCE
  to the normal Prolog executable swipl.

* FIXED/MODIFIED: `stream <-read_line': timeout argument is now a float
  representing timeout in seconds for compatibility with other time
  specifiers.  Return is now @nil timeout, failure on end-of-input.
  Behaviour between Windows and Unix version is consistent.

* FIXED: `frame->geometry' on Windows with negative X and Y.  ->geometry now
  ensures part of the title-bar of the window is visible, so you can move and
  resize the window.

* ADDED: `list_browser->selection_style' as a method.

* FIXED: Help-balloons on loc-still

* FIXED: make rpm-install: install the manual search index.

* FIXED: Search form of the XPCE HTTP manual (from xpce/prolog/lib/http)


VERSION 6.0.2, distributed with SWI-Prolog 5.0.2
================================================

* FIXED: Error handling red-slider in HSV colour demo (Geof Bishop).

* FIXED: Draw the label of tab objects that are not `on top'.

* PORT: MacOS X.  Changed:
	- Fixed xpm header detection if not in default path
	- Added __unix__ to config.h
	- Fixed configure to deal with shells where eval "" fails
	- Use plld -shared to link the pl2xpce.so shared object
	- Allow for different-named executable Prolog (swipl)
	- Use hacky function + call in ker/glob.c to work around
	  a bug in the linker.
	- See the SWI-Prolog twiki web for more info.

* ADDED: Allow for `editor->style: Name, @nil' to delete the given style from
  the editor.

* ADDED: Many PceEmacs goodies for Prolog mode
	- Colour arguments to all (declared) meta-calls
	- Better handling of explicit cross-module calls and definitions
	- Precompile prolog_mode.pl and related files to qlf to speed up
	  loading on slow machines.
	- Marking variables.
	- Integrate singleton marks with global colouring.
	- Deal with (direct) recursion while cross-referencing and
	  underline recursive calls.

* MODIFIED: Make pce_image_directory/1 not open the display when compiling
  a state.  This should be fine as long as the compilation process doesn't
  create images.  If it does, open the display explicitly before creating
  the rest of the state using send(@display, open).

* FIXED: Editor: bind C-j to newline_and_indent as well as LFD, as these
  sequences send different commands since a while.  Used to work nevertheless
  in PceEmacs because `fundamental_mode->typed' was defined to accept
  event_id rather then event.

* FIXED: Improve keyboard input handling in X11 version when using transient
  windows.  Opening a modal window now gives this window the input focus
  regardless of what the window manager wants.

* ADDED: implements/3 from library(pce_meta): allow for variable method
  name.  This library now handles not-yet-realised classes fully dynamic.

* ADDED: `editor->auto_fill', doing the fill-part of ->insert_self_fill,
  so filling can easily be specialised in subclasses.

* ADDED: emacs_language_mode->fill_comment_paragraph to fill/justify
  regions commented using the line-comment character.
  `emacs_prolog_mode->fill_paragraph' now dynamically distinguishes
  between ->indent_clause, ->fill_comment_paragraph or normal
  ->fill_paragraph.

* MODIFIED: `text_buffer<-scan_syntax' to return a tuple containing the
  syntax category with the location where this syntactical entity started.
  Also documented the method.  Being previously undocumented and pretty
  obscure we don't anticipate public usage.

* FIXED: PceEmacs Prolog mode: avoid endless loop in indent_clause on a
  fact near the end of the file.

* ADDED: library(pce_image_browser): deduce name through method, allowing
  to override in subclass.

* COMPATIBILITY: PceEmacs look-and-feel synchronisation to GNU-Emacs
	- Fix Control-j (new_line_and_indent)
	- Make prompters return immediately if typed value is unique
	- `editor->fill_paragraph' justifies if argument is specified
	- Make Control-x b (switch_to_buffer) use last buffer as default.
	- Add Control-h k (describe_key) and Control-h f (describe_function)


VERSION 6.0.1, distributed with SWI-Prolog 5.0.1
================================================

* FIXED: Arrow-heads on lines had disappeared in redraw modifications.
  Anjo Anjewierden.


VERSION 6.0.0, distributed with SWI-Prolog 5.0.0
================================================

* SECURITY: Use mkstemp for making temporary files.  See file->initialise.

* LICENSE: The license conditions have been changed to allow for building
  non-free applications (LGPL and GPL+Exception)

* ADDED: Bind cursor left/right to ->advance in dialog items.
  `device->advance' has a new `direction' argument.

* MODIFIED: Unix/X11 version look-and-feel aspects of the classes button,
  menu_bar, scroll_bar, text_item, int_item: including `gtk' look and feel.

* FIXED: Minor redraw issues when uncovering windows involving dialog items
  or text `with things sticking out'.

* MODIFIED: `Frame<-geometry' excludes the size if <-can_resize yields @off
  (for improved geometry maintenance by class persistent_frame).

* FIXED: shrinking ver_stretch items in a dialog (shrink could be blocked
  by empty cells in other columns).

* FIXED: Make Windows version completely compatible in frame geometry
  handling, required to make the persistent_frame library function
  correctly.

* ADDED: library(persistent_frame) defining a class with the same name that
  realises a frame remembering its position, size and subwindow layout.  Use
  this class for (part of) the development environment tools.

* FIXED: May issues around frame<->geometry.  At least on the X11 version,
  <->geometry now queries and restores the geometry correctly.

* MODIFIED/FIXED: `frame<-bounding_box' to return the true position of the
  frame rather then just the size, making this method more suitable for
  screen layout arithmetic.  Related and improved documentation of frame
  geometry-management methods.  Fixed PostScript code to deal with the
  changed interface.

* FIXED: If there is a default button in a dialog, give it the keyboard
  focus instead of giving it to another button (Christophe Costa Florencio).

* FIXED: Avoid missing dash-pattern definition generating PostScript from
  text objects with a pixmap <-background.

* FIXED: X11 image export to gif, jpeg, pnm and PostScript for all visual
  types (tested using VNC in 8, 16, 24 and 32 bit mode).


VERSION 5.1.11, distributed with SWI-Prolog 4.1.0
=================================================

* ADDED/FIXED: X11: Saving images to PostScript on X-servers with more then
  16-bit colourdepth.  Reported by Lourens van der Meij.

* ADDED: PceEmacs: dialog-based find command.  The library can also be
  used with non-PceEmacs editor objects.

* ADDED: PceEmacs HTML mode: open_in_browser to open the current page
  in the user's browser.

* ADDED: PceEmacs: ->pce_define_class as new command to the Prolog mode
  First of more to come.

* ADDED: prolog_navigator/1 toplevel predicate.  Fixed module inclusion
  to make debugsettings work without PceEmacs or the GuiTracer loaded.
  Bound Prolog Navigator to Control-C Control-N in PceEmacs.

* FIXED: PceEmacs LaTeX mode: avoid loop looking for environment.

* PORT: Win32: Upgraded jpeg-support libraries to version 6b, providing
  full compatibility with the current Unix/X11 versions.

* ADDED: PceEmacs: add file-pattern to Prolog mode for user-choosen
  extension (.pro on Windows).

* FIXED: ->free bitmap on ->unlink of associated image.

* FIXED: `image->save' cache errors handling the associated XImage.

* ADDED: Class image: support for loading and saving the JPEG_COM markers
  associating comments with JPEG files.  See `image->load' and `image->save'.

* ADDED: PceEmacs: show accelerators in menu-bar in human-readable form.

* ADDED: PceEmacs: show current line-number in status window.

* FIXED: PceEmacs: various dangling issues around using GNU emacs tag-tables.

* ADDED: library(pce_type) providing pce_define_type/2 for defining your own
  types.

* FIXED: Win32: `file->exists' succeeded on directories, where this is only
  supposed to be the case if the optional must_be_file argument is @off.

* FIXED: avoid domain error on random/1 in the manual object-inspector tool.

* FIXED: Many issues to subwindow layout handling for the user.  Added new
  class tile_adjuster for this purpose.

* FIXED: Proper handling of class-variable inheritence for class-variables
  associated with normal variables.

* ADDED: `stream ->input_message' to check whether the stream is already
  open and then attach asynchronous input handling.


VERSION 5.1.10, distributed with SWI-Prolog 4.0.11
==================================================

* PORT: make FN (required for building XPCE) not depend on bash extensions
  to sh (Lourens van der Meij).

* FIXED: load .ICO files.  Possibly caused by recent delay in opening the
  display. (Spotted by Fabien Todescato).

* ENHANCED: PceEmacs LaTeX mode to handle `"' normally in verbatim and
  code environment.

* FIXED: Text format (string->initialise, <many classes>->format) to
  check for buffer overflows and report gracefully rather than
  uncontrolled after buffer overrun.  Removed the limit altogether
  on all methods where long output is considered mor or less `normal',
  such as string->initialise, string->format, stream->format,
  editor->format, etc.

* ADDED: `prolog_term->equal' to test for Prolog equality on terms.

* ADDED: library(pce_toc): allow for the use of arbitrary graphicals as
  label of nodes.

* FIXED: `text_item->clear' to set the item to modified, so <-selection
  indeed returns ''.

* ADDED: Default binding of Control-Z to undo in editor.

* FIXED: Memory leak in class code_vector.

* PORT: Included some portability issues in unx/process.c, socket handling
  and make version detection for NetBSD 1.5.2.  Contributed by John Towler.
  Incomplete.

* MAINTAIN: Unix Makefile: fixed pl-static target to call xpce dependency

* ADDED: Avoid opening the display during XPCE's initialisation.  This
  allows for XPCE applications without doing graphics.


VERSION 5.1.9, distributed with SWI-Prolog 4.0.10
=================================================

* FIXED: Win32: `Frame<-comfirm' to move/resize already open transient frames.
  Reported by Tolga Konik on the GUI tracer.

* MAINTAIN: Fixed src/FN not to touch the name database it it wasn't changed.

* FIXED: send(file('~/.xpce/Defaults'), exists) to take very long on Windows
  98 and friends: ~/xyz is expanded to c://xyz, which in turn is treated as
  a network path.

* FIXED: `device->erase' to reset the windows focus also the erased graphical
  is a sub-graphical of the focus.  This can cause crashes in applications.

* FIXED: `table_cell->note_mark' for cells in top row or left column.

* FIXED: Colour update in class reporter on ->report: progress, ...

* FIXED: Focus handling bug opening text_item combobox (for completions).
  Reported by Bob Wielinga.

* FIXED: User cancel of `display<-win_file_name' (used by find_file.pl
  to return a filename on a Windows platform).  Reported by Jelmer
  Jellema.

* FIXED/MODIFIED: `graphical <-{above,below,left,right}' now tell the
  object I'm above, ... rather then *who is* above, ...  This makes
  send(X, below, Y) and get(X, below, Y) behave consistently.  More
  important, we can now destroy a dialog item in the middle of a
  (for example) vertical stack:

  cut(Me) :-
	get(Me, device, Dev),
  	(   get(Me, above, UnderMe),
	    get(Me, below, OverMe),
	    UnderMe \== @nil, OverMe \== @nil
	->  send(Me, destroy),
	    send(UnderMe, below, OverMe)
	;   send(Me, destroy)
	),
	send(Dev, layout_dialog).

  This used not to work for a rather obscure technical reason.  It is
  anticipated there is very few usercode that will be broken by this
  change.

* FIXED: Bug in allocation _debugging_, causing problems on machines
  with signed characters.

* FIXED: Added a few more sanity checks to reading gif files.

* FIXED: Properly handle resource context in class_variable declarations.

* ADDED: PceEmacs: menu to super-class field of :- pce_begin_class/[2,3]
  to allow switching to the class.

* FIXED: Error handling default file in finder on Windows.

* FIXED: Metafile handling in PceDraw (proper detection of win_metafile
  and win_printer classes).

* FIXED: Work around IE 5.5 bug in javascript cookie handling for
  library(http/html_hierarchy).

* FIXED: Editor->geometry problem with h = @default, introduced with the
  patch handling very small editors.  Shows up with GUI tracer making the
  binding and source window smaller each action.

VERSION 5.1.8#2, distributed with SWI-Prolog 4.0.9#2
====================================================

* FIXED: `event<-key' to distinguish between RETURN and Control-M as well
  as TAB and Control-I.  Also fixed detection of control-key in Windows,
  detected by Paul Holmes-Higgin.

* FIXED: Class editor to handle editors with very small height (notably
  1 line or less) properly.  Reported by Paul Holmes-Higgin.

* FIXED: PceEmacs: honour style-check options (notably -atom) appearing
  in the file being coloured.

* ADDED: Make `{text,text_item}->catch_all' accept methods associated
  with class String, regardless of the text<-string.

* ENHANCED: Performance of PceEmacs colourisation in Prolog mode by
  removing some non-determinism


VERSION 5.1.8
=============

* ADDED: `table->insert_row' to allow adding a the row to be inserted.
  This allows for subclassing class table_row and play around with rows.

* ADDED: Object Inspector to display non-member slots of subclasses
  of chain and vector.

* MODIFIED: Control-I is now distinct from TAB, as is Control-M from
  RETURN.  This has been accomplished by passing the raw event to the
  ->typed methods and change the calculation of the key-name in class
  key-binding to check the status of the control-key.  It is anticipated
  that this has no consequences for user-code, though user-code refining
  or invoking the ->typed methods will not profit from this change if
  they do not define the argument type as `event|event_id'.

* MODIFIED: Editor to delete selection on cursor-movement without the
  shift key held down.

* FIXED: X11 version: avoid endless loop in ws_synchronise_display().

* FIXED: Inpector Tool: possible crash on ->clear.

* ADDED: Inpector Tool: `find_references' option to display the cards
  of objects pointing at me.

* FIXED: pcerefer/1 error message.  Added printing number of found
  references.

VERSION 5.1.7
=============

* FIXED: Possible loop in repaint of rounded buttons in X11 version.

* FIXED: Image scaling and rotation in 24-bit colourmode for the X11
  version (memory corruption).

* ADDED: X11 Client-side DragAndDrop supporting `window->drop_files'
  compatible to the MS-Windows version based on the XDND protocol.
  Tested with xftree (part of XFCE desktop environment) as server.

* FIXED: get(@finder, file, @off, ...) not to return the obtainer.
  (Anjo Anjewierden).

* ADDED: <-read_as_file and <-size_as_file to class char_array, so
  atoms and strings can be opened as a Prolog stream using pce_open.

* FIXED: permission-checking when opening an object from read in
  pce_open/3, so atoms can be opened for reading.


VERSION 5.1.6
=============

* PORT: Various issues to make the system compile and run on the
  INTEL Itanium (Merced) processor using gcc and Linux.  Thanks to
  the SuSE team for providing access to their hardware.  The most
  important patch affects all hardware where int passed different
  to an `stdarg' function as void*.

* FIXED: Removed incomplete reference to library('overview.hlp').

* FIXED: Stop combobox browser from scrolling after a loc-still.

* UI: PceEmacs: swapped ok/cancel buttons in M-x argument prompter.

* PORT: By default disabled non-functioning C++ interface.

* FIXED: httpd: do www_form_encode/2 on the <-path of the request to
  decode it.  This fixes the hierarchy window of the online XPCE
  maual for Mozilla (Netscape 6).

* FIXED: httpd: automatic generation of the image-map for devices.

* FIXED: Properly shutdown *and* close a socket to really free the
  file-descriptor (Unix).  Especially required for the httpd library.


VERSION 5.1.5
=============

* ADDED: Allow controlling the frame<->colour_map through a class-variable.

* ADDED: Honour `verbose' prolog flag to suppress the banner if this flag
  is `silent'.

* FIXED: sh script error in FN script, making build fail on many Unix
  platforms (FN was ported from csh to sh in 5.1.4).

* ADDED: Handling of GNU-Emacs compliant mode-specification on first line
  of the file using -*- Mode -*- or -*- mode: Mode; ... -*-.  Other variables
  are (still) ignored.

* ADDED: Hook into prolog_edit:select_location to use GUI when running from
  the GUI.

* ADDED: PceEmacs: prolog mode: handle :- multifile directives.

* ADDED: (Finally ...) indication of default-button in default X11
  openLook style.

* FIXED: PceEmacs: Enable timed auto-colouring after ->paste

* ADDED: PceEmacs: language mode: ->insert_file_header.

* FIXED: `text_item->clear' sets <-print_name to '', so the item considers
  itself not modified.

* ENHANCED: Stop wheel-mouse from scrolling windows that have no scrollbar
  (introduced extra optional argument to `window->scroll_vertical' and
  `window->scroll_horizontal').


VERSION 5.1.4
=============

* ADDED: Wheel-mouse handling for Windows (tested on '98)

* FIXED: Install the GUI tracer 16x16 icons (Unix version), reported by
  Frank Schilder.

* FIXED: Clip-handling on Windows, notably using class win_printer.

* FIXED: Line-texture (dashes, etc) in Windows NT/2000.  Slightly enhanced
  and documented shortcommings in Windows 95/98/ME.

* FIXED: Problem in finder (opening files) due to the modified type
  checking in frame->return.

* PORT: Fixed handling of --with-jpeg=<dir> and --with-xpm=<dir>.
  Thanks to Brad Knotwell.


VERSION 5.1.3
=============

* ADDED: `Edit preferences' item in XPCE manual tool for direct access to
  various preferences files

* ADDED: Make class dialog_group react properly on the existence of a
  <-layout_manager.

* FIXED: `arc<-start', and `arc<-end': crash.

* PORT: Fixed old demo(chess) program to run using GNU-chess.  Only
  tested on the basic responses!

* MODIFIED: `@pce <-operating_system' now returns one of win32, win95
  or winnt on Windows system rather then just the fixed win32.
  @pce<-window_system returns `windows', regardless of the version.

* ENHANCED: Program around 8x8 brush-size limit for DOS-7 based windows
  system (95,98,ME, ...).  Smaller brushes are enlarged automatically,
  while filling rectangular areas using larger brushes is performed
  `by hand'.

* MODIFIED: Moved call to ->unlink *before* releasing assoc and hypers.

* ENHANCED: `frame->return' and `frame<-confirm' type-check to unchecked,
  so Prolog terms can be returned using this mechanism.

* ADDED: text_margin->event to handle the fragment selection.

* FIXED: Placement of scrollbar on editor when attaching a margin to an
  open editor.

* ADDED: `code<->debug_class: service' to hide everything executed by a
  code object from the tracer.  Used by PceEmacs, Visual Hierarchy and
  Inspector to hide idle events and changes-tracking from the Prolog
  debugger.

* FIXED: Avoid possibility of last-window variable (in evt/event.c) to
  become invalid.

* ADDED: library(file_item) the method file_item ->browse to start browsing
  using @finder.

* ENHANCED: Displaying sequenced of modal windows and input-focus handling
  (X11 version).

* FIXED: Error message on `class_variable->value' when passing an illegal
  value.

* MODIFIED: Organisational issues in PceEmacs: renamed class emacs_window
  into emacs_frame.

* FIXED: Type-error in manual tools: man_button_fragment ->initialise:
  Argument 4 (object): `object' expected.

* FIXED: Honour colour of `text_item<-value_text'.

* FIXED: Added *-> to meta-predicates for PceEmacs cross-referencer.

* FIXED: Win32: `box->fill_offset' for boxes displayed on sub-devices.

* PORT: Better diagnosis for libXpm and libjpeg and their headers in
  configure, helping users to fix incomplete or broken installation
  environment.

* ENHANCED: Error recovery sending messages to broken objects.

* FIXED: X11 version: problem when freeing colour objects in use by the
  graphical engine.

* ENHANCED: library(find_file), class file_item not to show . and ..

* FIXED: Crash, notably related to keyboard events destryoing the window
  on which the event happened.  Reported by Lyosha.

* PORT: Fixed vsscanf portability problems in src/ker/goodies.c.  Thanks to
  Gertjan van Noord.

VERSION 5.1.2
=============

* ADDED: library(gradient) defining class gradient for making gradient
  fill-patterns.

* MODIFIED: Images are only turned read-only if a named image is created
  from a data object.

* ADDED: Handling of HSV colour model.  See `colour->initialise'.

* FIXED: Allow .bm (old X11 bitmaps) the contain CRLF rather than plain
  LF for correct loading on Windows/Unix corrupted files.

* FIXED: Include dialog/bitmaps files in the Windows distribution.

* MODIFIED: PceEmacs user-init file changes from ~/.pceemacsrc to
  user_profile('pceemacs.ini') on Windows.

* FIXED: Modal window handling, especially for transient windows.  A transient
  modal window is now by defailt placed on the top-left of the parent window.

* FIXED: Maintain and handle directory in Windows file-finder (bug introduced
  while starting to use the standard GetOpenFilename()).

* ADDED: PceEmacs: Added the (fairly experimental) HTML, SGML and XML modes
  to the standard library.

* FIXED: Make GUI-tracer use library(prolog_predicate_item), avoiding
  a name-clash with private variation of this library.

* FIXED: Effectively block recursion handling keyboard events in
  `window->event'.

* ADDED: `window->normalise': optional mode-argument to allow normalisation
  in only one direction.

* FIXED/ADDED: library(pce_toc), class toc_window: improved normalisation
  handling.  Also added handling of HOME, END, PageUp and PageDown buttons.

* ADDED: `tree->root' extra optional argument `relink' to allow adding a
  new root above the current one.

* ADDED: `directory->same', analogous with `file->same'.

* ADDED: Lots of extras to the class win_printer, providing printing
  support in Windows.  Added this to PceDraw.

* FIXED: Add extension on Windows display<-win_file_name

* FIXED: Handling of recent-file menu in PceDraw.

* FIXED: Class text_buffer generation when making first change was not
  incremented, causing colourisation inconsistencies.

* ENHANCED: PceEmacs Prolog mode \C-l only to re-colour the buffer if
  it was modified.

* ADDED: Mode help for Prolog mode in PceEmacs

* FIXED: Some problems in `text_buffer<-skip_comment', operating backwards.

* ENHANCED: Various Prolog Mode layout problems if there is comment in the
  clause.

VERSION 5.1.1
=============

* ENHANCED: User Guide

* ADDED: plot library

* UPDATED: The XPCE/Prolog User Guide.  Please check the home-page.

* ENHANCED: Win32: Use same bitmap-scaling as the X11 version.  This produces
  much better results than the MS BitBlt() operations.

* FIXED: Win32: Various issues in colour-handling.  Properly distinguish
  between palette usage and direct RGB, fixing colour distortion on
  high- and true-colour displays and added proper colormap support to
  the windows port of XPM 3.4k.


VERSION 5.1.0
=============

* LICENCE: GPL-2

* Integrated with SWI-Prolog 4.0.0 package building schema.

* FIXED: Avoid crash in Postscript generation from text-objects containing
  non-ISO characters.  Thanks to Matthias Trautner Kromann.

* INSTALL: Added NMAKE makefiles for building and installing in Windows.

* ADDED: SWI-Prolog GUI tracer to standard installation for SWI-Prolog.

VERSION 5.0.11
==============

* FIXED: PceEmacs: Prolog colourising could get into a loop.

* ADDED: Support for writing .GIF files

* ADDED: `date->advance', moving date objects forwards and backward
  in time.

* ADDED: `char_array <-base64_encode' and <-base64_decode supporting
  rfc-2045 conform base-64 encoding and decoding.

* FIXED: Crash in `graphical <-abolute_position' if the receiving
  graphical is not displayed on the provided device (now fails).

* ADDED: `pixmap <-convert' to deal with graphicals and files.  Graphicals
  used to be indirected over class image, resulting in a black-and-white
  pixmap after an unnecessary and expensive intermediate conversion.

* MODIFIED: PceEmacs Prolog mode never to move the caret on automatic
  checking launced by typing a full-stop.  Also singleton-replace mode
  is now only activated on explicit request.

* MODIFIED: Call toc_window (from library(toc_window)) to use ->normalise
  on the window after expanding a node and to provide a horizontal scroll_bar
  by default.

* ADDED/FIXED: Proper support for long (word-)wrapped lines in class editor.
  This allows for normal modern `textarea' using `editor->wrap: word'.

* FIXED: Class key_binding to fetch <-saved_column on ->cursor_up and
  ->cursor_down.  MODIFIED: class key_binding now uses <-up_down_column
  to find the desired `context' column rather then <-column.  This allows
  a class to do close cooperation between <-up_down_column and the
  cursor movement without using the generic <-column method.

* ADDED: `editor<->wrap', delegating to the <-image.

* ADDED: Support writing jpeg files on systems running 24 or 32 bit
  colordepth (X11 version).

* ADDED: Lots of stuff to the HTTP server libraries including fairly
  complete manual server as demo.  Also documentation for the html_write
  library.

* FIXED: Deleting part of a tree that is zoomed (Paul Holmes-Higgin).

* FIXED: correct building of xpce-install through different routes.

* ADDED: `chain<-sub': return sub-chain using range of indices.

* FIXED: term-representation of class get_method.

* FIXED: PceEmacs Prolog colourising mode: errornous non-determinism when
  colouring DCG rules, leading to very poor performance.

* FIXED: distribution of table-slices with `table->width' not to negotiate.

VERSION 5.0.10
==============

* ADDED: Library 'http/httpd' for a HTTP daemon skeleton: make your XPCE
  process drive your browser!

* FIXED/MODIFIED: `node->for_some' and `node->for_all' to traverse the
  node<-sons before executing the code on the node itself.  This allows
  for removing nodes without breaking the consistency of the tree.
  Thanks to Paul Holmes-Higgin.

* ADDED: Class bezier_curve: both Quadradic and Cubic Bezier curves.

* ADDED: `point<-mid: point -->point' to find the point in the middle between
  two points.

* MODIFIED: `dialog_group->reference' is now equivalent to
  `graphical->reference', rather then `device->reference' for proper
  integration with dialog items.

* ADDED: `image->save' to allow saving in a source_sink object, so image
  data can be written to memory buffers.  Only works for jpeg en pnm formats.

* ADDED: @pce->debugging_subject to allow using pcedebug/1 from user code.

* FIXED: More graceful handling of term-expansion errors, especially
  useful for the on-the-fly cross-referencing PceEmacs.

* ADDED: `date<-rfc_string' to return date in RFC compatible format

* FIXED: Moved dialog-grid (<-above, etc.) unlinking from class dialog_item
  to class graphical: dialog windows get inconsistent if a non-dialog item
  is deleted.

* ADDED: Allow for :- pce_end_class(Class), providing additional documentation
  and error checking.

* ADDED: Book icon to manual tool main window.

* ADDED: `image->save' support for saving JPEG files (Both Unix and Win32).

* ADDED: library(doc/html): handle <BASE> element and ignore the content
  of <SCRIPT> elements.

* INSTALL: (Unix) changed behaviour of `make install' to be equivalent to
  the old `make dv-install'.  For this reason changed the name of the
  install-program to xpce-install rather than just install.

* FIXED: Document rendering (prolog/lib/doc) to pass table_cell options
  properly.  Now also passes <TR> options properly.  Currently only honours
  the BGCOLOR option of a table-row.

* FIXED: Drawing background of tables if <-border = 0.

* FIXED: Win32 native font specification to allow spaces in string
  arguments, which is needed for the face() argument.  Spotted by
  Anjo Anjewierden.

VERSION 5.0.9
=============

* FIXED: XPCE's library for the modified definition of select/3 in SWI-Prolog
  3.3.11.

* FIXED: Properly report an error when adding graphicals to a device that
  has not yet been initialised.  This fixes the case where class device
  is subclassed and the programmer omits send_super(Dev, initialise) before
  adding graphicals.

* CHANGED: pce_error/1, pce_warn/1 and pce_info/1 now all hook directly into
  the SWI-Prolog print_message/3 predicate.  XPCE message rules are added to
  the Prolog message rules.  This allows us using message_hook/3 for XPCE
  messages.

* FIXED: library(swi_prolog.pl) (editor hooks): declare message_hook/3 as
  dynamic.

* FIXED: Set CVS binary mode on documentation of classes lbox and
  resize_table_slice_gesture (crashed manual tool on Windows due to
  corrupted file).

* FIXED: `label_box->layout_dialog' corruption of @default<-name.  Mostly
  harmless but unelligant bug.

* FIXED: PceEmacs Prolog mode: typing a . at the end of the file inserts
  an additional newline after the cursor, so syntax checking can take place.
  (end-of-clause is .<blank>).

* ADDED: Allow for handling native Prolog data by methods and slots of
  type any.  This allows for passing Prolog data in messages (->for_all),
  and storing Prolog data in sheets, vectors, chains, etc.

* FIXED: Removed printing "Unknown error: 10", on typing errors.

* ADDED: Class resize_table_slice_gesture to allow user-controlled
  manipulation of row and column widths in class table.

* FIXED: BoundingBox calculation by class table using negative cell_spacing.

* FIXED: Win32: Repainting windows after removing transient windows sometimes
  failed.  Caused by frames not setting WS_CLIPCHILDREN.

* FIXED: Win32: returning absolute path for file('~/xxx') on Windows 95
  and Windows 98 (patched in the SWI-Prolog uxnt.lib library).

* FIXED: PceEmacs Prolog colouring to close the text-buffer input stream.

* FIXED: (Finally) saving the PceEmacs bookmarks on exit

* FIXED: modal transient windows not honoured if there is a focus.

* FIXED: Uninitialised data in dialog layout algorithm that could result
  in totally wrong placement.

* FIXED/MODIFIED: Deleting content from a table object now ->destroy's
  the graphicals if they are not locked.

* FIXED: Added proper message for `unresolved' types.

* ADDED: ignore-case argument to `char_array->prefix' for consistency with
  ->sub and ->prefix.

* ADDED: Syntax colouring in Prolog mode.  Lots of changes to the top  of
  the PceEmacs mode classes to deal with colourisation support.

* FIXED: `char_array->sub: text, @on' (i.e. case-insensitive substring match)

* ADDED: `table_slice->displayed' to temporarily hide/show table rows and
  columns.

* FIXED: Combining stretchability for spanned cells in tables, causing the
  table to grow/shrink as rows/columns are manipulated in the presence of
  spanned cells.

* FIXED: Colour of the underline in class text-image sometimes showing
  up wrong.

* ADDED: Support for wheel-mice.  See `event<-id' for details.  This support
  works if your windows system passes WM_WHEELMOUSE events or you are on a
  Unix/X11 system and the X-server is programmed to emit button-4 and
  button-5 events on rotating the wheel.  See the class-variable
  event.x11_wheel_mouse for details.

* ADDED: X11: added mouse button-4 and button-5 events as well as support
  for wheel-mice.


VERSION 5.0.8
=============

* FIXED: Click-stay up of popup menus that do not fit on the screen.

* FIXED: Location of pullright menus on multicolumn popup menus.

* ADDED: Optional case-sensitive argument to regex->initialise

* FIXED: Bounding box calculation for class parbox if floating graphicals
  extend below the text.

* FIXED: A few layout problems in the classes lbox and parbox.

* ADDED: X11 version: support for masked frame-icons.  Default frame-icon is
  now the same as for the Windows version.

* ADDED: Support for loading transparent .GIF image files.

* FIXED: SWI-Prolog help interface for syntax errors on `explain'.

* FIXED: library(compatibility/resource) to handle resources correctly
  if demand-loading traps loading another file while loading a class.
  This notably leads to trouble if PceEmacs is demand-loaded on an error
  inside a class.

* FIXED: `dialog_group->size: @default' (had no effect).

* FIXED: Error message printed from failing goals in pce_global/2.

* ADDED: library(http_client) to fetch HTTP headers and data.

* FIXED: Win32: allow for `timer->free' from `timer->execute'.

* FIXED: reading hot-spot info from XPM images in the Windows version.

* PORT: Support -D_REENTRANT on Solaris 2.5 (Patch by Frank Cornelissen).

* FIXED: Various details around event processing of text_item objects.

* ADDED: `socket->connect' to be no-op rather then error if socked is
  already connected.

* UPDATE: Updated getdate package with new version.  Now able to handle
  HTTPD time format.

* FIXED: `text_buffer<-scan_syntax' to deal properly with the 0'<char>
  syntax of Prolog.

* FIXED: `chain_table->add' to add only if not already part.  Thanks to
  Lourens van der Meij.

VERSION 5.0.7-beta-5
====================

* FIXED: line-attributes for underlined text in editors.

* FIXED: Update problem with (dis)appearing scrollbars of the content of a
  window depends on its size.

* ADDED: `table_column->for_all' to iterate over the cells in a table-column

* FIXED: Locking atoms against the Prolog atom garbage collector (SWI-Prolog
  3.3.0).

* MODIFIED: Class vector to distinguish between size and allocated size.

* FIXED: `style <-underline' and similar attributes.  Returned @on on
  all attributes if any of the attributes was set.

VERSION 5.0.7-beta-4
====================

* ADDED: Experimental document-rendering classes (undocumented):
  hbox, lbox, tbox, grbox, parbox and rubber.

* ISO: Avoid instantiation errors on =../2; replace concat/3 using
  atom_concat/3 and deal with syntax errors in PceEmacs
  pce_insert_require_directive and friends.

* FIXED: Font metrics error (X11 version).

* ADDED: Symbol font to standard font list and `symbol' font alias.  See
  FontViewer demo.

* FIXED: `editor->cut' to ensure the selection is cleared after cutting.
  Reported by Peter Mott.

* ADDED: Class chain_hyper to express mutual dependent objects.

* FIXED: Removed limits on # rows/columns of devices with a format object
  attached (used to be 1024x1024).

VERSION 5.0.7-beta-3
====================

* ADDED: Class variable text_item.combo_box_heigth to define the maximum
  height of completer/combox box windows (default 6).

* FIXED: Sometimes wrong assumption of control-key in XPCE editors (notably
  after incremental search.

* FIXED: `@pce->console_label' to deal with renamed console.dll --> plterm.dll

* FIXED: `image->draw_in' for selected graphicals.  Reported by Frank
  Cornelissen.

* FIXED: `editor->sort_lines_in_region': memory handling problem (sometimes
  crached).

* FIXED: `image->save', opening file in wrong mode.  Patch by Frank
  Cornelissen.  Thanks.

* FIXED: `editor->save_buffer' caused crash if an error occurred during
  writing the file.

* FIXED: `file<-read' on Windows for not-so-large files and Unix for
  truely large files.  Also a lot faster now.  Reported by Bob Wielinga.

* FIXED: Various ISO Prolog compatibility issues.

* FIXED: Take care of module-local operator specifications.  Fixes problems
  with autoloading.

* ADDED: Generated files to the source-distribution to allow for recompiling
  under Windows.

* ADDED: --enable-mt configuration option to provide rudimentary support
  for multi-threading.  Supports pceMTLock(int lockid) and
  pceMTUnlock(int lockid).  Requires thread-safe version of the X11 libraries.
  Used for cooperation with the multi-threaded SWI-Prolog version.

VERSION 5.0.7
=============

* ADDED: Compatibility to SWI-Prolog 3.3.0 (More ISO stuff)

* ADDED: `vector->for_all' and other vector-iteration methods now accept
  optional `from' and `to' to limit the range and/or enumerate backwards.

* ADDED: `chain->for_all' and other chain-iteration methods now pass the
  index of the current element in @arg2 for compatibility to class vector.
  Suggested by Uwe Lesta.

* FIXED: `vector->insert' (reference-count problem). Thanks to Uwe Lesta.

* FIXED: documentation of `list_browser->select_message'.  Thanks to
  Laurens van der Meij.

* FIXED: spypce(class<-getmethod).  Thanks to Uwe Lesta.

* FIXED: Added resource declaration to the kangaroo demo.

* FIXED: pce_pre_expand/2 to handle pce_pre_expansion_hook/2 if it returns
  a list.  Thanks to Uwe Lesta.

VERSION 5.0.6
=============

* PORTABILITY: Integrated many patches for compilation using egcs-1.1.1 on
  DEC/Alpha running OSF/1 4.0.  Most general 64-bit problems detected by
  the compiler.

* FIXED: Updated INSTALL.notes to be the same as the much more up-to-date
  INSTALL.src from the distribution directory.

* FIXED: drawing transparent text in Windows metafiles.  It appears diagrams
  can be properly transferred to Office 97 and compatible applications using
  the `EMF' format.  EMF is now the default format for PceDraw.

* FIXED: reporting errors for type-errors on var-arg methods.  Thanks to
  Lourens van der Meij.

* FIXED/MODIFIED: If a popup is appended to another popup (for creating
  a pull-right-menu), the `menu_item<-value' of the created menu-item
  is now the <-name of the popup rather then the <-label.  This makes
  <-member work consistent.  Reported by Lourens van der Meij.

* FIXED: UserGuide section on using hyperlinks.  Thanks to Uwe Lesta.

* FIXED: Various cleanup, adding declarations, etc. to get the XPCE/Prolog
  library running under SICStus.

VERSION 5.0.5
=============

* FIXED: Path-canonisation in class directory (could yield incorrect value).

* FIXED: `graphical ->resize' to invoke the method ->do_set, rather then
  bypassing message passing.  Thanks the Uwe Lesta.

* FIXED: catching initialisation exceptions better.

* FIXED: `editor->align_region' to honour default column correctly.

* FIXED: PceEmacs: Show bookmarks in Windows version.

* FIXED: Spying prolog-implemented methods that are called using
  sendSendMethod() (e.g. ->initialise).

* FIXED: handling grayscale JPEG images correctly.  Thanks to Bob Wielinga.

* FIXED: Win32: Added -f none to running Prolog during the installation to
  avoid problems with user's ~/.plrc file.  Thanks the Uwe Lesta.

* FIXED: Win32: Detection of `menu' key-event.  Caused problems on ALT-Gr.
  Thanks the Uwe Lesta.

VERSION 5.0.4
=============

* MODIFIED: If an object is freed, all hypers are sent ->unlink_to or
  unlink_from methods before calling the class's ->unlink method.

* ADDED: New bookmark utility to PceEmacs, preserving your bookmarks over
  multiple sessions.  Pretty alpha, but as it is at least as good as the
  old and doesn't affect the overall stability it has been put into this
  version.

* ADDED: `date <->posix_value' to access a date object as a POSIX time-stamp.

* ADDED: `node->sort_sons' to sort the sons of a node in a hierarchy
  according to user-defined comparison code.

* ADDED: `toc_tree <-selection' to return chain of selected nodes.

* FIXED: toc_image<->image was defined twice as a send-method.

* FIXED: Redraw of selected lines in editor/browser if width changed (notably
  if a scrollbar is attached/detached.

* ADDED: library(toolbar) to deal with toolbars and buttons displayed on them.
  This library has been in use with in-house applications for quite some
  time.

* FIXED: Use TIOCSCTTY to set the controlling terminal if available.  This
  fixes job-control when running (for example) an interactive shell under
  class process.  Unix, bug discovered under Linux 2.2 using glibc 2.0.

* FIXED: `graphical ->flash' (X11 version) for truecolor and directcolor
  displays.

* FIXED: `type<-convert': validate the return-value of the class' <-convert
  method.  Notably avoids illegal conversions by `object <-convert'.

* FIXED: In XPCE version 4, methods could be redefined using
  pce_extend_class/1.  Method from templates could also be redefined.  This
  possibility was lost in version 5 due to the modified class compiler.  It
  is back again in the above described situations.  Redefinition will fail
  in all other situations, which are reported by running checkpce/0 after
  loading your program.

* MODIFIED: General cleanup and UI improvement of (list-)browser:
	DELETED:  list_broswer->select_middle_message
	MODIFIED: Argument forwarding.  Both ->open_message and
		  ->select_message now forward the current selection.
	ADDED:	  multiple-selection using shift cursor up/down.
		  multiple-selection using shift-drag
		  more conforming selection handling.

* ADDED: `gesture->drag_scroll' to make a gesture scroll the window if
  the pointer is dragged outside the window.

* FIXED: Detection of double-clicks using WM_?BUTTONDBLCLK rather then
  internal timing.  Provides better compatibility and makes XPCE compatible
  to the ICA client protocol for use with Citrix MetaFrame.  After a couple
  of days testing, XPCE/SWI-Prolog appears to be fully functional.  Tested
  using Windows NT 4.0 Terminal Server (SP3)/Critrix MetaFrame 1.8, clients
  under Windows NT 4.0 and SuSE Linux 6.0.

* FIXED: `event <-clone': do not clone <-receiver and <-window.

* FIXED: Recursive calling of the readline interrupt handler, usually
  if an interrupt is generated while an XPCE confirmer is active.

* FIXED: Regex interface for SuSE 6.0 (conflict with library).  Unclear
  whether this is caused by glibc, ld or ld.so.

* FIXED: `editor ->fill'.  Ensure termination.

* FIXED: Class editor incremental search: handle 8-bit characters ok.

* FIXED: PceDraw problem with text objects, related to an incompatibility
  in use_class_template: it is no longer supported to define methods for
  methods that are already in the template.  The compiler should be
  modified to give an error in this case.

* FIXED: text_buffer comment detection: skip over quoted strings.

* ADDED: `text_buffer ->for_all_comments' to support colourisation of
  comments based on the syntax table.

* ADDED: xpce/src/msw/mkxcolours to generate the X-colour database
  automatically.  The old file had some dark ... colours missing.

* ADDED: manpce/0: Tools/Event viewer to examine the events generated
  by user interaction.

* ADDED: Win32: set shift/control/meta information in events for keyboard
  related events, so one can detect shift-cursor-left, etc.  Spotted by
  Uwe Lesta.

* ADDED: various details to PceEmacs modes (to improve sharing with
  functionality under development).

* ADDED: `text_buffer <-skip_layout' to skip blank space

VERSION 5.0.3
=============

* MODIFIED: PceEmacs M-x visit_tag_table to check automatically for parent
  directories that have a TAGS file if the current directory doesn't have
  one.

* FIXED: Unix version `process->open' to skip pseudo-ttys for which the
  slave-side cannot be opened.  This used to stop starting tty-bound
  processes if an application had left the tty of choice in a bad state.

* FIXED: Redraw problem with Windows-buttons if it is the default problem.

* DELETED: `@pce<-method_calls'.  Using the new message passing it is
  hard to get accurate readings for this.

* ADDED: Allow for interception of undefined errors using the
  @pce<-exception_handlers.  This simplifies the design of international
  applications as well as user-defined errors.

* ADDED: Redirected all translation of names to labels to call
  `name<-label_name' explicitely.  This allows for central definition
  of multi-lingual translation.

* FIXED: Consulting examples from the online manual.  Thanks to Uwe Lesta.
  Also fixed a syntax error in the `counting' example.

* FIXED: Execute pce_class_directive/1 while loading a saved-state if the
  directive appears in :- pce_extend_class environment.

VERSION 5.0.2
=============

* FIXED: Win32: DDE-handling of edit(File) mapped to edit(file(File)), so
  it doesn't edit other things.

* FIXED: Printing error message for error(argument_count) (i.e. send(@pce,
  succeed, doit).

* FIXED: type unchecked to accept prolog_term.

* FIXED: avoid the creation of explicit instances of class prolog_term.

* ADDED: documentation for `host_data ->initialise'.

* FIXED: Inspector to deal correctly with instances of prolog_term.

VERSION 5.0.1
=============

* FIXED: type->specialised produced incorrect result on not-yet-realised
  class-types.

* FIXED: Saved-states refused to start if they could not find the XPCE
  home directory.

* FIXED: Dropping PceEmacs file-prompter too early.  Found by Seth Greenblatt.
  Thanks.

FINAL 5.0.0 RELEASE
===================

* ADDED: Support to create RPM (Redhat Package Manager) distribution:
  make rpm-install and the RPM package specification file xpce.spec

* MODIFIED: `device->selection: chain' now converts all members of the
  chain to type graphical.  This makes `tree->selection: chain-of-nodes'
  work as expected.

* ADDED: Error <->report: throw to make an error raise a Prolog
  (host-language) exception.

* ADDED: `regex ->file_pattern' to easily define regular expressions
  representing (Unix csh) file-patterns.

* FIXED: PostScript image rendering details: rounded horizontal
  scaling: old code rounded the image width up to the next multiple
  of 8 pixels.

* ADDED: PostScript generation for tree objects displayed using the
  `list' representation: connecting lines and open/close images.

* ADDED: PceEmacs prolog-mode: completion on M-. (find-definition).

* ADDED: `chain ->sort': optional `unique' argument to remove duplicates
  from the chain.

* FIXED: `text_buffer <-matching_quote' to deal properly scanning
  Prolog quoted strings like `can''t do that' backwards.

* ADDED: Possibility to relate nodes (using node->son) before attaching
  them to a tree.

================================================================
= Preparing for new message-passing			       =
================================================================

* MODIFIED: If an object as an implementation for <->catch_all the
  kernel no longer raise no_behaviour error.  Instead, the method itself
  should generate a warning to indicate it is not willing to accept the
  message.

* DELETED: class class_stub, once experimentally introduced to deal
  with class-autoloading.  Now obsolete.

* DELETED: `vmi->parent_goal'.  This mechanism harms any potential
  optimisation too much.

* MODIFIED: @reportee is now a chain of visited canditates (used to
  avoid delegation loops).

* MODIFIED: object->update_constraints is now only invoked automatically
  on graphical objects that have their <-area changed.  For all other
  cases, an explicit call to this method is required.

* FIXED/MODIFIED: text->string now copies the string if the argument
  has a different reference, instead of just testing for equality of
  the contents.

* DELETED: class delegate_variable, dealing with delegation that
  required a wrapper.  Unnecessary complicated message-passing, with
  little befinits that can't be achieved using catch_all.  Class text
  and text_item, using these, have been modified using <->catch_all.

* MODIFIED: use_class_template is now only available as a directive
  inside a class definition.

* MODIFIED: no longer pushes @receiver and @receiver_class variables.

* ADDED send_class(Receiver, Class, Message) and
	get_class(Receiver. Class, Message, Result)

================================================================

* FIXED: `file->name' removed file instead of renaming it!  Now also
  dynamically checks for HAVE_RENAME instead of testing __unix__
  expandFileName() function has been redefined to avoid overwriting the
  buffer (and make this thread-safe).

* ADDED: popup->append: gap to attach a line (end_group) with the previous
  item.

* FIXED: Unix handling of process-status change (handled from SIG_CHLD)
  to merge message properly in the event-queue instead of performing
  an asynchronous message-invocation.

* FIXED: `pce->die' to call the <-exit_messages in `safe' mode.  Could
  cause a crash if running an exit-message destroyed the message.

* ADDED: `frame ->attach_transient' and `frame ->detach_transient' methods
  to monitor transient frames.

* ADDED: `device ->layout_dialog' to deal with dialog_item<-ver_stretch

* ADDED: Class tab_stack to make the stack as wide as required by the
  labels (There should be more options: multiple-rows, scroll).

* ADDED: `text_image ->background' to change the background of editors.

* FIXED: pcePP signal-handling to restore all state.  Leads to
  segmentation-faults in SWI-Prolog/XPCE on machines doing memory-mapped
  stacks and using sigaction() (Linux, Solaris for example).

* FIXED: silently ignore personal initialisation file if present

* ADDED: `table_cell <->note_mark' to attach a little mark in the top-right
  corner of the cell.

* FIXED: Updating the send/get cache table on reloading a class.

* ADDED: `display_manager->redraw' as an explicit method call to allow
  hooking into XPCE's redraw main-loop.

* FIXED: Windows 95/98 handling of input from sockets.

* FIXED: added resetDispatch() to deal properly with breaking out of a
  confirmer or otherwise interrupting XPCE while waiting for an event.

* FIXED: various minor issues to make the Prolog debugger work naturally
  again.

* MODIFIED: `editor->next_line' automatically adds new lines to the buffer
  when going down past the end of the file if <-editable equals @on.

* FIXED/MODIFIED: `dialog_group->label_format: top,bottom' was implemented
  the other-way around.  Fixed.

* ADDED: `dialog_group->label' to allow for image labels.  Also allow
  for `dialog_group->label_format: hot_spot', which allignes the hot-spot
  of the image with the box of the dialog-group.

* FIXED: Win32: Client sockets to deal properly with releasing the
  associated Windows resources.

* FIXED: PceEmacs: improved implementation of ->align_close_bracket.

* ADDED: `Button ->executes' invokes the (new) method ->forward to actually
  perform the desired action.  ->execute acts as a wrapper dealing with the
  visual feedback.

* ADDED: `table->sort_rows' and optional range-limitation arguments to
  `vector->sort'.

* ADDED: library(pce_toc): ->son now also accepts a node as argument.
  The Id may be @default, making the node it's own id (modified in
  `toc_node->initialise'.

* FIXED: Win32 fonts: force the use of TrueType fonts for the default
  fonts to improve MetaFile (WMF/EMF) generation.

* ADDED: Win32: `font <-x_name' is now initialised to the Windows
  fontface name for the default fonts.  Debugging support only.

* ADDED: Win32: Completed coverage of the Win32 font attributes.

* ADDED: `directory <-roots' to find the logical drives on a Windows
  system.  Also added an interface for this in library(find_file) and
  an icon in bitmaps/16x16/drive.xpm.

* FIXED: Win32: directory('D:/foobar')<-parent yeilds D:/ instead of D:

* FIXED: `frame ->label' with two arguments (Win32 version)

* FIXED: included `region' PostScript commands as dependency for clear.

* ADDED: `text ->underline: Bool': allow for underlined text objects.

* ADDED: PceEmacs: M-x comment_region

* ADDED: A list passed from Prolog is nor translated into a code_vector
  of objects.  Class code_vector is used to achieve compatibility for
  the new way of passing a variable-argument list to a method as well
  as to avoid garbage-collection suprises, as code-vector do not change
  the GC status of the objects they reference.

* ADDED: `chain <-convert: vector --> chain' to automatically convert an
  array into a linked list.

* ADDED: `object ->update_constraints' to deal explicitely with constraint
  handling.

* ADDED: `@pce ->catch_error: @default' to trap *any* error.  See also
  pce_catch_error/2.

* FIXED: PceEmacs double-beep on some cases, as well as double-prompt for
  saving buffers sometimes.

* MODIFIED: Prolog interface
	# Module information for the classes message and ? (obtain) are
	now kept in message<-context and ?<-_context, rather than tagged
	to the name.  Same holds for the new class rc, handling resources.

	# send/2 and get/3 now can handle the arguments as arguments to
	the selector.  Thus, the following is identical:

		send(Dialog, append, button(quit)),
		send(Dialog, append(button(quit))),

* MODIFIED/COMPATIBILITY Complete rewrite of class resource and anything
  related to it.  The functionality has been taken over by class
  class_variable.  Consequences:

	* Renamed methods

		Old				New
		======================================================
		object<-resource_value		object<-class_variable
					     or object<-Name
		class<-resource			class<-class_variable
		class->resource			new(_, class_variable(Class,
		class<-resources		class<-class_variables
		display<-resource_class		<deleted>

	* Modified methods

		+ display ->initialise: address=name
			Lost `resource_class' argument

	* Display term description is now display(address)

	* Class Definition

		resource(Name, Type, Default, [Summary])

	  is now

		class_variable(Name, Type, Default, [Summary])

  Defaults are now in the file <pcehome>/Defaults.  Syntax has changed.
  Lines now read:

	<class>.<class_variable>:	<value>

  For saved-states, the system first attempts to read rc('Defaults', pce).
  if this resource cannot be found, it will try the file named above.

* ADDED: object->delete_hyper calls from `hyper->unlink' are now real
  methods calls, so they may be refined.  Suggested by Jelmer Jellema.

* MODIFIED: Macro Definition mechanism for PostScript generation.  The file
  <pcehome>/postscript/pce.ps is no longer used.  See `graphical <-postcript'
  for the current mechanism used.

* IMPROVED: `object ->delete_attribute' now deallocates the object extension
  if the last attribute is deleted.

* MODIFIED: `Editor->load' now checks for write access of the file.  If not
  present, it will automatically turn the editor into read-only mode.

* ADDED: Editor isearch: remember displayed status of caret, so it can be
  restored to the same state afterwards, and send(Editor?text_cursor,
  displayed, @off) becomes an effective way to get rid of the caret.

* FIXED: Editor backward isearch (extend-to-word) to extend in the proper
  direction.

* FIXED: Pce.Circle.selection_handles: sides.  Thanks to Peter Mott.

* MODIFIED: Added class source_sink as super-class for objects that represent
  some form of byte-stream: char_array, file, text_buffer.  Consequences:

	* `file <-object' has moved to `source_sink <-object'.

* FIXED: `file <-read' now can deal with binary files that include the 0-byte.

* FIXED: byte-order problem in socket->bind, registering the address.  Found
  and patched by Frank Cornelissen.  Only applies to little-endian machines
  (Intel).

[VERSION 4.10.1]

* FIXED: Using XPCE objects in Prolog streams: report IO-error if the object
  was freed.

* ADDED: (WIN32) Window <->win_handle to get the window handle from an XPCE
  window or use an XPCE window for `subclassing' an existing MS-Window.

* FIXED: (WIN32) opendir() emulation if the accessed directory doesn't exists.
  Could cause a crash, notably occurring in `directory->scan'.

* ADDED: `popup->active' now works for popup-menus in a menu_bar (old version
  required `menu_bar ->active_member').

* FIXED: Honouring the active flag in popups by class menu_bar.  Thanks to
  Jelmer Jellema.

* FIXED: `emacs_mode_menu <-lookup' to avoid loosing part of the mode menu
  if there are user extensions.

* WIN32: xpce\lib\x11.crs data moved into src/msw/xcursors.c: faster startup,
  preparation to remove dependencies on runtime files.

* WIN32: xpce\lib\rgb.txt data moved into src/msw/xcolours.c: faster startup,
  preparation to remove dependencies on runtime files.  Also modified the
  colour demo to use @colour_names if it can't find the X11 colour database.

* Preload ms_left_arrow.bm as @ms_left_arrow_image to remove dependency on
  this file in the Windows version.

[VERSION 4.10.0]

* ADDED/MODIFIED: `dialog ->width' and `dialog ->height' to work like
  `dialog ->size'.  `dialog -size_given' is now one of none, width, height
  or both instead of a boolean.  Also changed: if the size is determined
  on the basis of the Pce.Dialog.size resource, -size_given will not be
  changed.  This implies that filling an empty dialog after opening, followed
  by a ->fit will actually layout and fit the dialog window.

* ADDED: PceEmacs: moved M-x prolog_manual from Prolog to language-mode, so
  the manual can be accessed easily while writing C/C++ code

* FIXED: `file <-character' to return a character 0<=char<=255.  Reported
  by Bob Wielinga.  Same for `char_array <-character'.

* FIXED: Win32: redraw on Windows 95 after iconify/deiconify.  Problem
  reproduces poorly, but notably when dealing with hierarchies.  Probably
  timing related.  Thanks to Jelmer Jellema.

* ADDED: Classes layout_manager, layout_interface, table, table_slice,
  table_column, table_row, table_cell: Generic interface for associating
  layout managers to graphical devices and realisation of HTML-3 like
  tables (tabular layout) in this framework.

* INCOMPATIBILITIES: The old class `table', representing a relational
  database-like table has been renamed to relation_table.  Code using
  this should be modified.

* ADDED: library(pce_set_item): check for adding duplicates using the new
  method `->check_duplicate'.

* ADDED: `char_array <-strip' for deleting and cononising blank space in
  char_array objects.

* MODIFIED: library(editable_text) ->loose_focus renamed to ->release_focus
  for better consistency.

* FIXED: text objects holding an empty string now have zero-width (actually,
  2 times the <-border).

* FIXED: if a format is attached to a device, align the graphicals using
  ->do_set, rather than ->set.

* MODIFIED: `vector->element'.  `Gaps' are filled with @nil, instead of
  @default.

[VERSION 4.9.7]

[#3]

* ADDED `image<-rotate' for Windows 95.  Now uses same algorithm for NT,
  as it produces clearly better results.

* FIXED: displaying boxes with negative <-width or <-height.

[#2]

* FIXED: Displaying 3-d rectangles with radius > min(w,h)/2 (Unix/X11 version)

* FIXED: Displaying windows on tab objects (Unix/X11 version)

* FIXED: Avoid r_complement() for drawing `selection-bubbles' on graphical
  objects.

* FIXED: CtoNumber(), which could raise the error `number->initialise has
  1 argument'.  This function was incorrectly called on evaluation of
  expressions in the Windows version.  The error lead to performance
  degradation and sometimes crashes when using (for example) expressions
  on places where an integer was expected (send(Box, width, Box?height*2)).

* ADDED: -assert nodefinitions to the LDSO flags for SunOs 4.1.x, which
  sometimes incorrectly reports unresolved symbols when linking pl2xpce.so

* ADDED: Big warning in configure if -lXpm cannot be found.

* FIXED: SunOs 4.1.x/X11R4 detection of -lXpm and -ljpeg libraries failed
  due to a bug in SunOs ld.  Fixed by removing -lXt from the libraries to
  test -lXpm and -ljpeg.

* ADDED: Various libraries:

	library(pce_arrow_item)		Show/define arrow-head
	library(pce_config)		Configuration access
	library(pce_configeditor)	Edit configurations
	library(pce_graphical_browser)	Browse graphicals
	library(pce_image_browser)	Find images
	library(pce_image_item)		Show/browse image
	library(pce_set_item)		Edit set, based on editor for single

* PCEDRAW: many changes: added export of drawings as Prolog term, interface
  to the configuration library, new format for prototypes, which are now
  saved with the image, etc. etc.

* ADDED: `path ->points' and an optional additional argument to
  `path->initialise' for specifying the points as new() arguments.

* FIXED: push_operators/pop_operators to deal with op(Num, Kind, ListOfAtoms).

* FIXED: reentrance in rewindAnswerStack(), which may be caused
  by exception-handling and unlink-handling during a free invoked by
  another rewindAnswerStack().  Thanks to Heddrik van Rijn for providing
  me with a program to reproduce this error, which may leave the system
  with an illegal answerStack, causing an infinite loop of crashes.

* FIXED: Win32 `frame->geometry' for WxH-x-y, position relative to the right
  edge of the screen.

* FIXED: Win32: realise XPCE's pallete before `image->draw_in' and
  similar operations.

* ADDED: Win32 colour garbage-collection.

* FIXED: sometimes no redraw after `button->label'

* FIXED: Various things around plain display of arrow instances: proper
  redraw when displayed on nested devices, automatic update on attribute
  changes.

* ADDED: Application configuration library: library(pce_config).  See
  PceDraw for an example.  The definition of the PceDraw configuration options
  is in library('draw/config.pl').  The personal X11 config data has been
  moved from ~/.Xpce has been moved to ~/.xpce/Xpce.

* CLEANUP: The Reference Manual database was cleaned to unreachable
  cards using `man_space ->delete_unreferenced'.

* ADDED: Class int_item: specialised text item for entering integer values
  with increment/decrement buttons.  The buttons themselves are added to
  class text_item (see `text_item ->style: stepper'), and may be used for
  -for example- ordinal scales.

* ADDED/FIXED: `arrow ->geometry', which now moves the arrow, rather than
  making it invalid.

* ADDED: `arrow->initialise': additional arguments for `style' and `fill'.

* ADDED: class label_box for making labeled dialog items consisting
  of multiple parts.  Used for the new implementation of font_item, making
  it much easier to understand.

* MODIFIED: `object->equal', and all its refinement will no longer complain
  if the argument type cannot be converted into the requested one, but simply
  fail.  So, send(colour(red), equal, point(1,3)) now simply fails.

* ADDED: `get' access to `colour<-kind'.

[VERSION 4.9.6]

* ADDED:  `colour->equal': test of two colours have the same RGB values.

* MODIFIED: Class tree in `list' mode.  A node will now display a [+]
  or [-] sign or nothing depending on the value of node <-collapsed.

* INSTALL: modified library(dialog/dialog) to avoid a call to
  pce_image_directory during compilation, and therefore the need to
  have access to the X11 display while (q)compiling the library.

* FIXED: Installation procedure for bitmaps.  New options have been
  added to install(.c): -d, -C and -pN to get much faster and simpler
  installation.

* FIXED: Scrollbar update for editors with incomplete last line.

* FIXED: `display <-font_alias' to call makeBuiltinFonts() first to
  ensure all system fonts are defined.

* FIXED: Win32 colour handling.  Properly handle colour-names case
  insensitivly.

* FIXED: 2nd argument of bitmap->initialise (transparent) was ignored.

* ADDED: Much better support for dynamically adding windows to an (open)
  frame.  See `window->above'.

* COMPATIBILITY: if a window is added to an open frame, the system now
  invokes ->resize to the frame, rather than ->fit.  This avoids the frame
  from resizing.  Code that wishes the old behaviour should look at the
  resource Pce.Frame.fit_after_append, or explicitely invoke ->fit after
  appending the window.

* CHANGED: removed obsolete `frame <-destroying' (now using ->unlinking
  to avoid recursion).

* UI: PceEmacs: added ->save_as to file menu.

* FIXED: figure ->_draw_postscript to deal properly with the <-radius of
  of the figure.

[VERSION 4.9.5]

* FIXED: Win32 box with rounded corners with radius > min(w,h)/2 was
  displayed as an ellipse.  Now displays as box with radius min(w,h)/2.

* GENERALISED: Arrow handling in class joint and its subclasses.  Any
  graphical can now play the role of an arrow-head, provided it implements
  the ->points method compatible with `arrow->points'.

* FIXED/MODIFIED: Changed first `term_name' of class window from `label'
  to `name'.  This fixes object/2 for windows that have no frame (and
  thus no implementation for <-label).

* FIXED: Area handling of thick lines (partial, handling of large arrows
  still needs to be fixed).

* FIXED: Painting arrows with non-nil fill_pattern and defined pen.

* ADDED: Various hooks to PceDraw.

* ADDED: support for user-redefinition of `graphical ->in_event_area'.

* FIXED: PostScript generation for text objects with border > 0 and
  alignment not left.

* FIXED: PostScript generation for lines with pen=0 and text objects
  holding no text.

[VERSION 4.9.4]

* FIXED: Adding windows to open frames.

* FIXED: key_binding reset of prefix and argument if a non-implemented
  key is activated.  Fixes `hanging' PceEmacs on \C-x\C-f\C-x\C-f.

* FIXED: `dialog_item ->left', etc. to configure items, appending them
  to a dialog later.

* IMPROVED: allow for user-abort while creating the manual index for the
  search tool.

* CHANGED: `Menu->update' now explicitely invokes `menu_item ->active' on
  all changed items, so this method may be redefined on class menu_item.

* FIXED: PceEmacs M-x find_tag command for better finding the line-numbers.

* FIXED: Now use hypers for dependency between PceEmacs hit-list and
  fragments.  This avoids the mark fragments from being invalidated.

* MODIFIED: `text->wrap: clip' (used by text_item) now shows the text as
  a single line, mapping \n, \r and \t to the paragraph sign, << and >>.
  Modified PceEmacs prompter handling such that Control-Q <one of the above>
  may be entered for search/replace.

* FIXED: `window->normalise' to be prepared for (dis)appearing scrollbars.

* FIXED: PceEmacs query_replace_regex: 'n' if it was the last match.

* ADDED: Class text_item `combo-box' handling: Show drop-down indicator in
  Unix/X11 version and immediately execute ->apply after a user selection.
  See ->selected_completion for details on altering this behaviour.  Also
  see library(file_item) for an example.

* ADDED: Selection handling in text and text_item classes.

* ADDED: Various additions to mouse-based editing:
	+ `editor ->cut_or_delete_char', bound to DEL
	+ `editor ->cut' and `editor->copy'
	+ `display ->copy' and `display->selection'
  The latter two used to be part of library(pce_selection).  This library
  will be removed.

* FIXED: PceEmacs: various improvements to input-focus handling.  This fixes
  various cases where the editor appeared `death'.

* FIXED: Win32: `window->cursor: @nil', also avoid changing the cursor if
  an XPCE cursor is changed in a window now holding the cursor.

* IMPROVED: Unix/X11 version: try even harder to get a colour.

* ADDED: Moved images from main bitmaps directory that are used by XPCE
  itself into the code, so runtime applications no longer need the bitmaps
  directory and its contents.  The new predefines images are
  @ol_pulldown_image, @ol_pullright_image, @ol_cycle_image and @pce_image
  (the default frame icon).

* ADDED: Win32: Automatic handling of the colourmap for DIB based images.

* ADDED: Reading .JP(E)G and .GIF files.  Requires -ljpeg, JPEG library
  version 6a.  Use archie on jpegsrc.v6a.tar.gz to find it on the net.
  The Win32 version now uses the same code, removing the 3rd party
  gifread and imglib libraries.

* IMPROVED: Request the X11 selection both as text and string.  Fixes import
  of selected text from ApplixWare (and maybe others).

* FIXED: PostScript generation bug in class text.

* ADDED: Win32: `frame->status: full_screen'.  The frame-status `open' has
  been replaced by `window', though the method still recognises `open' as
  a synonym.  An open window returns status `full_screen' or `window'.

* Win32: ensure popup and completion windows are displayed above the Windows
  95/NT 4.0 task-bar.

* FIXED: Completion-window is repositioned to ensure it fits on the screen.

* ADDED: Handling of (undocumented) MS_MOUSELEAVE event for Windows-NT 4.0,
  hopefully curing some old problems.

* FIXED: Colour handling drawing masked monochrome bitmap on colour device.

* FIXED: Avoid references to @manual from card-browser and visual
  hierarchy tools.

* FIXED: Deletion of the main manual tool through the window-manager.

* FIXED: `object ->delete_hypers': wrong argument order if invoked
  from the `to' object.  Also added documentation.

* FIXED: Figure/tree background setting, so dialog items and other
  graphicals using r_clear() show properly.

* FIXED: Window delegation to frame: avoid crash if no frame exists.

* PceEmacs server: Check for modified file when opening a window.

* ADDED: extra argument to `device->advance'.  All internals to call
  this as a method.  Added `tab->advance' to default the new propagate
  argument to @off.  Causes advancing in a tab to circulate, rather
  then to switch to the next (hidden) item.  Makes it possible to
  define other subclasses with this same feature.


[VERSION 4.9.3]

* IMPROVED: integer range increased to +- 2**30 (was +- 2**29).

* PORT: Various minor issues for AIX 4.1 (using gcc 2.7.2).

* UPDATED: Updated the XPCE/C++ and XPCE/Prolog/C++ installation.  Many
  improvements:

	+ Fixed and fixed for MSVC 4.2 (Win32 version)
	+ Deleted PceMethodCall (non-portable)
	+ C-interface based handling of TheDisplay, etc., to avoid
	  exporting mangled symbols (better C++ compiler independency).
	+ Replaced masking of function pointers by using a flag on
	  class method and class class to find the type of pointer
	  used to improve portability.
	+ Autoconf based configuration for the C++ interface
	+ Added installation of the interface tools to make dv-install
	+ Fixed some C++ compatibility issues in Chain.h and Pce.h
	+ Tested all demos.  Removed a few that cover issues covered
	  extensively by others.  Improved a few to look better and
	  fix C++ compatibility issues.
	+ Extended CXX/demo/README and README.CXX.  Added CXX/demo/DEMOS,
	  providing a brief overview of the demos.
	+ Changed libXPCEmain.a, now implemented in C++ by src/itf/main.cxx.
	  Exits the application if there are no more frames for which
	  events can be dispatched.

* FIXED: if the system defines on_exit(), this is preferred over atexit()
  to be able to pass the exit code to messages registered using
  @pce->exit_message.

* PORT: Linux libc 5.4.23 defines sysinfo(), which errornously is mistaken
  for Solaris (incompatible) sysinfo() by configure.  Fixed in ker/self.c by
  explicitely testing for not-linux.

* MODIFIED: `directory->scan' to send ->ignore_case to the pattern if the
  class feature `case_sensitive' on class file yields @off.  Fixes
  compatibility problems.

* INTERFACE: Various minor modifications to the SWI-Prolog/XPCE interface,
  mainly aiming at reduced memory usage and faster data conversion in the
  interface.  Saves some 10% on the interface speed.

* PW3: fixed require/1 for reporting non-existing predicates (the predicate,
  not the expansion form of require/1, which was ok).  Added support for
  index files in other library directories, so you can expand the predicates
  handled by require/1.  Added an informational message, telling which
  library index databases are loaded.

* ADDED: user:pce_post_expansion_hook/2, next to pce_pre_expansion_hook/2.

* IMPROVED: `Image ->draw_in' to provide for efficient update of the display
  if small graphicals are painted in big images.


[VERSION 4.9.2]

* ADDED: Win32: save image as XPM file.

* ADDED: Save image<-mask and <-hot_spot when writing an XPM file.

* ADDED: Documentation for pce_open/3 (see Predicate Browser).

* PERFORMANCE: Improved change combination algorithm, providing less
  unnecessary redraw operations.

* FIXED: `text_buffer <-sub', first argument didn't properly default to 0.

* IMPROVED: Modified PceDraw, such that it can be used both using 2 and
  3-button mice.

* FIXED: configure problem, not autodetecting getpwnam().  This caused
  ~user not to be recognised as a valid filename.

* ADDED: Drawing lines in tree using style `list'.

* FIXED: Selection of `Sub Class' in `Display' on ClassBrowser stopped
  finding anything if the class had no subclasses.

* DEMOS/TOOLS: Improved the image viewer a little: Use normal file-patterns
  instead of regex, and provide default extensions.

* FIXED: Configure to use MAKESHELL rather then	SHELL to define the correct
  shell.  This avoids other shells to overrun the default using the SHELL
  variable set by most user-shells.

* FIXED: Avoid colour errors.  Notably caused by Netscape running and eating
  all colours.  Both loading XPM files and allocating XPCE colour objects
  now always replace the colour value by an `as close as possible' value
  from the colourmap.

* FIXED: `display ->report: error' not to show the `cancel' button (Win32).

* FIXED: Added trapping of frame exposure to call `frame ->exposed' in Win32.
  This ensures transient windows are kept on top of the windows they are
  transient for.

* FIXED: Tab tag-width is recomputed automatically to fit the text.

* FIXED: Loading colour database appeared to miss some colours. Also added
  handling of uppercase colournames to the "Colours" demo program.

* INTERNAL: Rewrote Win32 guarding of object pretty-printer to use __try
  rather then the badly supported Win32 signal handling.

* CHANGED: Pretty Printer (used for the tracer) to print floats as
  @<ref>/<value>, to simplify debugging.

* FIXED: Dialog layout label/value alignment for a specific combination
  of `natural width' values.

* FIXED: Added hook to ensure the last_window variable in event.c contains
  a valid object.  Caused a crash under very specific circumstances.

* FIXED: `class <-super_class_name' to fail without warning on class object.

* ADDED: Win32 version: loading of .ICO and .CUR files, including mask and
  hot-spot (for cursor).  These files can be written as .XPM, to make them
  available in the Unix version.

* FIXED: Various issues concerned with displaying windows inside other
  graphicals and windows.  Modified scrolling approach in the X11 version
  to properly post a redraw request instead of redrawing immediately.  This
  should avoid useless redraw actions and avoids reentrance of the window
  redraw system (possible, but with limited nesting).

* FIXED: `line->resize'.  Used to be just graphical->resize, but this makes
  alignment errors when applied to a line.

* FIXED: `gesture ->cancel' could post the drag event to the object not
  in focus.   This could cause a drag to be received on an object that
  is not currently being dragged.

* FIXED: PostScript generation for text objects with pen > 0 and/or
  <-background attribute.

* ADDED: Pce.Graphical.event_tolerance  This resource constrolls how far
  outside very small objects, the event is considered in the object. Used
  to be a fixed value of 5.

* ADDED: `line <-distance' to accept a point argument for calculating the
  distance between a line and a point.

[VERSION 4.9.1]

* FIXED: Memory leak in alloc()/unalloc(), causing considerable leakage on
  some applications.  Also fixed a memory leak in the debugger.

* WIN32: The library uxnt.dll is now linked as a static library into the
  xpce.dll kernel, to simplify the distribution of runtime systems.

* ADDED: Win32: `frame ->icon' now defines the small icon for the system
  menu and the task-bar.  The default icon is the resource
  Pce.Frame.icon_image, which is set to pce16.xpm for the Win32 version.

* FIXED: Defining a cursor from an image and added support for XPM-image
  defined cursors for the Win32 version.

* FIXED: Accelerator assigment moved to the C-kernel, slightly improved the
  algorithm and avoided the possibility of ending in an almost infinite
  loop.

* FIXED: File->copy if the file does not exist.

* ADDED: `cursor ->initialise' to deal with XPM masked images and hotspot
  values for comfortable definition of user-defined cursors.

* FIXED: Class Real load/save and clone: ensure the F_ISREAL flag is set,
  so the host interface translates the value into a host float.

* FIXED: Graphical->displayed: @off sometimes didn't invoke the update
  mechanism properly.

* FIXED: Correction of text-width calculation for left/right bearing (X11
  version).  Only goes wrong on some weird fonts.

* FIXED: Win32: Many aspects of full colour handling: reading XPM colour
  images and specifying colours.  The system now maintains its own colour
  map in `display <-colour_map'.

* FIXED: Win32 painting arcs to update the pen.

* ADDED: Image <-rotate and Image <-clip to properly copy and/or update
  <-hot_spot and <-mask.

* ADDED: Image loading XPM files: reading the XPM's hotspot and filling
  `image <-hot_spot'.

[VERSION 4.9.0]

* PW3: Fixed generation of Manual search index.  Fixed XPCE term-expansion
  to properly support PceEmacs M-x pce_insert_require_directive.  Fixed
  errornous foreign definition in pce_principal.c.

* FIXED: RS6000: Fixed __unix__ definition, added sys/socketvar.h
  configuration, various minor patches to Makefiles and other sourcefiles.

* MODIFIED: Some details in class connect_gesture to allow for more
  advanced redefinition: ->terminate now invokes ->drag through the
  message-passer, making redefinitions of drag work properly.
  ->indicate has been modified to allow ->initiate to set the <-from_handle.

* ADDED: Class->instance_variable to allow for redefinition of variables
  with a more restricted type.

* FIXED: Area computation of class arc, sometimes missing a pixel.

* FIXED: `image ->save: file, pnm'.

* ADDED: `date ->copy'.

* ADDED: Multilevel undo in PceDraw.

* ADDED: Modal operation of frames.  See `frame ->modal'.

* ADDED: Class application.

* FIXED: Reference count management for objects having hypers, attributes,
  etc.  Caused many objects to be ignored by the incremental garbage
  collector.

* ADDED: `connection->relate' to change connections without removing
  them.

* MODIFED: `device->erase' and `graphical->device: @nil' no longer
  modified the <-displayed attribute.

* FIXED: Binding of @class when reconsulting a file.  Make class
  directives work properly.

* MODIFIED: Handling of `chain <->current'.  The following methods no
  longer manipulate current: ->initialise, <-head, <-tail, ->swap,
  ->delete_head, ->member.

* FIXED: emacs_tags library to handle types and #defines properly (affects
  PceEmacs M-. command).

* ADDED: Class application to define a collection of cooperating windows
  as an application. Added `frame <->application' and `frame <->name' to
  support finding applications and application parts.  Also `graphical
  <-application'.

* PORT: Fixed class process handling for SGI/Irix (both compilation and
  runtime problems).  Configure has been addapted to check for the
  differences between Solaris and Irix in this respect (ioctl(tty,
  I_PUSH, "ttcompat") and the info provided with signal handlers using
  SA_SIGINFO.

* ADDED/FIXED: Added `tab ->in_event_area' test to fix event-handling and
  cursor management in tab_stack objects.

* ADDED/FIXED: Flash management.  All graphicals now define ->flash:
  [area], time=[int].  Implementation is done by inverting part of the
  window using the low-level window primitives rather then by
  manipulating the `graphical <->inverted' attribute.  The added
  area argument allows for flashing part of an object, which is exploited
  by class tab to only flash the label if it is not the top tab, and the
  whole area otherwise.

* ADDED: `dialog_group ->kind', ->border and a kind attribute to
  ->initialise.  The system now provides both boxed groups and groups
  that lack visual feedback, and may be used to define compound
  dialog objects.

* FIXED: Repaint of text objects with border and clipping (appears
  as loosing the last character in scrolled text_item objects).

* PERFORMANCE: Better detection of changes while doing dialog layout, to
  avoid unnecessary work being done.

* FIXED: dialog_group compute management.

* ADDED: Demo: colour for (pre-)viewing the XPCE mapping of the X11
  named colour database.

* PCEDRAW: Added resources Pce.Draw.draw_fill_patterns and
  Pce.Draw.draw_colours, allowing for easy extension of these menus.

* PCEDRAW: Added automatic alignment on the basis of handle positions.

* PCEDRAW: Added automatic adjustment of the mode-menu for too many items
  or resized window.

* ADDED: On a frame resize, initiated from the user, the method `frame
  ->resize' is now explicitely called, allowing for redefinition.

* FIXED: Win32: Popup windows not to show in the Windows 95 taskbar.

* FIXED: Win32 `file->copy' (actually, worked around Win32 bug).

* FIXED: ListBrowser event handling to use the {left,middle} up events for
  their message, rather than the down event.  Fixes focus handling problems
  around cycle-menu's using the combo-box feedback (Windows).

* FIXED: Properly greying the accelerator underlining.

* FIXED: Windows 95 `socket ->append' implementation.  Thanks to Donald
  Kwakkel!

* FIXED: Win32: `display ->cut' memory allocation error if there were
  more than 1 line in the cut-buffer.

* FIXED: `host ->catch_all' to handle multiple arguments correctly
  if <-call_back is @off (message(@prolog, foo, arg1, arg2)), not using
  call-back.

* FIXED: `frame <-confirm' to return failure if the frame is destroyed.

* FIXED: Image ->draw_in: Bitmap, where Image is monochrome and Bitmap
  is coloured to avoid a crash (proper dithering still to be implemented).

* ADDED: `editor ->lost_text_buffer' to program the behaviour if the
  text-buffer of an editor is deleted.

* ADDED: @pce<-window_system.  Renamed @pce<-xt_version into
  @pce<-window_system_version and @pce<-rt_revision into
  @pce<-window_system_revision.

* ADDED: `stream ->record_separator: int' to make the socket break the
  input in fixed-size records.  The record separator may now be switched
  on open communication lines, and binary data is handled correctly by
  it.

* FIXED: PceEmacs and editor: management around the undo buffer.  This
  should fix various problems in this area.

* FIXED: PceEmacs completion items to explicitely convert to a string
  in canonise.

* FIXED: Class socket: convert port to network byte-order in the address
  specification.  Also fixed in xpce-client.  Only affects big-endian
  (e.g. Intel) machines.

* ADDED: `image->mask' to support non-rectangular images.

* ADDED: Read and write of XPM colour images when compiled and linked
  to -lXpm (auto-detected by configure).

* ADDED: `display <-image', to get an image from a rectangular portion
  of the display.

* PERFORMANCE: Much better performance for various graphics operations
  on images.

* FIXED: Redraw management for `opaque' graphical objects.  Moving
  Such objects sometimes caused parts of the window not to update
  correctly.

* ADDED: Resource-based rebinding of all the XPCE keyboard-editable
  classes: editor, text_item, list_browser, etc.

* MODIFIED: Non-editable text_item will not show its line.

* ADDED: ListBrowsers shift-click to extend and control-click to toggle
  the selection.

* FIXED: Win32 cut/copy of text to translate between internal and external
  text format.

* CHANGED: Menu's of kind ->cycle to show as a combo-box.

* FIXED: Undo for editor/textbuffer.  The bug was associated with resizing
  an undo-cell, which almost exclusively happens in case-conversion
  commands.

* CHANGED: {Dialog,DialogGroup,Button} <->default_button are now implemented
  on the basis of the attribute `button<->default_button', rather than the
  accelerator.

* FIXED: details regarding geometry management of browsers to ensure
  a browser of height 2 can actually display 2 lines.

* ADDED: ScrollBar <->auto_hide: automatically hides a scrollbar if it
  is no longer needed as all data is visible and redisplay it again if
  too much data arrives.

* ADDED: ComboBox implementation, based on the completion mechanism of
  class text_item.  See text_item->style.

* FIXED: and improved: numerous issues concerning completion-browsers
  for text-items to make them feel much more natural.

* FIXED: Behaviour of scrollbars if the object scrolled is not too much
  bigger than the window (provide more `natuaral' scrolling).

* ARCH: Slightly modified the relation between XPCE and the window
  environment for handling dialog objects (controllers).  In the old
  version, all dialog work was done entirely by XPCE, based upon the
  virtual-window-system graphical layer.  In the current version, part
  of the dialog handling is directly handed to the `virtual-dialog'
  layer.  This layer implements the item for the look-and-feel it
  belongs to using both the virtual-window-system and direct access
  to the underlying system.

  At the moment, this layer is restricted to graphical operations.
  For example, vd_draw_button_face() is supposed to draw the face of
  a button according to the current look-and-feel, giving its state
  and bounding box.

  This approach allows for a simpler and more garanteed compatibility
  in look-and-feel.  This is currently being implemented realising more
  of the Windows 95 look-and-feel for Win32.

* FIXED: Win32: Made standard window brushes (available as @win_*_brush) work
  as images, as their name suggests.

* ADDED: Win32: Access to standard Win32 images.  All these are named
  @win_* image.

* MODIF: PceEmacs Prolog/Source File entry to only show `user' source
  files.

* FIXED: Win32: Colour compatibility of non-bubble part of the scrollbars

* FIXED: Win32: Bottom-right pixel of elevated areas was not painted.

* Win32: Improved alignment and layout of triangles in the arrows of
  scrollbars.

* GUI: PceEmacs: when entering a directory if a file is requested, the
  system will open the standard viewer.

* GUI: TextItem completer improvements:	Deleting text when the completer
  is show back to the point where it was started now removes the completer.
  If no `prefix' is specified, cursor up/down will properly highlight the
  selection now.

* FIXED: X11: avoid sending characters twice to the window holding the
  keyboard focus in a frame if the pointer is on the border of the frame.

* FIXED: Win32: Force immediate window update after drop of files.

* ADDED: Win32: Class win_metafile: full encapsulation of Windows metafiles,
  both Win32 enhanced metafiles and Windows 3.x metafiles: load
  and display them, save them in any format, put them on the clipboard
  and get them from the clipboard.  This provides easy exchange of
  drawings with the popular Microsoft Tools.  These features have been
  exploited in PceDraw.  If someone has a library for Unix ...

* FIXED: Win32: creating PostScript from images, frames and display.

* FIXED: Creating HBITMAP handles for images of <-kind: bitmap.

* FIXED: return-type warning for PceEmacs find_definition command.

* FIXED: `var->unlink' to remove the variable from the binding-block.
  Thanks the Lourens van der Meij for providing me with a program that
  demonstrated the problem deterministically.

* FIXED: `device ->layout_dialog' to use ->do_set instead of ->set for
  resizing sizeable objects.  Makes list-browsers and editors behave
  normally in this context.

* FIXED: The scrollbar of an editor sometimes appears at the left-side,
  despite the preference is set to right.

* ADDED: ->label and similar methods to class editor.


[VERSION 4.8.19]

* ADDED: maintenance of correct source-location for Prolog clauses
  implementing methods. REQUIRES SWI-Prolog 2.7.12 or later!

* FIXED: ->orientation type check to accept 'south_west'.  Thanks to
  Donalt Kwakkel.

* FIXED: pce_extend_class to accept variable, resource and class-directives.


[VERSION 4.8.18]

* FIXED: XPCE/SWI-Prolog detect now on basis of the *basename* of the
  file rather then the entire path

* FIXED: Win32: loading .ico file images.  Broken when moved to 32-bit
  platform.

* FIXED: new(C, colour(@default, R, G, B)).

* FIXED: Error reporting if loading pl2xpce.so fails, removed pushing
  LD_LIBRARY_PATH in pce_pl.pl as this didn't work anyway (ld.so checks
  these variables only at startup).  Removed require/1 definition from
  XPCE/SWI-Prolog interface, as this predicate is part of Prolog since
  a while.

* DISTR: Removed various outdated files.

* FIXED: (hopefully) mispositioned Popup menus on some X11 servers and/or
  window managers.

* FIXED: Module handing in the Prolog <-> XPCE interface when an exception
  caused the global variable DefaultModule to be overwritten.  This resulted
  in messages of the type

     [WARNING: Undefined predicate: pce_realise:use_method/2]

[VERSION 4.8.17]

* FIXED: Win32 class frame: did not send ->displayed to member windows
  on ->show on/off.  Did not invoke ->mapped too.

* FIXED: Win32 problem in brush caching.

* FIXED: menu-redraw problem when a menu-item in a non-popup menu
  has not-nil <-popup.  Win32 only.

* FIXED: redraw problem in horizontal scrollbar when not displayed at
  x=0 (i.e. when used as a graphical).

* FIXED: `text->margin' handling (displays box for unknown character
  after the string on Win32, possible alignment problem on X11).

* FIXED: Notably popup-driven action sometimes refused to redraw
  properly.

* ADDED: library(pce_toc): table-of-contents browser library.

* ADDED: SWI-Prolog help library.  Modified plrc to make a more neat
  connection between XPCE and Prolog.

* MOFIFIED: `tile->enforced' now has additional argument, used by
  `frame->fit'. See documentation.

* ADDED: Window ->left, etc. may be given a tile to insert windows
  at arbitrary positions.  Also modified `tile->left' and friends to
  realise this.  Used by the new SWI-Prolog help GUI.

* FIXED: If a tile message arrives on a window that has a decorator,
  delegate it to the decorator.

* FIXED: PceEmacs: M-x manual_entry: better feedback and handling of
  man -s on Solaris.

* FIXED: PceEmacs: capitalisation of popup-labels followed by ...
  (find_file, etc.).

* MODIFIED: Menu-bar event-handling:
	+ After clicking, moving to another popup will open this
	  popup.

* FIXED: avoid failing `key_binding->typed' for prefix and other built-in
  commands.

* ADDED: loc-still management for Win32 version.  Windows-95 compliant
  implementation of class menu-bar.

* ADDED: `alignment' attribute to `menu_bar->append' to allow for flush-right
  of (for example) the help-button.  Implemented `menu-bar ->geometry' and
  `menu-bar <-hor_stretch' to support this functionality.

* FIXED: 'device->append_dialog_item' to ensure the item has auto_align
  set to @on.

* FIXED: `display->inspect_handler' handling.  Also speedup of the
  implementation.

* FIXED: Win32 version: PostScript generation for text objects.

* MODIFIED: Resource parsing is not longer done using the X11 resource
  manager, but using XPCE's own resource reader.  It now loads the file
  $PCEHOME/Pce, which loads $HOME/.Xpce

* ADDED: Class tab for `tabbed dialog windows support' as commonly found
  in Windows '95 application.  Also class tab_stack for creating a stack
  of tabbed dialogs.

* ADDED: event-type loc-still to detect the pointer hasn't moved for a while.
  This can be used to display feedback messages, etc.

* ADDED: Class dialog_group, for defining a boxed group of dialog
  objects with a label.

* MODIFIED: General cleanup of arithmetic, improving on its range, precision
  and error handling:

	* Tagged integers with range +/- 512 M (not changed)
	* Object integers (class number) with full 32-bit range
	* Floats (class real) using double-precision representation
	* Expression and equation now handle floating point numbers.
	* All arithmetic is caried out in 32-bit integer arithmetic
	  as long as the arguments premit such and converted to double
	  precision floats otherwise.

* FIXED: PceEmacs starting of the server if the socket is still present
  from a previously crashed session (which happens mostly to myself after
  I overwrite the running executable :-().

* FIXED: Process termination handling for Solaris (PceEmacs kill-buffer
  crashed if the buffer was connected to a live process).

* FIXED: Path problems in pl/src/Makefile.bin

* FIXED: `arc->points' arithmetic.  Also fixed a bug in the virtual window
  system interface code for arcs in the Win32 implementation.

* FIXED: `@display ->draw_in' (didn't do anything).

* ADDED: `frame->event', `frame->cursor' and `frame->grab_pointer'.  `Frame
  ->event' handles resizing the subwindows now.

* MODIFIED: behaviour details on `tile->set' if `tile <-enforced' is @on,
  to support resizing subwindows better.  Added `tile <-sub_tile_for_resize'
  to support computation of subwindow resizing in frames.

* MODIFIFIED: Various details to the colour resources, r_3d_box() and some
  details to class menu to achieve prettier looking menus and buttons, using
  a slightly darker colour when depressed.

* ADDED: optional `size' argument to `device ->layout_dialog'
  and `dialog->layout' to force the dialog-layout algorithm to distribute
  the items properly over dialog windows that are too big for their
  contents.

[VERSION 4.8.16]

* ADDED: configuration for ldconfig

* FIXED: Reload-from-id in the Dialog Editor to restore the can_resize
  property.

* ADDED: support for displaying images to the left of lines in a browser.
  The image is specified using the icon option of the associated style.

* ADDED: `image <-scale' to scale bitmaps.

* ADDED: `list_browser ->{next_line,previous_line}' and some keybindings
  to support proper keyboard driven handling of list_browsers.

* ADDED: Event-conversion for many more `named function keys': page_up,
  page_down, end, insert, help, etc.

* FIXED: Exit immediately if loading pl2xpce.so fails, instead of reporting
  lots and lots of error messages caused by this.

* PORT: Solaris to use sysinfo() rather then gethostname() for better
  System-V compatibility.

* ADDED: @pce <->trap_errors.  When set to @off, all runtime errors will
  be ->report'ed and the tracer will never be trapped.  Useful for running
  apps.  @pce->trap_errors sets @pce->trace to `never'.  @pce->trace has
  a new value, called `error', which confirms to the old `never'.

* FIXED: Added some extra conditions to connect_gesture to make it behave
  better when not used entirely as it was designed for.  It is no longer
  obligatory to invoke the super method of ->verify in subclasses of
  connect_gesture.  Updated the class documentation.

* MODIFIED: Changed default extension for PostScript output to be .eps,
  which appears to be more conforming to the current standards.  PceDraw
  now add a showpage command to the file, so files can printed directly.

* DEBUG: Improved error reporting when sending a message to a freed
  or otherwise invalid object-reference.

* ADDED: optional `ignore_case' argument to `char_array->suffix' and
  `string->ensure_suffix'.  Should be added to some more of the text
  analysis methods.

* FIXED: Update after sending a message from the Prolog window to XPCE
  for the Win32 version (broken with the new pl-2.5.x interface).

* FIXED: Added case-insensitive file handling in the standard library finder
  for the Win32 platform.

* FIXED: Loading images from file on the Win32 platform.  Guaranteed display
  of picture windows that have been loaded from file.

* FIXED: Dialog Editors handling of menu_items with messages in associated
  popup menus.  Modified code-generation, make_dialog/2 and reload-from-id.

* FIXED: `stream <->record_separator' handling.  Probably broken since
  version 4.8.14.  Also improved underline/bold handling and feedback
  for M-x manual_entry in PceEmacs.

* Added `graphical <-displayed_cursor' to make cursor computation available
  to the (advanced) user.

* Integrated SICStus interface and moved SWI-Prolog interface to the new
  2.5.0 interface.  Both Prolog's now share the same interface.

* PceEmacs: Added conversion of - to _ for entering M-x commands.

* PceEmacs: Fixed M-P in completer field when no history was present.

* INTERFACE: Created hooks for malloc()/free()/realloc() to allow for
  host-defined versions of these.

[VERSION 4.8.15]

* PceEmacs: changed fundamental, language and text mode to use the supported
  begin_emacs_mode/end_emacs_mode rather than the low-level equivalents. This
  ensures the display is not opened when PceEmacs is compiled, enabling the
  SICStus-3 save_program to be able to save XPCE with both the manual tools
  as well as PceEmacs compiled.

* INTERFACE: Deleted HostAction(HOST_WRITE/HOST_FLUSH, ...).  Added Cflush()
  to the interface callback structure.  Also added malloc, realloc and
  free to this structure to allow for embedding in environments where
  the standard functions may not be used.

* MODIFIED: renamed exception redecared_reference to redeclared_reference.
  Same with the error.

* ADDED: class->delete_send_method and class->delete_get_method to ensure
  proper handling of the exception-based method binding.

* INTERFACE: 1-st argument of pceNew() (assoc) is now a PceName instead of
  a plain char *.  Same for cToPceString() and pceExistsAssoc();

* PERFORMANCE: Speedup of handling message objects having exactly one argument.

* INTERNAL: Modified class-definition structure for built-in classes.  Also
  built-in methods are now bound `lazy', reducing startup-time and memory
  usage.

* FIXED: `graphical <-keyboard_focus'.

* FIXED: various problems in the dialog editor: horizontal alignment detection,
  code generation for objects with explicit position and some minor problems
  in the look of the dialog editor itself.

* FIXED: library(dragdrop) memory management for handling <->source.  Lead
  to `invalid integer reference' if <-get_source yields an unconnected
  object.

* MODIFIED: `Dialog ->apply' and `Dialog ->restore' now deactivate the
  <-default_button when completed.

* FIXED/MODIFIED: Dialog Items now correctly report the Y of their reference
  point to the baseline of the label, dominant text or similar attribute.
  Notably fixes layout of left-to-right aligned dialog items, but may lead
  to displacement in applications that corrected to misalignment.

* FIXED: Editor <-clone.  Didn't properly clone the reference from the
  text-buffer.  Introduced `variable ->clone_style: reference_chain' to
  realise this.  Necessary to make editors work properly in the dialog
  editor.  Also fixed Editor ->save_in_file.  Similar problem.

* FIXED: Load/save to directory objects using ->save_in_file.

* ADDED: Changed chain_list/2 to behave much more as a logical predicate.

* MODIFIED: Deleted @pce <->print_c_stack and the gC option to the tracer
  to do so.  This didn't work on most machines anymore and shouldn't harm
  users.

* FIXED: Default button layout on 2-D openlook mode.

* FIXED: browser->typed to delegate to its <-list_browser.

* FIXED: area->set: misspelled argument name height.

* ADDED: Manual search tool.  See Browsers/search.

* FIXED: `frame ->wait' now waits till the frame is not only mapped, but
  also all windows in it have been painted properly.

* FIXED: Redraw problem on colour screens in menu-bar, notably appearing
  on Solaris!!

* FIXED: Readline interface library, avoiding crash on illegal instruction
  after ^Z and repeated repaint of the first line on resize.  See
  ftp://swi.psy.uva.nl/pub/SWI-Prolog/readline

* FIXED: `path->geometry' for paths containing no points.

* FIXED: `path<-segment' to avoid division by zero when there is a zero-
  length segment in the path.

* BUILD: Removed obsolete xversion.h stuff from Makefiles and x11 directory.

* ADDED: User-defined graphics.  Allow for the redefinition of _redraw_area
  and added ->clip, ->unclip, ->save_graphics_state, ->restore_graphics_state,
  ->graphics_state, ->draw_line, ->draw_poly, ->draw_arc, ->draw_box,
  ->draw_fill, ->draw_text and ->draw_image.

* FIXED: Removed maximum number of points for a polygon.

* FIXED: Editor: honour text-colour of selection_style resource.

* WIN32: Fixed look of browsers having a label.  Added ->pen to list_browser
  and editor.  Changed resources to exploit these.

* WIN32: Added inferior process interface.  Consider this ALPHA code, but
  provided you have a 32-bits NT console application `grep', PceEmacs
  allows you to do M-x grep in both Windows'95 and NT.  Doesn't work in
  win32s though.  Use `@pce->has_feature: process' to test for the
  availability of inferior processes.

* ADDED: `file->is_absolute' to provide platform-independent checking for
  absolute filenames.  Used by `emacs_shell_mode<-directory', but probably
  should be inserted in more places.

* WIN32: Fixed scrollbar repeat-timer stuff (actually, worked around timer
  bug in Windows '95).

* WIN32: Fixed loading of ~/.Xdefault for personalised initialisation.

* ADDED: `chain<-next' and `chain<-previous' to query the order in a chain.

* FIXED: path<-segment if there are 0-length segments (division by zero).

* ADDED: `text_item ->value_width' to specify fieldwidth in pixels. Modified
  initial value of `text_item: auto_value_align' to @off.

* FIXED: pullright-mark in popup to be 3-d style again.

* ADDED: PceDraw: select-all option to the edit menu.  Added ->fill_dialog
  to the main draw class to improve embedding capabilities.  Modified
  hide/expose to restack the graphical only 1 level.  Added key-bindings for
  actions on selection: DEL --> delete_selection, Control-H: hide, Control-E:
  expose, Control-C: copy.

* FIXED: Event-handling for nearly-vertical or -horizontal lines.

* FIXED: Button-indicating messages in dialog editor.

* FIXED: stayup-mode handling of multiple-nested popup menus.

[VERSION 4.8.14]

* MODIFIED: handle `list_browser <->open_message' if multiple selection
  is @on and <-open_message is not @nil.

* FIXED: use new mclock() for timing of graphical->synchronise.  Makes this
  functionality compatible in WIN32 and centralises portability of timing.

* FIXED: PNM `RAWBITS' format.  It appears scanlines are byte-aligned.

* ADDED: Bound ESC to cancel search in listbrowsers.  Also to cancel completer
  of text_item.

* MODIFIED: moved quoted-insert from editor to key_binding, so other
  text-objects can exploit this as well.

* FIXED: column preservation in editors for next_line/previous_line.  Cleanup
  of `key_binding->typed' implementation.

* ADDED: Forwarding current selected status of dict_item while executing
  the messages associated with a browser.

* ADDED: `list_browser ->change_selection' as an explicit message.  Allows
  to hook into the list_browser's selection mechanism.

* FIXED: selection visualization problem in browsers associated to the
  first item.

* FIXED: removed premature overflow for XPCE arithmetic functions, provided
  the used C-compiler supports 8-byte integers.  Configure checks for the
  support of long long.

* ADDED: new(X, file) to return a file object with a system-dependent
  temporary name.

* FIXED: Various event-handling issues for scrollbars, resulting in better
  repeated scrolling and largely reducing problems with OpenLook
  scrollbar automatic mouse-movement.

* CHANGED: Edit capabilities for the manual tools are now bound to the
  resource Pce.ManManual.edit rather then checking write-access to the
  manual/reference directory.

* FIXED: reopening a help-file after the sequence open, split, join,
  close.

* FIXED: PceEmacs: Compile Buffer from buffers not asociated to a file
  (just gives proper message), WIN32: consult_region to use proper
  tmp filename.

* FIXED: Various issues around process exit.  Updated demo(chess) and
  emacs_shell_mode to exploit the new features.

* FIXED: {list_browser,editor}->reference to use `graphical ->reference'
  rather then `device ->reference' to make these objects fit into the
  dialog layout schema.  Fixed various related problems in the
  dialog editor.  Proper interpretation of the reference point still
  needs to be implemented in the dialog editor.

* ADDED: Completed floating-point support for class slider.  Added ->format
  to allow formatting (floating) numbers.

* FIXED: Class process to handle premature death of the child more elegantly.

* WIN32: `window->flash'.  Didn't work and left graphical infrastructure
  in an unstable state.

* FIXED: VisualHierarchy print command to be better portable.

* WIN32: Fixed `frame ->delete: Window'.  Fixes `delete-other-windows'
  in the help system.

* ADDED: More flexible argument interpretation from tracepce/1 and
  breakpce/1.

* ADDED: Allow `class <->resolve_method_message' to be a c_pointer
  with similar semantics as `method <->message'.  This makes it easier
  to hide the dynamic binding of methods from the tracer and saves a
  bit of time during startup.  Internal.

* ADDED: `point <-plus', `point <-minus' and `point <-mirror' to make
  position arithmetic a bit more natural.

* FIXED: Dialog editor temporary file handling for Win32 platform.

* FIXED: `file ->find'.  Crashed if one of the path-components contained
  variables or other constructs that cannot be expanded (again if page
  0 is unreadable, otherwise it has a very small propability to	yield
  the wrong answer).

* WIN32: Added read/write for PNM (Portable aNy Map) image format.  This
  allows for the exchange of colour images between the Unix and Win32
  versions.  `image ->save_in_file' and `file<-object' use this format,
  making saved image-objects portable between the platforms.

* FIXED: Attempt to convert an integer to a colour lead to a crash.

* ADDED: `popup ->show_current' to put a style-dependent mark of the current
  selection in the popup.  Replaces the `hack' to use `popup ->on_image'.

* ADDED: Logical-font handling system: see '@display ->font_alias' and
  friends.

* MODIFIED: `menu<->kind'.  The new look-and-feel treated `marked' and
  `choice' the same.  Both motif and windows define menus with marks
  next to the item.  Therefore, `marked' implies to use marks if the
  style allows for that, `choice' means use some modification of the
  item (elevation, a box, invert, etc).

* FIXED: Rewrote layout of PCE finder (library(find_file)) to use automatic
  layout, so it will behave properly on different look-and-feel.  Also
  fixed for case-insensitive file-systems.

* WIN32: Fixed serious bug in low-level graphics, causing the system to
  run out of graphical resources when using image-based fill-patterns.

* FIXED: `chain <-complete_name' when ignore_case := @on and their are
  several matches with different case-pattern.

* WIN32: Modified library(file_item) to be case-insensitive when
  the class-feature case_sensitive on class file indicates this.

* FIXED: 'file ->backup' to give proper error message if it can't make
  a backup.

* FIXED: `image <-postscript' for colour images on system that donot permit
  read-access to the first memory page (i.e. a null-pointer was dereferenced
  for reading, but the result wasn't used, so the data didn't matter).

* FIXED: `display ->load_font_family'.

* PW3: Checked :- require/1 directives, checked the building process for
  SunOs.

* DOC: Generated the reference manual.  Documented use_class_template/1
  in the online manual.

* FIXED: class <-send_method and class <-get_method to handle the cache
  properly.  The error was harmless for normal message passing, but could
  lead to a serious performance degradation.  It crashed the ClassBrowser
  on some methods.

* INSTALL and C++: Defined creation of versions-controlled libXPCE.so
  and only a small shared object to load this to SWI-Prolog.  This is
  cleaner and allows the usage of the same XPCE shared object with both
  the C++ and Prolog versions.  Also allows for creating XPCE/C++ shared
  objects and linking them to XPCE/SWI-Prolog.  Developed and tested on
  PC/Linux using ELF.

* MODIFIED: `@pce <-home' to initialise as default and set from $PCEHOME
  when needed.

* WIN32: Programmed around MSVC++ 2.0 optimizer bug for ker/goodies.c.

* FIXED: Input handling in class stream to avoid a crash if executing the
  ->input_message of the stream destroys the stream (fixes problems in
  socket and process).

  [sent C-part of the patches to AIIL]

* FIXED: PceEmacs server package to deal properly with invalid requests.

* ADDED: dict ->insert and dict <-sort_by to manipulate sorted dictionaries
  more efficiently.

* FIXED: Visualisation update problem in list_browser after a ->sort.

* INSTALL: Configure fixed for users of a shell that doesn't export $PWD.

* ADDED: ->drop and ->preview drop to emacs_fundamental_mode to allow for
  dropping files on PceEmacs windows.

* ADDED: `directory ->modified' to check for modifications in a directory

* FIXED: Source option on demo tool.  Now uses absolute_file_name/3.

* MODIFIED: ImageViewer demo to use directory_item for realising
  completion on the directory.

* MODIFIED: Dialog editor to exploit the new drag-and-drop gestures.  All
  actions are now moved from the middle to the left mouse-button, so the
  system gets less dependent on the middle-button.  Deleted dialog/prompter;
  the dialog editor now uses library(pce_prompter).

* FIXED: directory->scan to handle the hidden_too argument properly.

* FIXED: Prevented `editor->event' from calling ->report: status, '' through
  endIsearchEditor().

* ADDED: Indirected all internal calls of `editor->caret' as a message, so
  the application can keep track of moving the caret in an easy way.

* ADDED: Proper geometry management for text-item objects that allow for
  more interactive editing in the dialog editor and better layout of dialog
  windows.

* UPGRADED: library(pce_prompt) to be a bit smarter and more useful in simple
  applications: better feedback on errors, automatic generation of menus,
  list_browsers or text_item.  Completion in text_item if appropriate.

* ADDED: editpce/1 to accept objects: editpce(@blabla) will edit the source
  file of the class to which @blabla belongs.  Also, editpce(@blabla->hello).
  Same for manpce/1.

* MODIFIED: drag_and_drop_gesture and drag_and_drop_dict_item_gesture to
  use a normal cursor.  This will fix problems with systems not supporting
  big cursors or making a mess out of them (most colour X11 servers).

  The ->preview_drop method now has an optional position argument, allowing
  the receiver to preview the location of the drop and possibly only allow
  for dropping in restricted areas.  The dialog editor usage of the drag
  and drop gestures have been modified to handle this.

  Both gestures are now defined on the left-button by default.  These gestures
  ->cancel if the up is within 5 pixels of the down, allowing other gestures
  to cooperate with them.  See the dialog editor for details.

* FIXED: left-drag from dialog objects in dialog editor to yield an undefined
  method.

* FIXED: dialog editor: documentation on @prolog to work ok.

* FIXED: `event->inside' now works for windows and succeeds if the event is
  in the visible area of a window.

* FIXED: getting position of an event relative to a device in another window
  as from where the event was generated.

[VERSION 4.8.13]

* UPDATED: PW3 version:
	- Fix to input-handling.  New windows where sometimes only filled
	  after moving the pointer in the window.
	- Update of the Prolog dependencies and PW3 specific Makefiles.
	- Fixed incorrect definition of make/0 and source_warning/2.

* INSTALL: make dv-install to install the development system with SWI-Prolog.

* FIXED: restarting the dialog editor, moving the help-files to appl-help
  directory.

* FIXED: configure for Linux/ELF

* ADDED: checkpce/0 to check for unclosed class-definitions.

* FIXED: checkpce/0 to consider pce_prolog_class/1.

* PERFORMANCE: speedup of pce_autoload_all/0 by using pce_prolog_class/1.

* ADDED: pce_prolog_class/[1,2]

* FIXED: Protected get_methods and send_methods from the incremental
  garbage collector while executing.

* INSTALL: Reorganised the Makefile architecture.  The aim is to be able to
  build multiple configurations using the same sourcetree. To avoid
  problems with old ar(1) programs, some files have been renamed to fit
  in 14 characters.  The configure programs have veen moved to the src
  subdirectory.

* REMOVED: library(pce_common).  This file defined some SWI-Prolog specific
  predicates for SICStus.  Now moved to the SICStus sourcetree.

* ADDED: `@pce <-version', additional argument to obtain short form and
  numeric form.

* FIXED: PceDraw: set `modified' after paint of prototype, auto-alignment
  after pasting a prototype holding no text objects.  Both found and fixed
  by Lourens van der Meij <lourens@cs.vu.nl>.  Thanks.

* FIXED: `class ->save_style_variable' to <-clone the variable if it isn't
  onwed by the class (copy-on-write).  Fixes save problems in PceDraw and
  other saving displayed graphicals.

* FIXED: `Source' option from the manual tools to start PceEmacs properly
  if it is not running.

* DOC: Added default/3

* PW3: Fixed signal() interface.  This fixes execution of
  `process ->terminate_message' and `@pce ->catch_error_signals'.  The
  latter is useful for locating errors.

* PW3: Fixed graphical update when commands arrive from the terminal.

[VERSION 4.8.12]

* FIXED: Multiclick generation in confirmers (sometimes required a button
  to be clicked multiple times).

* MODIFIED: Class click_gesture now accepts <->multiclick: @default, indicating
  the gesture should respond to any type of click (single, multiple).  Allows
  for fast-clicking on a button.

* FIXED: `class ->instance_variable' to handle the cache properly.

* DOC: added pce_image_directory/1 and pointers to it.

[VERSION 4.8.11 (= ProWindows-3, version 1.3]

* FIXED: PostScript generation for class text: handle <-border correctly.

* FIXED: Windows on multiple displays when displaying text objects.

* CLASSCOMPILER: The XPCE class compiler (handling :- pce_begin_class ...
  :- pce_end_class) has been rewritten completely.  Instead of producing
  directives, the current version produces prolog code that creates the
  classes on the basis of XPCE exceptions.  The code is supposed to be
  fully compatible, with the following exceptions (COMPATIBILITY)

	* Wrappers around pce_begin_class/pce_end_class should use the
	  user:pce_pre_expansion_hook/2 hook predicate.

	* The class-definition predicates cannot be called directly
	  anymore.

	* Directives to the class under construction should be written
	  as

		:- pce_class_directive(Goal)

	  with the exception of:

	        :- send(@class, ...).
		:- use_class_template(Template).

	  which are tagged automatically (but it is not forbidden to
	  use pce_class_directive/1 explicitely.

* PROWINDOWS: Many small fixes to various parts of the code.  All the manual
  and demo tools are working perfectly now (using Quintus Prolog 3.2).

* EDITOR: Fixed ->position right after editor is created.

* FIXED: Memory management problem in class regex, related to cloning
  and destroying regex objects.  Lead to various types of errors.

* ALLOC: Removed some dead code, making it a bit faster and cheaper.
  Made checking in ALLOC_DEBUG mode more strict.

* FIXED: `object ->save_in_file'.  Bug was introduced in 4.8.10.  Also
  fixed saving windows (including their frame).

* DIALOG EDITOR: Various minor modifications leading to version 0.5.
	* Ported to Quintus for ProWindows.
	* Better readability of the behaviour model ports.
	* Correct handling of the size of editors.
	* Fixed code generation for cycle menus.
	* Added (rudimental) support to communicate between dialogs
	* Added handling of function objects in the behaviour model.

* FIXED: Utility predicates portray_object/[1,2] to handle recursive
  objects.  Also added rules for booleans, quote_function and when.

* FIXED: Handling data for sockets only works if the display is opened.
  This is now opened automatically.

* ADDED: `socket <-peer_name' to find address of socket at other end.

* FIXED: SGI/IRIX autoconf generation of the LDSOFLAGS value -shared and
  POINTER_OFFSET for all machine needing this macro.

* ADDED: `real <-compare' to allow sorting chains on the value of reals.

* FIXED: popup_gesture: handling of focus such that programs using
  window?focus_event?<something> will work again.  Fixes the dialog
  editor.

* ADDED: Bold style to M-x manual_entry in PceEmacs.

* FIXED: pce_image_directory/1 resulting in an undefined method when
  used before any graphical operations.

* FIXED: `directory ->scan' to include files starting with a dot if the
  pattern includes this.

* FIXED: Avoid previewing non-active menu items in popup menus using `stayup'
  mode.

* FIXED: Dialog Editor code generation for cycle menus.

* FIXED: Finding the demo sources.

[VERSION 4.8.10]

* FIXED: Redraw problem when displaying windows in windows.

* FIXED: socket <-address now yields valid address (port) after the sequence
  new(S, socket(0)), send(S, listen, message(...)).  Killing the pce_server/1
  using the exit command now works properly as well.

* FIXED: editor repaint problem for word-wrapped long lines holding hidden
  fragments.

* FIXED: popup_gesture->terminate: ensure to release focus when activating
  `popup ->execute'.  Fixes event-focus problem with stayup-popup style.

* ADDED: Indirection over `link <-connection' for handling
  `graphical->connect'.  Allows for easier to modify the connection
  behaviour of class connect_gesture.

* FIXED: browser/OpenLook Scrollbar: middle click in scrollbar activated
  the browser's <-open_message.

* FIXED: library(pce_drag_and_drop_dict_item) now uses <-label to be dragged
  rather than <-key.

* MODIFIED: dict_item <-key may now be any object.  dict_item<-label may
  be any char_array object (normally either string or name).  Improves the
  flexibility of dicts and saves space on the name-table.  Notable, some
  applications may wish to use integers as keys.

* ADDED: Generation of coloured PostScript for all graphical, except for
  pixmaps. (will follow later).

* ADDED: Improved schema to handle shared resources with object save/restore.
  See `object<-storage_reference'.

* FIXED: Postscript generation for pattern-filled objects.

* ADDED: Generation of PostScript grey-maps from coloured image objects.
  Makes screen-dumps and PostScript generation of diagrams containing
  coloured images much better.

* ADDED: Image interface for PNM (PPM, PBM, PGM): Portable aNy Map format.
  Allows for reading and writing colour images.  PNM is the central format
  of a set of public domain tools for the conversion of bitmaps to numerous
  formats.  Added format argument to image->save for saving in different
  formats.

  A variant of the PNM format is now used for storage of images in saved
  objects (`object ->save_in_file'), providing display-independent saved
  images for all versions of XPCE.  This fixes bugs in save/reload of
  PceDraw pictures holding captured windows.

* FIXED: Incremental garbage-collector error.  The incremental garbage
  collector missed objects reaching 0 reference count when not running
  in debug mode.  This fix should have serious impact on memory usage.
  There may be cases where old code used to run and now yields `bad PCE
  integer reference' or `send to freed object' warnings. If you know
  what object is deleted, you can try to find the context of the
  deletion using:

  ?- get(class(<theclass>), send_method, unlink, M),
     send(M, trace, @on, full,
	  message(@pce, print_stack, 10, @on)).

  Which will cause a dump of the top-10 stackframes whenever an instance
  of <theclass> is destroyed.

* ADDED: Automatic mapping of colours to nearest available colour if the
  colour map is full.  Avoids `PCE fatal error: red: ->_xopen failed"
  messages (notably on colour displays when running together with netscape
  that unkindly allocate lots of colours).

* ADDED: `colour ->unlink' and changed definition of class colour such that
  colours are destroyed if they reach 0 reference count.  This should minimise
  the amount of colours used by XPCE.  Colour objects no longer have a global
  reference.  Thus, @white_colour, etc. no longer exist.

* FIXED: Better checking for valid colour specification in colour->initialise.

* PERFORMANCE: Various minor and major changes to improve performance:
	+ Exploit new SWI-Prolog 2.0.10 C-interface function PL_univg()
	  to speed up the interface.
	+ Prolog interface GetCompound changed to exploit name interface
	  table.
	+ cToPceReference() reimplemented
	+ Type-checker improvements
	+ Efficient structure initialisation for new objects by maintaining
	  a prototype
	+ Editor Fragment-linking algoritm improved

* ADDED: Lazy method-binding schema to speedup loading of Prolog (precompiled)
  files.  Changed pce_term_expansion/2 and adds various features to class
  class.  Should be 100% compatible, except for applications redefining
  PCE's term_expansion.

* FIXED: hash-table resize problem that wasted memory (result was ok).

* ADDED: `always' argument to `graphical ->synchronise'.  If not @on,
  synchronise will be a no-op if the last executed synchronise was less
  then 200 milliseconds before.  Symplifies user-interaction in loops.

* FIXED: Bug in `text_buffer <-content'.  Could lead to various kinds
  of problems depending on the memory layout of the target system:
  false answer (too short, padded with rubish) or crashes.

* FIXED: `image ->draw_in' if the object has <-selected: @on.

* FIXED: Redraw of figures with >0 ->border and an outline/background.

* FIXED: `directory ->scan' to honour the hidden_too argument if the same
  chain is given for files and directories.

* CLASS COMPILER: Changed various things to the method resolution system to
  allow for lazy binding of methods.  See `class <->resolve_method_message'.
  This changes the class compiler and the semantics of pce_expand/2.

* FIXED: Bug in `display_manager ->dispatch'.  May have let to crashes on
  some platforms.  Once the system has an open window the problem
  (initialisation ordering) was gone.

* ADDED: `connection ->event' to consider recognisers associated with the
  line of the link.

* FIXED: 'text_item ->advance: clear'.

* FIXED: pce_autoload(class, demo(ispell)) and similar calls.


[VERSION 4.8.9]

* ADDED: PostScript generation for *all* graphical objects using intermediate
  image objects.  See `graphical ->_draw_post_script'.

* FIXED: PostScript generation for graphical objects filled with a solid
  colour object.

* ADDED: WinSock support for the win32 port.

* FIXED: elevation handling associated with `figure->elevation', followed
  by figure->background.  Now uses the new method `elevation <-modify' to
  avoid messing up read-only elevation objects.

* CHANGED: Library structure for demo and contrib modules.  Instead of
  library('demo/something') or library('contrib/something'), you should
  now use deme(something) or contrib(something).  Part of ProWindows
  integration.

* FIXED: event-processing for normal graphical objects displayed on
  instances of class tree using `tree->display'.

* FIXED: redraw problems when modifying the area of graphicals displayed
  on a figure with a defined outline or background.

* CONFIG: All references to stdin/stdout/stderr in the library have been
  wrapped into a small layer defined in itf/console.c to allow for window
  based I/O.

* FIXED: Class editor will pick the window's keyboard focus when clicked
  on.

* C-interface: added class c_pointer to pack arbitrary C void * in an XPCE
  object.  Added interface function cToPcePointer(void *ptr) to convert
  C-pointers into XPCE objects.  Currently used by the C/C++ interface.

* CONFIG: use alien types for passing text-access functions to class text_image.
  avoids the need to smash a C-function pointer into a XPCE integer.

* CONFIG: added WORDS_BIG_ENDIAN configure option to replace __i386__
  dependency.

* FIXED: `regex->for_all' for regexes that can match the empty string to avoid
  loops.

* ADDED: `text_buffer <-clone' hooks to realise proper cloning of the alien
  data associated with text_buffer objects.

* MODIFIED: library predicate pce_server/1 now exits the server when receiving
  the `exit' command.  xpce-client will terminates immediately on reaching
  end-of-file in the input.  With the -b flag it will wait for the socket
  to be closed by xpce.

* FIXED: class(window) save-style for <-current_event and <-focus_event set
  to `nil' to avoid saving event objects.

* FIXED: `fragment ->string' for subclasses of class fragment that redefine
  the ->emptied method to destroy emptied fragments.

* MODIFIED: `directory <-{file,directory}' only uses the path of the receiver
  if the name of the argument is not absolute now.

* ADDED: `fragment ->include' to determine whether or not the start/end
  is included in the range.  Determines expansion if the insertion takes
  place exactly on the border.

* FIXED: `regex <-match' while operating in a fragment object.

* MODIFIED: Added `move_end' argument to `fragment ->start'.

* MODIFIED: The fragment-list of class text-buffer now ensures that, if
  two fragments start at the same position, the larger one is first in
  the list to improve the notion of `nested' fragments (order used to
  be undefined).

[VERSION 4.8.7]

* FIXES: Integrated Quintus' modifications to 4.8.0.  Mostly portability
  issues.  `frame ->expose' now guarantees the window is mapped before it
  is exposed.

* CONFIGURE: added support for runtime version generation:
  configure --enable-runtime.

* ADDED: `style ->left_margin' and `style ->right_margin'.  Raised the maximum
  number of arguments to C-defined methods from 10 to 16 for style->initialise.

* FIXED: `editor ->selected_fragment_style' when defining the colour of the
  characters.

* FIXED: class -><undefined method> lead to a delegation loop.  Bug introduced
  with class_stub (4.8.5)

* MODIFIED: Class tree is now a subclass of class figure instead of class
  device.  Allows for use of ->background, ->border and ->pen.  As figure
  is a subclass of device, this should not have compatibility consequences.

* ADDED: `tree ->root' may be used to clear the entire tree as well as to
  assign a new root to the tree.

* ADDED: PceEmacs: `Prolog/Source File' to jump to any loaded sourcefile.

* ADDED: PceEmacs: outline mode.  Specification is experimental.
  Suggestions are welcome.  Currently implemented for Prolog and C
  modes.

* ADDED: `style <->hidden' to implement `hidden' text fragments: text that
  remains in the buffer, but is invisible to the user.

* UPGRADE: Class regex has been upgraded to use version 0.12 of the GNU
  regex library from emacs 19.28.  This appears to fix a number of bugs
  in searching and matching.  Unfortunately the new regexes are not 100%
  compatible to the old:

  INCOMPATIBILITIES:

	# prefix\(repeat\)+postfix
	Used to return as register 1 the entire span from the first to
	the last matched `repeat'.  Now only returns the last.  Please
	use prefix\(\(repeat\)+\)postfix to get the desired behaviour.

  FIXES:

	# `regex <-registers' now really works.
	# \(repeat\)* now appears to match very long texts

[VERSION 4.8.5]

* FIXED: PceEmacs: script-mode now makes menu.  Otherwise mode refinement
  doesn't work properly.

* FIXED: PceDraw middle-click on text objects `pasted' always.  Now only
  if the text object has the caret.

* FIXED: <-displayed handling of windows when displayed on other windows.

* EXTENDED/FIXED: 16-bit character support:

	* Fixed `editor ->insert_self' for 16-bit values
	* Fixed character classification for 16-bit characters
	* Fixed methods using newline, tab and space constants
	* `key_binding ->typed' calls <-function, so this may be
	  redefined.

* ADDED: Introduced class class_stub above class class.  Intended for
  lazy creation of classes in a foreseen modification of the class
  compiler.  This modification itself will ensure better and faster
  runtime generation, but is delayed due to more urgent matters.

* ADDED: Defined load/save format to load/save plain char_array objects
  using ->save_in_file and `file <-object'.

* DIALOG EDITOR:
	- Improved guessing of horizontal layout intentions
	- Fixed destruction of various parts
	- Added optional port system for `expansions' in the behaviour

* FIXED: `editor ->dabrev_expand': first hit didn't expand if the same word
  occurred as first hit before the word to expand.  Also, button-down
  events now reset the `editor <-focus_function', canceling isearch,
  dabrev and other `local' modes.

* ADDED: `Stayup' popup handling style: clicking on an object with a popup
  or menu-bar will open the popup and allow you to click on one of the items.

* FIX: ClassHierarchy tool destruction.  Lead to a message to a freed object
  if, while the tool is running, subclasses are created below class class
  (tricky programming, but used by PceEmacs).

* ADDED: `image <-convert' now converts graphical objects.

* ADDED: `method <-summary' is now a real method.  It the slot is filled with
  @default, this method will try to look up the summary from a variable or
  refined method.

* FIX: Activate pce_group/1 declarations in variable section.

* FIX: Error handling if the display cannot be opened.  Now avoids generating
  errors in a loop and prints an elaborate user-friendly error message.

* FIX: PostScript generation for shadowed and rounded boxes.  Shadow was not
  generated in the versions 4.8.[1-4].  Generating PostScript for boxes with
  a too large radius gave `interresting' results.

* FIX: `text_buffer <-scan' with `word' unit and a syntax table that defines
  end-of-line as end-comment and the scanned word ends at the end of the file.

* FIX: Colour handling (X11 binding) that could cause colours to appear
  wrong when image related operations occurred while redrawing.

* ONLINE MANUAL: Many changes.  Look at it and donot forget to read the new
  help page.  Many manual cards have been updated.  Various cross links and
  examples have been added.  hot-links to predicates and examples are now
  provided.

* PERFORMANCE: Lazy creation of `dict <-table'.  Many dicts never use this
  table.  The table is now automatically created if the dict contains more
  than 50 items and <-member is called.  The method <-table also creates
  the table, so applications should not be affected by this change, even
  is they address the table directly.

* FIX: `graphical ->copy' did not copy the colour attribute.  Used when
  instantiating links to connections.

* ADDED `event <-click_time' and `event <-click_displacement' to simplify
  detection of `neat' clicks.

* INCOMPATIBILITY: Text objects (instances of class text) now have ZERO
  WIDTH if they contain no text.  Non-zero width was used in old versions
  to ensure the caret was inside the redraw-area.  All versions 4.8.x adopt
  a different changes schema that takes care of the caret without extending
  the area.  The current approach generally improves alignment and allows for
  texts to be displayed immediately adjecent.

  Most applications should improve.  Application that took care of this or
  relied on the few extra pixels should be fixed.  Note the existence of
  `text ->border'.

  This modification should also fix PostScript scaling problems with short
  text objects.

* ADDED: `popup->drag' and `popup->show_pullright_menu', implementing parts
  of the `popup->event' method.  The aim is to make this method easier to
  understand and allow for redefinitions to realise different look-and-feel.
  Same for `menu_bar <-popup_from_event' and `menu_bar ->show_popup'.

* ADDED: `event->is_drag' to quickly test for any kind of drag event.

* FIXED: immediate abort when there are failing make-runs in one of the
  subdirs (maintenance/development only).

[VERSION 4.8.4]

* ADDED: warnings for some common class-compiler misusages.

* ADDED: pce_error/2 in pce_pl.pl (SWI-Prolog binding) to exploit the
  generic source-location an warning system of SWI-Prolog.

* SYNCHRONISED: MS-Windows 3.1 and Unix versions.

* FIXED: `editor ->kill' for `adjecent' kills that exceed more than 10K
  characters (crashed).

* Various minor memory management problems (found with strict checking version
  of the alloc.c module).  Most of them just `unelegant', a few could cause
  trouble in rare circumstances.

* FIXED: Class menu_bar and class scroll_bar look-and-feel for non-open-look
  styles.

* MODIFIED: `Button <->font' renamed to `Button <->label_font'.  Ensures
  more consistent handling of resources.  `Button ->font' is added to handle
  compatibility.

* ADDED: `@pce->has_feature' to test for certain features supported in this
  version.

* ADDED: `@pce->iconify_console' to iconify the console window, provided
  this is possible.

* FIXED: `window ->unlink' deletes the window from ChangedWindows.  Fixes
  crashes in the Windows version, but the Unix version may also suffer from
  this problem.

* Included Quintus PW3 patches (Quintus compatibility).  XPCE 4.8.4 requires
  SWI-Prolog 1.9.5 or later.

* Improved changes management in class menu_bar (faster screen update).

* Fix in cycle detection in class node.


[VERSION 4.8.3]

* Renamed some *[cC]++* files and directories to *cxx* or *CXX*.

* Updated for SWI-Prolog 1.9.4, which no longer allows for local redefinitions
  os system predicates.  Also updated pce_require.pl (to generate the require
  directives) to watch for system-predicate redefinitions.

* FIX: Window (re)size problem that could result in bad window layouts,
  notably for fixed-size windows (happens very rarely).

* FIX: PceDraw: Proto/Delete (was never activated).

* FIX: area calculation of class arc.  Fixes redraw problems on arcs where
  start_angle + size_angle < 0.


[VERSION 4.8.2]

* INSTALLATION: XPCE is now configured using GNU's autoconf toolkit, simplifying
  installation.  Requires SWI-Prolog 1.9.2 or later (also configured using
  autoconf) for automatic linking to SWI-Prolog.

* ADDED: PceEmacs: `@emacs->check_saved_at_exit', called at `@pce->die'.
  Allows you to stay in XPCE if you leave any unsaved buffers.

* ADDED: PceEmacs: `emacs_buffer->check_modified_file' to check whether
  the file was modified.  Used to be part of ->modified only.  Now the
  check is also called from ->open, avoiding you viewing an out-of-date
  file.

* FIX: `@display ->dispatch' if the display is not yet opened.

* CHANGED: PceDraw now exploits class templates for a much more compact
  definition of its shape classes.  Public schema for extending PceDraw
  has been added (prototype).

* CHANGE: new/2 and friends now give a warning if the 1-st argument is
  not of the form @<atom>, @<var> or <var>.  Traps accidental reuse of
  already instantiated Prolog variables.  Actually also reveiled an
  error in font-management of the online manual reader!

* ADDED: `joint <-default_arrow' as an explicit method which should return
  the default arrow to be used for `joint ->arrows' and friends.

* ADDED: Function object @class, pointing to the currently compiling class.

* FIX: PceDraw: Background `Select Mode' menu.

* FIX: Class text positioning of centered text.

* ADDED: PceEmacs argument-prompting history added.  Using
  M-p and M-n, you can now go through the history of the current
  command.  Special purpose prompt routines have been removed to make
  the history accessible for all commands.

  A formal PceEmacs extension protocol is added.  See Help/Customise
  in the PceEmacs menu-bar.

* FIX: `meta-class' refinement through subclassing class `class' works
  again.

* FIX: `chain->move_after: member' failed if chain holds member as it's
  head.  Should succeed (and now does so).

* HOOK: Split `key_binding ->typed' into various pieces, so it is easier
  to specialise on this.  Used for M-x command history in PceEmacs.

[VERSION 4.8.1]

* ADDED: auto_call/1 to simulate an autoload call on standard Prolog
  systems.

* CHANGED: PceDraw and PceEmacs now uses @helper to display help.

* CHANGED: Many changes to the online-help library: automatic generation
  of table of contents and concept index, menus, automatic recognition
  of @colour_display, etc.  File format and programmatic access is
  compatible.

* FIXED: `Ispell' demo now works with both Ispell version 3 and 4 (change
  in communication syntax from ispell).  Also, ispell is now more careful
  in using fragments, so text_buffers using fragments may be `ispelled'.

* FIXED: `menu ->_redraw_area' deferences an invalid pointer.  Crashed
  on Irix machines.  Also fix to instantiation of X11-counterpart for
  images.  Thanks to Jan van der Steen (jansteen@cwi.nl), who also created
  new up-to-date Irix machine description files.

* CHANGED: Hyper-text help library.  Many new features added.  This library
  is now used for an XPCE FAQ (through the manual File/Faq menu), PceEmacs,
  PceDraw and various other demo's.

* ADDED: optional `ignore_case' argument to `char_array <-compare'.

* ADDED to show_key_bindings/1 window: popup menu for switching to the
  documentation as well as the source for some method.

* Implemented: `@pce ->console_label: label'.  This method was already present
  in the MS-Windows version.  The Unix version will issue the proper escape
  sequence of an xterm(1) window if $TERM equals xterm (\033]2;label\007).


[VERSION 4.8.0]

* Changed location of the X11 resource-file Pce.  XPCE now adds PCE's
  home directory to the environment $XAPPLRESDIR, so XPCE will always
  load `@pce <-home'/Pce for finding resources.  This simplifies the
  installation and allows for different versions of XPCE to have
  different resource databases without conflicts.

* Improved OpenWindows emulation on scrollbars: 3-D version for colour
  displays, better event-handling.

* CHANGED: Focussing keyboard input has changed considerably.  The aim is
  to gain compatibility with `non-XPCE' graphical applications, to give more
  control to the application programmer and to allow for showing which object
  will receive keyboard input visually.  Methods affected:

  	`frame ->input_focus'	(changed semantics)
	`frame ->input_window'	(new method)
	`frame ->keyboard_focus'(new method)
	`window ->input_focus'	(new method)
	`window ->has_pointer'	(new variable)
	`window <-grab_pointer'	(deleted variable)
	`frame -has_returned'	(deleted variable)
	`text ->show_caret'	(now @off, passive, @on)
	`text ->event'		(new method for handling caret activation)

  The event-types activate_keyboard_focus and deactivate_keyboard_focus have
  been added (below type focus; see event-hierarchy demo program).

  It is unlikely that existing source-code is affected by these changes.
  Applications that want to redirect keyboard input should now consider
  using `frame ->keyboard_focus' instead of posting the keyboard event to
  the window that is supposed to receive the input.  This will send the
  necessary focus-changing events.

* Added interface predicate pce_group/1.  This predicate defines the functional
  group to which subsequent methods will be attached.  See predicate browser.
  Currently tested on class draw_canvas (part of PceDraw).  Slowly this will
  be used in more and more classes to enable quick and more useful overview
  of Prolog defined classes.

* FIX: `window ->normalise' normalised point(0,0) when given an empty chain
  of graphicals.  Now it does nothing if the union of the graphicals to
  normalise on contains no points.

* Colour handling handling feedback on selected graphicals by other means
  then using selection.  Changes:

  	* Added window <->selection_feedback (feedback on this window)
	  Allows for invert, show inverted blobs, use colour or use
	  an elevated area.
	* Added graphical ->paint_selected to paint the selection attributes
	* Added Pce.Graphical.selection_handles to define how to paint the
	  inverted blobs if this mode is choosen.
	* Deleted `class -selection_style' and Pce.Graphical.selection_style

  These changes should in most cases allow for the usage of the built-in
  graphical selection mechanism instead of reprogramming it as is commonly
  done currently.

* Dialog Editor: fixed code generation for layout.

* CHANGED: `object ->attribute' now accepts both

	send(Object, attribute, attribute(Name, Value))		and
	send(Object, attribute, Name, Value)

  which is a more pleasent syntax and avoids the creation of an attribute
  object when an attribute value has to be changed.

  INCOMPATIBILITY: send(Object, attribute, Name) in earlier releases
  was equivalent to send(Object, attribute, attribute(Name, @nil)) and
  is now interpreted as send(Object, attribute, Name, @default).

* Added class @=, an executable object to assign names to objects.  This allows
  writing myfont @= font(myfamily, mystyle, mysize, my-x-ref) and similar
  constructions in the Xdefault file.

* PceEmacs: Added `emacs_language_mode ->visit_tag_file' to allow switching
  tag-files.  Added completion for finding tag entries.  Fixed the
  switch_to_buffer pullright menu to include the plain buffer-names
  instead of the capitalised ones.  Bound \es (ESC-s) to ->sticky_window,
  toggling the sticky status of the current window.  Improved finding
  current directory in shell-mode (compilation) windows, now also considering
  output from GNU-make 3.71.

* Fixed library class file_item to properly handle somedir//newpath, etc.

* Reimplementation of `text_image ->_redraw_area'.  The `double buffering'
  of this class has been removed as it turns out that most X-servers are
  very could at painting text and not extremely good at copying large
  rectangles.  This reduces memory usage both in XPCE as on the X-server
  drastically.

* Added '#<hexdigits>' conversion for class colour.  Allows for X11
  compatible RGB colour specification.

* Added: make `graphical ->_redraw_area' an explicit method.  For the time
  being this just allows for traceing this method for debugging redraw
  problems.

* Fixed: <-summary of `boot-classes' (classes created in a special way to
  avoid the chicked-and-egg problem) has no summary description.  Fixed.

* Fixed: class(object), now correctly translates to the object reference.
  (special case as object has no <-supers).

* Fixed: `frame <-image' and `frame <-postscript' for frames that are displayed
  partly off the screen.

* Class Hierarchy Browser (Manual Tools): added resources to let the user
  distinguish between user-defined and built-in classes.

* Introduced class `elevation', to describe an elevated area: height,
  colour and colour of the edges.   Also added `colour <-hilite' and
  `colour <-reduce'.

* Introduced class `pixmap'.  Basically an image of <-kind: pixmap.  The
  explicit class facilates type specification and conversion.

* Moved `dialog_item ->apply' and `dialog_item ->restore' to class graphical.

* Added: `text <->border', providing additional space around a text object.

* Replaced `text <->transparent' by `text <->background', allowing for
  arbitrary background.  `text <->transparent' is mapped on this new
  method for compatibility reasons.

* Added: `bitmap <->transparent' to define bitmaps with non-rectangular
  shape.  Added this as a second optional initialisation argument.

* Modified resource-syntax.  Resources now use a syntax very similar to
  the Prolog syntax for objects.  For example:

  	Pce.Dialog.gap:		size(10,10)

  Old-style resource specifications are still handled, but raise the
  error `old_resource_format'.  You can use this error (by default just
  prints a warning) to locate incompatibilities or invoke:

  	?- send(error(old_resource_format), kind, ignored).

  to stop the system complaining.  The resources Pce.Display.font_families
  and the font-family implementing resources do *not* convert the old
  format.  As these will not very often be redefined by the user, this
  should be an acceptable burden.

  The reason for this is to allow for specification of resource-values
  for ambiguously typed resources.  For example, type colour|image makes
  translating a name ambiguous (either a colour-name or an image-file
  name).  In the new system, you may use `colour(red)' and `image("pce.bm")'.

  See `resource <-convert_string' for details on the new syntax.

* Resource handling and representation:

  + Class resource changes:

	# deleted: `resource <-obtained'
	A resource is not obtained if its <-value equals @not_obtained
	(a constant)

	# added: `resource <-convert_string'
	Converts the string-value read from the `resource <-default' or
	the X11 resource system in to a value satisfying the <-type.

	# Added: @resource_parser
	This global object parses resource specifications.

  + Modified resource inheritance.  Resource definitions with classes need no
  longer to be redefined at each sub-class to be able for the user to
  modify the resource.  The system takes care of refinement of resources
  when necessary, while sharing as much as possible of the data-structures.
  Lookup of resources has been speeded up drastically.

  + Flag to speed-up `object ->obtain_resources' on multiple calls to this
  method.

* Improved colour-handling:
	- Allow (window) background to be both an pixmap or a colour.
	- Allow graphical colour to be both pixmap or a colour.


* Added `timer ->delay' to allow suspension of the XPCE process in a
  host-independant fashion.

* Redraw now maintains multiple update-areas.  This change has provides
  an incredible speed-up for some applications.	 The infra-structure
  has been set-up for further advanced redraw planning in the future.

* Library naming.  The libraries pce_drag_and_drop.pl and
  pce_drag_and_drop_dict_item.pl have been renamed in dragdrop.pl
  and dragdict.pl to satisfy DOS naming conventions.

* Frame OPEN/CLOSE/ICONISE issues.  The port to MS-Windows made it
  desirable to clean-up the various interacting methods dealing with
  opening, iconising, mapping, etc. of frames.  All is now handled
  by the central method <->status.  `Frame <->show' and <->iconic
  are mapped onto this new method for compatibility reasons.
  `Frame ->mapped', invoked from the X11 interface has gone.  The
  most likely usage of this method is to wait for a frame to be
  open.  This functionality is now realised by the new method
  `frame ->wait'.

* Implemented MS-Windows-3.1 version of the `Virtual Window System
  Interface'.  See source directory msw.  Additional methods for the
  MS-Windows implementation: `@pce ->console_label' and `@pce
  ->expose_console' to manipulate the console window.

* Complete reorganisation of C-source directory structure and Makefiles.
  Aim: simplify installation, reduce Unix dependency and limit filename-
  length requirements.

* Definition of class stream as a superclass for socket and process to
  share the details of asynchronic communication.  Will probably be
  integrated further.

* Virtual Window System Interface now includes the classes display and
  cursor.  For class display, this implies that some old `hacks' are
  no longer possible.  To determine the display is open, use
  `display <-opened' instead of `display <-slot: display_xref'.  The
  depth of the display is requested using `display <-depth'.  The old
  hack `display <-slot: depth' no longer works as this slot has disappeared.

  Vanished slots on class display are: display_xref, shell_xref, root_bitmap,
  pixmap_context, bitmap_context, depth, white_pixel, black_pixel,
  foreground_pixel, background_pixel and colour_map.  All this data is
  not private to the X11 inplementation of the Virtual Window System
  Interface.

* Modified: `text_buffer <->character' now fails if the index is out of the
  range of the text-buffer

* 8/16 bit version of text-representation classes

* Added: `string ->insert_character'


[VERSION 4.7.2]

* Added: overview of delegation to ClassBrowser.

* Added: library('man/behaviour_item') for entering XPCE behaviour references
  using completion.  Used by PceEmacs for M-x manpce and M-x editpce and
  by the manual card-browser for a `goto' field.

* Modified: `@emacs->server_start: Force:[bool]': Added `force' argument.
  When not @on, the server will only be started if no server exists.

* Fixed: ensured call to `window<-resize_message'

* Fixed: removed errornous error-message from `node->son' to make this
  method succeed without side-effects if the son-relation is already true.

* Compatibility: Fixed initialisation of `style <-colour' when loading old
  files.

* Fixed: trees using multiple-inheritence (e.g. directed graphs with a single
  source) did not handle `collapsed' nodes correctly.

* PceEmacs: fixed using selection as default value when prompting for files.

* More QP integration stuff: renamed emacs.pl and demo.pl into pce_emacs.pl
  and pce_demo.pl.  Some more initialization directives.

* Added: menu <->vertical_format to control the vertical alignment of items
  in their box.

* Fixed: unalloc() regex `fastmap' on ->unlink.  Fixes memory leak on
  optimised (regex ->compile: @on) regular expression objects.

* Added: `menu ->members' to set the <-members of a menu with one message.

* Added: `editor ->styles' to associate a new style-sheet with an editor.

* PceEmacs: make server windows `sticky', redefine \C-x# to mean `quit'
  for non-server windows and kill-buffer-and-return-server for server
  windows.

[VERSION 4.7.1 (PW-3 1.1 == 4.7.1 including a few patches from 4.7.2)]

* Modified Makefile to avoid the macro C++, which is refused by many
  versions of make.

* Added Makefile-i486-linux and friends for linking to Linux 1.0 (tested
  using the Slackware 1.2.0 distribution).

* (re)integration of SICStus interface: added prolog/boot/pce_expand.pl.
  this file is supposed to be loaded *first*.  the module pce_host is
  supposed to define property/1 describing some aspects of the Prolog
  system.

  XPCE/SICStus still does not run due to a bug in SICStus 2.1#8.  An
  fix has been promised by SICS for 2.1#9.

* Added: PceEmacs `fundamental_mode ->goto_line'

* Fixed: list_browser search as called by the text-item completion
  function.  Caused a name-table inconsistency if completion was
  requested without initial value, there was no common prefix to the
  extensions and the user tried to search the list_browser ...

* Fixed some minor problems in the reference-manual generation software
  and some group-inconsistencies.  Minor updates to the reference manual.


[VERSION 4.7.0]

* Fixed: reporting of `unresolved' types by checkpce/0 for types which
  context class has an autoload declaration.

* Modified: Default font-set generation.  See Pce.Display.font_families
  and `display ->load_fonts'.  See also README.font

* Fixed: `event ->is_a' for 8-bit characters.

* Fixed: Serious name-table hash-performance degradation, generally
  occurring with more than about 7000 XPCE names.

* Modified: Visual-hierarchy: added `dict' between `browser' and
  `dict_item'.  This is both conceptually clearer and drastically improves
  the speed of ->destroy'ing large browsers.  Browsers are now tested to
  be really fast upto 25.000 items on a SPARC-II.

* Modified: graphical <->fill_pattern now also accepts a colour argument:
  send(Box, fill_pattern, colour(green)) make the *interior* of the box
  green.

* Fixed: Various bugs in image objects of <-kind: pixmap, notably
  colour handling: proper handling of <-background and <-foreground,
  proper opening and association with a display, proper read and write
  of individual pixels.

* Added: `visual <-container: class|code': find enclosing visual that
  satisfies condition.

[VERSION 4.6.15]

* Fixed: `window ->typed' when nested in a decorator (pictures).  This method
  handles global menu-bar accelerators.

* Added: `object ->unlinking': test if object is currently beeing unlinked
  (freed).

* Fixed: added global declaraction for @default_syntax_table.

* Added: graphical ->_redraw_area.  Allows plain graphicals to be displayed.

* Fixed: declaration of return-type of `regex <-register_value'.

* Modified: `device ->compute' no longer clears the bad_format variable
  if there is no attached format (internal).

* Added `text ->margin: Width wrap_fixed_width' which is like `wrap',
  but the <-width of the text (as a grapical) is fixed to margin value.

* DELETED `text_item ->caret' and introduced `graphical ->keyboard_focus'.

* Integration of keyboard-input for list_browser and editor: definition
  for _wants_keyboard_focus, ->next and related methods.

* MODIFIED: (list_)browser <-selection FAILS is there is no selection
  AND the multiple_selection equals @off.  Earlier releases returned
  @nil in this case.  Code written as

	get(Browser, selection, Selection),
	(   Selection == @nil
	->  bla bla

  Will have to REWRITTEN.  Most source will be unaffected however.

* Manual Tools, History menu fixed for groups containing a class
  (no-behaviour error).

* Fixed: `file ->find' for `refinding' a file from a restored object.
  Fixes bug in reloading image objects from files (file <-object) if
  the absolute pathname has changed since the ->save_in_file.

* Added: Prolog module pce_host (Prolog implementation binding):
	- callable_predicate(+Module:Head)	True if can be called
	- modified_since_last_loaded(+File)	True if file has been modified

* Fixed: ClassHierarchy: error message when asking menu on a leaf-node.

[VERSION 4.6.14]

* Restructuring of Prolog libraries:
	- Added dialog editor tool
	- Calling of dialog editor and emacs from the manual-tool menu
	- New Prolog libraries:
	* make_dialog.pl: make_dialog/2: Realise dialog built using
	  Dialog Editor.
	* pce_image.pl: pce_image_directory/1: declare a new image directory
	* pce_helper.pl: Application help-system.
	* pce_tagged_connection.pl: Connection with a tag in the middle.

* Added: `source_location <-convert' to allow editing files using
  send(@emacs, edit, 'hello.pl').

* Fixed: class <->resource if the class was not yet ->realised

* Reorganisation to prepare ports:
	- Converted to fully prototyped ANSI C.  Fixed some minor
	  bugs in the course of doing this.
	- Defined abstract window-system interface for the classes
	  window and frame.  X11 implementation thereof.

* Improved QP compatibility together with Mike Vines (AIIL): added
  :- initialization where needed, autoload definition, various
  misplaced :- meta_predicate declarations, etc.  Requires
  SWI-Prolog 1.8.9 or later to run (improved quintus.pl library).

* Fixed: drag_and_drop gestures under mwm Window-Manager

* Solaris patches:
	- Fixed starting inferior processes in PceEmacs
	- Fixed M-x manual_entry for other sections (man -s)


[VERSION 4.6.13]

* Fixed: path->initialise_new_slot to call graphical->initialise_new_slot
  (Fixes saved-object conversion for class path).

* Changes library(pce_postscript) for Quintus compatibility.

* Fixed: `key_binding->typed' when invoking a method accepting more than
  2 arguments.

* Avoid a number of useless messages to the completer of class text_item.

* Fixed: `frame ->expose' to properly set <-show: @on.

* PceEmacs: ensure that deletion of the window works (doesn't really
  quit emacs; just ->show: @off it).  By default does not show the buffer
  menu.  Added show_buffer_menu to the file menu.  Fixed `reload'
  after trapping modified buffer.  Indicate modified buffer in title
  bar of window.  Added more `window-pools', Added pool to ->identify,
  etc.


[VERSION 4.6.12]

* PceDraw: fixed: clear modified on save.

* Moved `dialog_item <->active' to the level of class graphical.  Graphicals
  that are inactive are greyed-out and not sensitive to events (unless
  the ->event method is redefined).

* Fixed: `picture ->open' if the picture had been opened before, but was
  closed using `frame ->show: @off'.

* Changed: `dialog_item <->reference' handling.  Slot-value @default now
  computes the <-reference when requested.  Otherwise the value is
  returned.  Also improved alignment of class menu_bar.

* Fixed: drawing a bitmap of <-kind: pixmap onto a bitmap with <-kind:
  bitmap.  Maps all pixels in the source foreground to 1 and background
  to 0.  All other colours yield an undefined result.

* Added: optional `times' argument to `string->newline'.

* Changed: handling of absolute paths for class file.  The aim is to
  arrive at better portable load/save facilities.  The <-name attribute
  remains in the original specification (i.e. including ~ and or $var).
  ->absolute_path writes the <-path variable and leaves the <-name
  unchanged.  See class file for details.

  This fix should make file-related saved image objects portable to
  machines on which xpce is installed in a different place.

* Fixed: Class menu for <-on_image == @nil and <-off_image \== @nil
  (crash).

* Fixed: load/save of syntax_table objects on machine with different
  byte order representation (PC/Linux).  Declared save_style of this
  class `external'.


[VERSION 4.6.11]

* Tracer: when the tracer prompts for a value, possible pointer-grabs
  are released first.  Avoids hanging, notably when the tracer traps
  an error after a display ->inform

* The method `frame->fit' is now always called using normal message
  passing.  This allows for redefinition of this method in applications.

* Fixed: replaced ln -sf in install by rm -f ; ln -s

* Fixed: ranlib entry in makefile for systems lacking ranlib

* Fixed: `fragment->overlap' if the argument is a fragment or point
  (yielded incorrect results).

* Fixed: Syntax error on unx-directory.c for solaris.

* Fixed: C++ include files now define As... as `inline'.

* Fixed: Realising the event-type hierarchy when the tracer is on.


[VERSION 4.6.10]

* Added: `fragment ->emptied' which is called by class text_buffer if
  the fragment is emptied as a result of deleting text.

* Added: `fragment ->delete' for compatibility with class string.

* Fixed: regex->for_all: include type `fragment' (implementation could
  already handle fragments).

* Fixed: view, editor: copy obtained size resource!

* Added: `graphical <-popup', complementing `graphical ->popup'.

* Added: <-clone and ->save_in_file hooks for class editor.

* PceEmacs: M-x manpce now handles descriptions such as class->method,
  etc.

* Fixed: `text_item ->enter' now invokes ->typed: id, @on on its <-device
  in order to properly handle default buttons with nested dialogues.

* Fixed: delCodeReference() testing for freeing object.  This should FIX
  CRASHES IN ALLOC() recently reported.

* Added: `function ->convert_loaded_object' to allow objects to be loaded
  in debug-mode that contain functions.

* Added: `variable <-return_type' for consistency with class get_method.
  Changed: `variable <-argument_type' fails if variable has no send
  <-access.

* Changed: `list_browser ->show_label: @on' default label is no longer
  `Untitled', but <-label_name of `list_browser <-name'.

* Fixed: Crash in redrawing list_browser.  It is unclear whether the
  errornous status could only be reached on a reloaded (using `file <-object')
  list_browser or that normally created list_browsers could be affected
  by this bug too.

* Added: `object <-clone' interface for the classes text_image and
  list_browser.

* Added `vector->append: value ...', store value(s) from <-high_index + 1

* Added `dict->members', doing ->clear and ->append members of chain to
  the dict.

* Added: `directory <-directory: name': return (sub)direcectory.

* Fixed: incompatibility in loading object-databases with hypers created
  with version 4.6.7 or older.

* Added: save/load (object ->save_in_file) facilities for class list_browser
  and class text_image.

* Added: AsChain(), etc. types to C++ interface (see C++/demo/dir.C).  Fixed
  lazy creation of the host instance (for XPCE/C++ stand-alone programs).

[VERSION 4.6.9]

* Installation: replaced ln -sf by rm -f followed by ln -s for compatibility
  with BSD ln versions.

* Modified: PceEmacs: Paste while a prompter is active now pasts the
  value in the minibuffer rather than at the caret in the window.

* Added: `text ->insert' to insert text (by default at <-caret).

* Fixed: stop flagging the online manual database to `modified' after
  inspecting a user-defined class.

* Fixed: ClassBrowser search with scope : `sub'. Bug was introduced by
  the changed semantics of `class <-sub_classes' in 4.6.3.

* Fixed: IMPORTANT: improper handling of reference-counting by local
  variables.  Temporary code objects that include assign statements
  could upset reference-counting.  This caused unpredictable crashes in
  searching the online manual and after switching buffers in PceEmacs.

  This fix is extremely important for the XPCE/Lisp interface as
  !setq is translated into an assign object.

* Fixed: PceEmacs refusing to switch modes under some conditions.

* Changed: portray_object/2: types are 'portrayed' by their name.

* Fixed: reference to freed object in PceEmacs miniwindow prompter.

* Fixed: figure: redraw of outline/background on changes to the internals.

* Fixed: spypce(Class <-Selector): avoid evaluation of the implementing
  function.

* Added: PceEmacs: ->drop and ->preview_drop to include sources from the
  dialog editor.

[VERSION 4.6.8]

* Added: drag_and_drop_dict_item_gesture to the online manual list-browsers
  that allow dropping methods to the (experimental) graphical activation
  model of dialog windows.

* Added: library file pce_drag_and_drop_dict_item.pl, defining the class
  drag_and_drop_dict_item_gesture for drag-drop dict-items from a
  list_browser.

* Modified library file pce_drag_and_drop.pl for better extensibility.
  New features: <-warp to switch between putting the cursor in the
  center of the dragged object and not-moving the pointer.  Also,
  ->get_source defines a function on the graphical to determine the
  object dropped.  See library files and demo programs.

* Added: `dict_item <-position' to compute the location of a dict-item
  on the associated list_browser object.

* Fixed: error reporting for incompatible slot-value in saved objects
  (file <-object).

* Errors: fixed error id redeclared_reference (called by
  `object ->name_reference') to produce a sensible text.

* Class-compiler: give warning on non-ground type-specifiers.

* Fixed: SERIOUS BUG in class window_decorator.  Caused send(new(picture),
  open) to crash on PC/Linux pl14 (any maybe other OS/compiler combinations).

* Object save/load: added `variable <-save_style' (completeness).  Fixed
  `variable <-save_style: nil' interpretation by `object ->save_in_file'.
  This fixes a bug in storing cyclic structures containing attribute-links
  with save_style `nil'.

* Fixed: Positioning of popup-menu's on windows when the window is scrolled.

* Fixed: PceEmacs: dangling `emacs_mode <-editor' references after
  switching mode and deleting the window.

* Changed: `connection ->indicate' now passes the event object instead
  of the position as a point.  Fixes linking to specific handles when
  using `cross-device' connections.

* Added `key_binding <->condition': general condition to accept events
  as for class gesture.

* Added `event <-key' to get key-description from event as used by class
  key_binding.

* Object ->save_in_file: hyper-relations are only stored if both ends are
  stored.  Based on new (rudimentary) support for save/clone using
  `relation-semantics'.  This will be further extended in the future, but
  for the moment it allows using hyper-objects to objects that are subject
  to the save-mechanism.

* Fixed: `type <-kind: member': translation now verifies argument-type before
  calling <-member on the context.  Improves error-response on methods
  with argument-type `member:<something>'.

* Fixed: load library(pce_selection) in Inspector.  Avoids trapping
  undefined method `display ->copy' and properly exports the selected
  object to the X11-selection.

* Added Pce.TextItem.search_ignore_case resource to make completion on
  value-sets case-insensitive (default).

* Added (simple) detection for creating cyclic structures in trees.  Cyclic
  trees crash the layout algorithm.

* Fixed: line (with <-arrows) PostScript generation if the <-pen of the
  line is different from the pen of the arrow.

* Type syntax: <int>.. and ..<int> are now accepted as ranges ``from
  <int> to @pce <-max_integer'' and ``from @pce <-min_integer to <int>''.
  Added to some slots, but should be added to many more.

* Added: `function ->send_super' and `class ->install'.  Made
  `code ->execute' and `function <-execute' accessible for user-defined
  methods.  This together allows for user-defined executable (code) classes.

* Class message and ? (obtain): execution now evaluates the receiver the
  same as the arguments.  This implies that

	message(XYZ?something, '_instance_of', class)

  will evaluate the obtainer (once) before starting '_instance_of'.  This
  only effects messages if the selector is defined on class function or
  below and the receiver is a function.  As the previous definition was
  rather useless it is unlikely to effect compatibility.

* Fixed: redraw of menu-label with <->layout: vertical and <-label_format
  is right or center.

* Slider: grab focus on button-down.

[VERSION 4.6.7]

* Fixed: update menu layout on dynamically changing `menu_item <-label's.

* Fixed: `menu->execute' for menu's that have no <-members.

* Fixed: `menu ->clear' when menu is not displayed.

* Fixed: `frame ->append' if the frame is already mapped.

* VisualHierarchy tool: fixed typing integer references to the text_item.

* `device ->layout_dialog' and `dialog ->layout' now discard dialog
  items that have <-displayed: @off.

* Added: `char_array <-delete_prefix'

* Fixed drawing line of text_item 1 pixel outside the area.

[VERSION 4.6.6]

* Fixed generation of .../xpce/src/files to include pce-inline.o, itf-C.o
  and gnu-getdate.o.  This should make the LispWorks installation work again.

* checkpce/0: Added checking whether all forward declarations of types
  are actually backup-up by a class-definition or an autoload definition
  for the class.  Also, if this is not the case the system won't crash
  anymore while accessing the unresolved type.

* Fixed ClassHierarchy-tool `Expand Tree': recent class reorganisation
  defines that `class <-sub_classes' either fails or returns a chain.
  In older versions an empty chain was returned.

* Made first argument of `text_item ->initialise' optional.  Allows for
  show_key_bindings(text_item) to display the key-binding table for an
  instance of class text_item.

* Added `text ->prefix' to allow for multikey sequences in text_item and
  other non-editor based editing.  ->prefix was delegated to the <-string.
  Using the new meta-key encoding for 8-bit support this resulted in an
  error when ESC was typed to a text_item.

* Modified FontViewer demo to display all characters of a character-set.

* Added quick hack to allow for handling 8-bit input (so we can handle
  full ISO-Latin-1 character sets): Meta-key no longer generates event-codes
  <value+128>, but event-codes <value+65536>.  They key_binding table
  `insert' maps the entries 128..255 onto ->insert_self.

  COMPATIBILITY: event-handlers using numeric values to specify
  meta-<key> will no longer work.  Please replace such specifications
  by symbolic ones:

	  handler('M-c', message(...))

  handles meta-c.  In most cases class key_binding provides a better
  replacement of the out-dated handler class.  Code using key_binding
  objects is fully compatible.

* Added library-file prolog/lib/pce_font_item.pl implementing class
  font_item: a compound-dialog-item for selecting fonts.  See comments
  in the file.  Class font_item is now used by PceDraw too.

* Fixed memory-leak in handling functions: executing functions left a
  reference, protecting functions for the garbage-collector after they
  had been evaluated.

* Fixed button recompute when changing <->popup on a displayed button.

* Added PostScript generation for class text when ->margin is active.

* Added `menu->sort' to sort the list of menu-items and update the
  menu afterwards.

* Fixed rounding in `text ->length' to ensure the text can actually hold
  the requested number of `ex'es.  This also fixes short text_items.

* Fixed *serious* bug in `object <-clone'.  This bug appears on variables
  that have a `named' type that represents a class.  The clone and original
  will share the value of such slots and the reference-count will not be
  maintained correctly.

* GCC-2.5.x/SunOs-4.1.x: Fixed declarations for strtod().

* Fixed: slider->redraw (OpenLook style): was drawing 1 pixel outside the
  area.  Only a problem when moving sliders.  Also fixed sliders which
  range includes negative values and ensured proper update on changing
  various slider attributes.

* Fixed: `device ->layout_dialog': offset problem if the left-side of the
  device was not the origin of the window.

* Added `menu_item ->value: value, [label]'.  Changes value *and* label,
  just like ->initialise.  COMPATIBILITY: changing the value now also
  changes the label!

* Fixed superfluous redraw when displaying text_item objects.  Notably
  speed-up of making dialog windows.

[VERSION 4.6.5]

* Fixed area computation of class menu.  Only caused problems for
  overlapping dialog-items.

* Fixed: `menu->kind: cycle' with `menu <-look: open_look' now switches
  the <-pen to 0.

* Fixed: `button ->default_button' to force redraw on change.

* Added: `figure ->{border,radius,shadow}' to manipulate the outline of
  the figure.

* Modified `device ->advance' (controlling the caret notably in dialog
  windows) to exploit the device hierarchy.

* Fix class list_browser default-size: the default size of a list-browser
  depended on resizing other list-browsers.

* PceEmacs: fixed trapping the `Browse' menu when trying to find a
  non-existing tag (emacs_language_mode ->find_tag).

* Added `dialog_item ->name' to update <-name and recompute the default
  label.  This method calls `dialog_item <-label_name' to compute the
  default label.

* Modified object->send_vector and object <-get_vector: attempt to convert
  vector argument (Allows for passing in functions).

* Redesign of object-initialisation:

	- Replaced `variable <-initial_value' by `variable <-alloc_value' and
	  `variable <-init_function'.
	- `object ->initialise' now initialises variables and resources
	- Added type := initial_value syntax to Prolog class parser.

  NOTE: the functionality of these things are still subject to further
  changes.  The aim of these changes is to simplify object-creation and
  to make initial and default values explicit (i.e. move them from the
  code level to the meta-level).

* Cloning: set clone_style of `behaviour <-context' to `reference' and from
  class type to `none'.  This patch is necessary for the experiental
  class-template stuff.

* Fixed `event <-inside_subwindows' (X11 error when the pointer was not
  over an XPCE window).  Fixed drap_and_drop_gesture error message.

* `@pce ->syntax': realises all classes before modifying the syntax.
  This patch is necessary for the LISP interfaces.

[VERSION 4.6.4]

* Allow list_browser <-dict to be @nil (i.e. have a browser without
  an associated dict.  `Dict ->free' may now be invoked also if the
  dict is displayed in a browser (used to crash). [sorry, this patch
  didn't make it in the Linux version yet].

* Added `Mailing List' option to the file menu of the online manuals
  for (un)subscribing to the mailing list.

* Added `chain ->nth0' and `chain ->nth1'.  Fixed description of
  (outdated) `chain ->current' method.

* Version 0.2beta release of the C++ interface:
	- Added 'pceloadc++'/[1,2] in prolog/boot/pce_pl.pl
	- Added pl/src/pl-crt0.c: incremental-linking `crt0.o'
	- Added pl/src/mangle.c: mangle C++ __CTOR_LIST__ and friends to
	  avoid multiple definition conflicts when linking C++ code with
	  global constructors.
	- Changed linker-flags for SWI-Prolog to drop -r -static (linux)
	- Changed @pce<-machine to hold the complete machine description
	- Added ..../xpce/include: C++ include files and friends
	- Tested on: SunOs-4.1.3/g++-2.5.4/make/gnu-m4
		     Linux-0.99.13/g++-2.4.5/gnu-make/gnu-m4
 	- Documentation: .../xpce/man/C++/*
			 ftp.swi.psy.uva.nl:/pub/linux/doc/C++/*
	- Demos: .../xpce/C++/demo
	- Skeleton Makefile: .../xpce/C++/demo/Makefile

* Added `function ->_name_reference' to allow for renaming functions
  rather than the thing they point too.

* Documented `chain ->move_before' and `->move_after'.

* [INTERFACE].  Added pceReInitialise(int argc, char *argv[]).  Languages
  that create a saved state should call pceInitialise() as before when
  the state is created and pceReInitialise() after a saved-state is
  reloaded.  Needed for interfacing to plain C++.

* Fixed `@pce ->bench' for invokation-style `invoke'; did not actually
  call the code n times ...

* Fixed memory-leak when invoking a host-defined vararg method.  Also
  realised speedup of this by added special-purpose creation/destruction
  functions for the code_vector object used to pass the argument-vector.

* Added `@pce <-method_calls' (statistics).

* Changed `regex ->for_all' to accept (optional) `from' and `to' arguments
  to substitute in range.

* Fixed creating example cards in the online manual,

* Added `directory <-file'.

[VERSION 4.6.3]

* Integrated SGI/IRIX-4.0.5F port (using gcc-2.4.5) from Fred Kwakkel:
  Renamed the irix md and makefiles to conform the new naming schema,
  added pl/src/Makefile-sgi-irix-4 and fixed ioctl() problem in
  src/unx-process.c

* Added `variable <->initial_value: any|function' to initialise slots
  automatically.  This feature is currently only used by the C++ class
  definition interface.

* Added class `create' to create objects using functions (i.e. as part of
  an (compound) PCE code object).

* Fixed `device <->{position,x,y}' to ->compute the device first.
  Undisplayed devices (also class figure) yielded wrong results.

* Fixed `window ->catch_all' to take care of frame-defined methods when
  there is a <-window_decorator, but no frame yet.

* Fixed type of `device ->resize'.

* Fixed `expression <-value'.  Errors (failing functions) were not reported
  and caused all subsequent calls to this method to fail.  For error-reporting
  on functions, the method `function ->_error' is added.  Corresponding
  changes to the internal function errorPce() and the arguments of
  `error ->display'.

* Implemented pre-alpha C++ interface.

* Made creation of built-in classes dynamic.  See `class <->realised'.  As
  a consequence the start-up time is reduced for host-languages that cannot
  create a saved state *after* initialising xpce.  Initial memory consumption
  is reduced from about 1 MB to 0.5 MB.


* Added support for full 8-bit character sets: modified all char values to
  be unsigned using gcc's -funsigned-char.  Fixed gnu-regex.c for proper
  extending the sign.  Fixed dimension computations in xwn-draw.c for
  incomplete fonts (also speedup of font stuff).


[VERSION 4.6.2]

* Switch off Prolog tracer (actually SWI-Prolog, but mostly relevant to XPCE)
  before calling Prolog's on_halt() hooks to avoid recursive tracing while
  trying to get out.

* Fixed source-location registration so that for Prolog-defined classes
  <-source now always works properly.

* Fixed PceEmacs `emacs_buffer ->revert' and added revert to the file menu.

* Moved geometry-management of the classes browser, view, editor and
  list_browser to use the ->request_geometry mechanism.  This should
  remove inconsistent handling of various geometry request methods.
  These objects (like any other object) may be addressed in pixel
  units using `graphical ->do_set'.

  COMPATIBILITY: Old code that used broken methods may now result in
  very large windows.  Width and height of these classes is now always
  represented in character units!

* Added `@display <->quick_and_dirty' to choose between speed and correct
  drawing.

* Fixed changing the busy_cursor on an existing frame.  See
  `frame ->busy_cursor'.  Detected block_events=@off argument not to
  work.  This may turn out to be practically impossible using X11.


VERSION 4.6.1

* Fixed `frame <-return' when the return value is an integer.

* Added `class ->record_instances' and `class <-instances' to keep track
  of created instances.

* Added `frame ->busy_cursor' to switch the cursor temporary for all
  subwindows of a frame and `display ->busy_cursor' to do the same for
  all PCE frames in a display.  The latter is automatically used to switch
  the cursor to a watch while clicks and popups are executed.  See
  `click_gesture ->terminate' and `popup ->execute'.

* Fixed `graphical <-postscript' for not-displayed graphical objects by
  invoking `graphical ->compute' to the graphical before generating
  PostScript.

* Moved the automatic layout-system of class dialog to the
  super-class device.  Effectively this adds `device ->append_dialog_item'
  and `device ->layout_dialog' to the system, enabling `sub-dialogues'.

* Added graphicals to the automatic layout system of dialog windows.
  See `graphical ->above', etc.

* Added `@pce <-save_version' to get the version number used to tag
  saved-objects (was already documented but not implemented).

VERSION 4.6.0

* Fixed bug in tracer that causes a segmentation fault if XPCE is in
  trace-mode and the selector of a method is a function object.  The
  latter is used by the ClassBrowser tool, so running the classbrowser
  when XPCE was is tracemode could cause a crash.

* Fixed and documented `event <-inside_sub_window' to take care of
  window_decorators properly.

* Fixed undefined method (<-create_member) in PredicateBrowser.

* Fixed `window ->event': if the window had a <-popup, this was shown
  instead of posting the right_down event to the contents first.

* Fixed `fragment <-sub'.

* Fixed `window_decorator ->request_geometry' to take care of the <-tile.

* Fixed `window ->create' to take care of the <-pen properly (causes problems
  in the unlikely case that the window geometry is not changed while the
  frame is created).

* Changed printf()'s in `file <-object' into proper PCE errors:
  failed_to_convert and bad_slot_value.   This allows for silent loading
  of old (incompatible) object structures.

* Added menu-bar to PceEmacs windows to make them usable for novice
  users.

* Fixed `window ->normalise' when argument was a chain of objects that
  *can* be converted into graphicals (like node objects).

* Changed VisualHierarchy to normalise on expanded fields.  This avoids a
  lot of scrolling.

* Fixed drawing boxes for pen = 0, radius > 0 and fill_pattern != @nil.

* Added `list_browser ->reset' to restore the cursor after a crash.

* Fixed `menu_item <-default_label' when a graphical object is supplied.
  (not-closed argument list).

* Fixed menu_bar <-member to check for the `popup<-name' instead of the
  (translated) <-label of the popup menu.  This ensures the popup can
  be requested with the same name as it was created.

* Added `bitmap ->unlink' for proper unlinking of the <-image.  Fixes
  (mostly harmless :-) dangling references from images.

* Fixed error generated by exec() in class process to cannot_start_process.

* `key_binding' now checks type of the return value of <-interactive
  argument and generates a no_argument error in case of mismatch.  Avoids
  trapping the PCE tracer when an incorrect argument is returned.

* `text_item ->complete' now verifies the event_id to be a printable
  character before calling ->insert_self on the object if completion
  is not possible.  Avoids trapping the tracer when ->complete is
  bound to an event that cannot be inserted in the text.

* Implemented fully transparent interface to the X11 selection server.
  See `display <-selection' and `display ->selection_owner' for details.
  Modified class editor to use these (see prolog/boot/pce_editor.pl).
  Also modified the Inspector and VisualHierarchy tools to publish
  the selected object using the X-selection server.
  This avoids the need to redefine selection handling in other X11
  applications for proper interaction with XPCE.

* Implemented OpenWindow compatible look-and-feel:

	- Added Pce.OpenLook to the distribution.  This file may be
	  appended to Pce or ~/.Xdefaults to use XPCE in OpenLook
	  mode.
	- Added `button <->popup_image' to indicate presence of popup
	- `dialog_item <->alignment' replaces `dialog_item <->align_in_column'
	- Added `dialog_item <->label_format' to align the labels
	- Added DialogItem.label_suffix to ensure a label suffix (:)
	- Added `dialog_item <->look' for general switches on look-and-feel
	- Added `popup <->margin' to modify the popup layout.
	- Redesign of class menu_bar to use buttons
	- Changed class scroll_bar redraw and event handling.  Added
	  scroll-unit `line', also to class window, editor and list_browser.
	  Switches on the <-look attribute.
	- Fixed pen != 0 in menus
	- `menu ->kind: marked and choice' both map on feedback: box
	  if <-look is open_look.

* Added <->shadow to class box and class ellipse.  Added `graphical
  ->initialise_new_slot' to initialise the shadow slot of the new
  classes with 0.  Incremented SAVE_VERSION.  Added shadow to PceDraw
  and the PostScript generation methods for box and ellipse.

* Added `menu ->feedback' to switch the feedback style of existing
  menus.

* Fixed `real <-convert' for conversion from textual values.  Bug
  (returning wrong value) probably only existed on SunOs 4.x.x due
  to missing prototype.

* Class timer now first executes the message before setting up the next
  interval.  This avoids the system to `hang' due to to many timer events.

* Added `pce <-answer_stack_size'.  Changed the implementation of the
  answer-stack to reduce garbage on this stack.  Avoids quadradic
  (time) behaviour on some types of loops.   Performance problem is
  completely solved.  There is still a little garbage left on this stack.

* Added breakpce/1 and nobreakpce/1 to break on PCE methods like
  tracepce/1 and notracepce/1.

* Fixed `frame <-postscript' if the frame is partially outside the
  screen.

* Added in prolog/lib:
	- Overview		Short overview of the library
	- tmw_geometry_box.pl
	- twm_resize_button.pl
	- subframe.pl		Define frames-in-windows

* Fixed new(X, real(0)) crash as reported by Ben Rabau (ISL).  For this
  purpose I added the interface function pceToCReference() that is
  similar to pceToC(), but only works on true PCE objects and always
  returns a PCE_ASSOC or PCE_REFERENCE.  Fixed pl_new() to use this
  function.

* The geometry-changing gestures (move, resize, move_outline and
  resize_outline) now use `graphical ->do_set' to bypass the new request
  branch PCE's geometry management.

* Added: display ->draw_in to draw directly on the root window of the
  display and display ->grab_server to temporary grab the server. May
  be used by dragging gestures who'se operation is not window-bound.

* Added Pce.Window.cursor resource for specifying the default window
  cursor (top_left_arrow).

* Fixed size of help window in PceDraw.

* Fixed `vector ->shift' garbage collection interaction.  This (internal)
  method caused problems with `editor ->kill' and friends.

* Added switch_to_buffer (\C-xb) to PceEmacs fundamental mode.

* Added the `type <->kind: value_set'.  Allows a type to define a member
  of a set of object.  The set may be generated by a function object.

* Changed `key_binding <->receiver' relation to use hyper objects instead
  of slot references.  This ensures proper behaviour on deleting the
  receiver of the key_binding (keybindings are reusable and should thus
  be preserved).  The inconsistency reported before by checkpce/0 was
  harmless.

* Fixed destruction of windows.

* Fixed `Quit' in online manual, Visual Hierarchy Tool and Inspector Tool.
  All tools can now freely be created/quited, recreated, etc.

* The methods `graphical ->device' and `graphical ->displayed' are now
  called internally as true methods, thus allowing the user to redefine
  these methods.  See class graphical.  The message passing system has
  been enhanced with a `Quick And Dirty' version of the send() operation,
  that checks quickly whether a method has been redefined and bypasses
  most checks if this is not the case.  QAD-send() has 1/3 of the
  overhead of a normal send if nothing has been redefined.

* Moved virtual method `window ->modified_item' to class device.  Fixes
  displaying dialog items on generic devices.  Bug reported by Ben Rabau.

* Modified send() not to report a freed object if the selector is `free'.

* Major redesign of class window and cleanup of scrollbars.

	- Introduction of class window_decoration: a window holding
	  the scrollbars and window-level labels.  This turns these
	  into ordinary graphical object, getting rid of a lot of
	  specialised code and update bugs.  Allows redefinition
	  of many things from the host language instead of only from C.

	  *COMPATIBILITY*
	  The code is as good as possible compatible.  However:

	  `window <->radius' is gone as the drawing plane now uses
	  the X11 window border and X11 does not support windows with
	  rounded corner (at least not as I want to have them).

	  `Window <->display_position' and `Window <->display_size'
	  have gone.  These (rarely used) methods are replaced by the
	  normal geometry-management.

	  `Window <-area' now reflects the area of the window relative
	  to the super-window or frame.  The new variable `window <-
	  bounding_box' now reflects the bounding box of the displayed
	  graphical objects.

	  There are various subtle changes.  All my testing applications
	  however run without modification.  Please report compatibility
	  problems.

	- Split geometry management for class graphical into a
	  request and action branch to allow for negotiation with
	  other objects.  See `graphical ->request_geometry' for
	  details.  No compatibility issues.

	- Cleaned the scroll_bar code, removing a lot of old and
	  no-longer used stuff.  Fixed the update code to avoid
	  calls to undefined behaviour and added a more efficient
	  schema.  See `scroll_bar ->compute' and
	  `window ->bubble_scrollbar'.

	  Added resource `Pce.ScrollBar.placement: name' which allows
	  the user to place the scrollbars right,left,top,bottom of the
	  window.

	  No compatibility issues.

	- Turned class window into a true graphical class.  Now allows
	  for `windows on windows'.

	  *COMPATIBILITY*
	  `window <-area' now reflects the area of the window relative
	  to the parent (window or frame).  `window <-bounding_box'
	  reflects what the old `window <-area' did: the bouding box
	  of the displayed graphicals in the window coordinate system.

	  `Window <->display_size', `window <->display_position' and
	  `Window <-display_area' have gone.  The normal methods
	  to handle graphical geometry now work properly.  Old bugs
	  like `window ->height' and other graphical window manipulations
	  not working properly should be fixed now.


* Fixed bug in trapping existing object references.  Added library
  pce_renew which allows you to redefine the behaviour of new/2 on
  an attempt to redefine an existing reference.  Fixed related exception
  generation.  The predicate pce_renew/1 allows you to preset how
  existing references are handled: trace, free, rename, ask.

* Fixed bug in PceDraw yielding undefined <-mode behaviour

* Remove limit (100) of number of windows in a frame

* Renamed text_item <-print_name into <-print_name_of_value.  Overriding
  `object <-print_name' with different intention leads to poor error
  reporting on text_item objects.  Applications	that redefine this method
  should be changed.

* Added resource Pce.DrawCanvas.size resource to PceDraw which allows
  the user to specify the default size of the canvas (drawing area).

* Changed type of 2nd argument of `dialog ->append' from [name] to
  [{below,right,next_row}] and updated documentation.  No functional
  changes.


VERSION 4.5.12

* Added: class regex (regular) expression now operates on fragment objects
  too.	To support this, `fragment <-sub' is added.

* Fixed memory leak in incremental garbage collector.

* Added @editor_recogniser hook in `editor ->event', exploited by the
  new button-bindings for PCE editors defined in prolog/boot/pce_editor.pl
  Both selection and caret manipulation may now be used without modifiers.

* Fixed multiple kill-commands in editors.

* Fixed extending the selection to word boundaries in editors using double
  click to be compatible to other X applications.

* When switching to a non-existing file in PceEmacs, this file is no longer
  flagged modified.  Avoids save for accidently created buffers.

* Changed error no_x_server to `fatal' to avoid a loop in reporting the
  error.  Fixes error reporting when contacting the X-server fails.

* Improved saved-object compatibility: incremented save-version number,
  changed message on incompatible versions to use the error object
  new_save_version (default ignored), added `path ->initialise_new_slot'
  to fix `path <-offset', changed text load function to insert wrap and
  margin slots.  Fixed return type of `file <-object' to return functions
  too.

* Added `normalise' argument to `frame ->open', `window ->open',
  `frame <-confirm' and `window <-confirm'.  When @on, the window
  is repositioned to fit entirely on the screen.  Used by the
  text_item completer object to ensure the browser with possible completions
  is displayed entirely on the screen.

* PceDraw: fixed resizing selections (dangling resize boxes problem).

* Added: `text_buffer ->attach' and `text_buffer ->detach'.  These methods
  are called to update the `text_buffer <-editors' chain and may be redefined
  to monitor attach/delete of editors.

* PceEmacs miniwindow now completes on TAB too.

* Actually implemented the `sticky' indication at the bottom of PceEmacs
  windows.  PceEmacs now will reuse any `non-sticky' window for displaying
  a new file.  There are two pools of buffers: `file' and `other'.
  Tell me whether you like it!

* Fixed `Class Hierarchy' tool for the added `device <-find': now class
  tree inherits <-find from device instead of delegating to its <-root
  node object.

* Fixed xpce/make-bin-tape and xpce/install to properly handle the
  SWI-Prolog startup and include file.

* Added `kind' `progress' and `done' to the generic reporting mechanism
  realised by `object ->report', `visual ->report' and various other
  classes.  Provides a generic and easy interface to indicate actions
  such as loading a file to the application user.  Updated the manual
  tools to use this method.

* Added Prolog library "pce_drag_and_drop.pl", which implements the
  class drag_and_drop_gesture.

* PCE now allows for having click- and `drag' (move, connect, resize)
  gestures on the same button.  New methods for this:
  `click_gesture ->cancel', `gesture ->cancel', `event <-distance',
  `click_gesture <->max_drag_distance'.  Modified: `click_gesture ->drag'.
  By default, a click_gesture cancels after the user dragged more than
  5 pixels.

* Fixed `type <-value_set' with `type <-kind: alias'.  Used by
  `text_item ->complete'.

* Fixed trapping X11 events by class window to garbage collect the
  event after it has been processed.

* Fixed `frame ->return' `frame <-confirm' couple for proper handling
  of the return value by the incremental garbage collector.

* Fixed `image ->draw_in' to properly restore the position of the
  graphical when a position was specified.  Now uses `graphical <->set'
  rather than `graphical <->position' for moving the graphical.  Also
  fixed when the graphical is currently displayed on a device with
  a `device <-format' attached.

* Added anonymous cursor objects that can be destroyed when `cursor <-name'
  is @nil.

* Changed `class ->clone_style_variable' and related class methods
  to accept integer slot identifier too.

* Added `device <-find' for locating graphicals similar to the
  event dispatching system.

* Added `event <-inside_sub_window' for locating events on frames and
  windows in frames.

* Changed `graphical ->toggle_select' and `device ->selection' to
  invoke `graphical ->selected' using a message, so this message may
  be redefined.

VERSION 4.5.11

[Changelog before version 4.5.11 was not maintained carefully.  Changes
that introduce major new functionality and/or incompatibilities may be
found in the release-notes directory]
